/* Application.c generated by valac 0.56.17, the Vala compiler
 * generated from Application.vala, do not modify */

/* Application.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <vte/vte.h>

#define TERMINAL_GETTEXT_PACKAGE "blackbox"
#define TERMINAL_LOCALEDIR "/usr/share/locale"
#define TERMINAL_APP_NAME "BlackBox"
#define TERMINAL_VERSION "0.14.0"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_APPLICATION (terminal_application_get_type ())
#define TERMINAL_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplication))
#define TERMINAL_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))
#define TERMINAL_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_APPLICATION))
#define TERMINAL_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_APPLICATION, TerminalApplicationClass))

typedef struct _TerminalApplication TerminalApplication;
typedef struct _TerminalApplicationClass TerminalApplicationClass;
typedef struct _TerminalApplicationPrivate TerminalApplicationPrivate;
enum  {
	TERMINAL_APPLICATION_0_PROPERTY,
	TERMINAL_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* terminal_application_properties[TERMINAL_APPLICATION_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);

#define TERMINAL_TYPE_KEYMAP (terminal_keymap_get_type ())
#define TERMINAL_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymap))
#define TERMINAL_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))
#define TERMINAL_IS_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_IS_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_KEYMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))

typedef struct _TerminalKeymap TerminalKeymap;
typedef struct _TerminalKeymapClass TerminalKeymapClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_WINDOW, TerminalWindowClass))
#define TERMINAL_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_WINDOW))
#define TERMINAL_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;

#define TERMINAL_TYPE_COMMAND_LINE_OPTIONS (terminal_command_line_options_get_type ())
typedef struct _TerminalCommandLineOptions TerminalCommandLineOptions;

#define TERMINAL_TYPE_TERMINAL (terminal_terminal_get_type ())
#define TERMINAL_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminal))
#define TERMINAL_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))
#define TERMINAL_IS_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_IS_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_TERMINAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))

typedef struct _TerminalTerminal TerminalTerminal;
typedef struct _TerminalTerminalClass TerminalTerminalClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TerminalApplication {
	AdwApplication parent_instance;
	TerminalApplicationPrivate * priv;
};

struct _TerminalApplicationClass {
	AdwApplicationClass parent_class;
};

struct _TerminalApplicationPrivate {
	GActionEntry* ACTIONS;
	gint ACTIONS_length1;
	gint _ACTIONS_size_;
};

struct _TerminalCommandLineOptions {
	gchar* command;
	gchar* current_working_dir;
	gboolean version;
	gboolean help;
};

static gint TerminalApplication_private_offset;
static gpointer terminal_application_parent_class = NULL;

VALA_EXTERN GType terminal_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalApplication, g_object_unref)
static void terminal_application_on_focus_next_tab (TerminalApplication* self);
static void _terminal_application_on_focus_next_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void terminal_application_on_focus_previous_tab (TerminalApplication* self);
static void _terminal_application_on_focus_previous_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void terminal_application_on_new_window (TerminalApplication* self);
static void _terminal_application_on_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void terminal_application_on_about (TerminalApplication* self);
static void _terminal_application_on_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
VALA_EXTERN TerminalApplication* terminal_application_new (void);
VALA_EXTERN TerminalApplication* terminal_application_construct (GType object_type);
VALA_EXTERN GType terminal_keymap_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalKeymap, g_object_unref)
VALA_EXTERN TerminalKeymap* terminal_keymap_get_default (void);
VALA_EXTERN void terminal_keymap_apply (TerminalKeymap* self,
                            GtkApplication* app);
static void terminal_application_real_activate (GApplication* base);
VALA_EXTERN GType terminal_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalWindow, g_object_unref)
VALA_EXTERN TerminalWindow* terminal_window_new (GtkApplication* app,
                                     const gchar* command,
                                     const gchar* cwd,
                                     gboolean skip_initial_tab);
VALA_EXTERN TerminalWindow* terminal_window_construct (GType object_type,
                                           GtkApplication* app,
                                           const gchar* command,
                                           const gchar* cwd,
                                           gboolean skip_initial_tab);
static gint terminal_application_real_command_line (GApplication* base,
                                             GApplicationCommandLine* cmd);
VALA_EXTERN GType terminal_command_line_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalCommandLineOptions* terminal_command_line_options_dup (const TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_free (TerminalCommandLineOptions* self);
VALA_EXTERN void terminal_command_line_options_copy (const TerminalCommandLineOptions* self,
                                         TerminalCommandLineOptions* dest);
VALA_EXTERN void terminal_command_line_options_destroy (TerminalCommandLineOptions* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TerminalCommandLineOptions, terminal_command_line_options_destroy)
VALA_EXTERN gboolean terminal_command_line_parse_command_line (GApplicationCommandLine* cmd,
                                                   TerminalCommandLineOptions* options);
VALA_EXTERN AdwAboutWindow* terminal_create_about_dialog (void);
VALA_EXTERN GType terminal_terminal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalTerminal, g_object_unref)
VALA_EXTERN TerminalTerminal* terminal_window_get_active_terminal (TerminalWindow* self);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal);
VALA_EXTERN void terminal_window_focus_next_tab (TerminalWindow* self);
VALA_EXTERN void terminal_window_focus_previous_tab (TerminalWindow* self);
static void terminal_application_finalize (GObject * obj);
static GType terminal_application_get_type_once (void);

static inline gpointer
terminal_application_get_instance_private (TerminalApplication* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalApplication_private_offset);
}

static void
_terminal_application_on_focus_next_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
	terminal_application_on_focus_next_tab ((TerminalApplication*) self);
}

static void
_terminal_application_on_focus_previous_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
	terminal_application_on_focus_previous_tab ((TerminalApplication*) self);
}

static void
_terminal_application_on_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	terminal_application_on_new_window ((TerminalApplication*) self);
}

static void
_terminal_application_on_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
	terminal_application_on_about ((TerminalApplication*) self);
}

TerminalApplication*
terminal_application_construct (GType object_type)
{
	TerminalApplication * self = NULL;
	GActionEntry* _tmp0_;
	gint _tmp0__length1;
	TerminalKeymap* keymap = NULL;
	TerminalKeymap* _tmp1_;
	self = (TerminalApplication*) g_object_new (object_type, "application-id", "com.raggesilver.BlackBox", "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
	setlocale (LC_ALL, "");
	textdomain (TERMINAL_GETTEXT_PACKAGE);
	bindtextdomain (TERMINAL_GETTEXT_PACKAGE, TERMINAL_LOCALEDIR);
	bind_textdomain_codeset (TERMINAL_GETTEXT_PACKAGE, "UTF-8");
	_tmp0_ = self->priv->ACTIONS;
	_tmp0__length1 = self->priv->ACTIONS_length1;
	g_action_map_add_action_entries ((GActionMap*) self, _tmp0_, (gint) _tmp0__length1, self);
	_tmp1_ = terminal_keymap_get_default ();
	keymap = _tmp1_;
	terminal_keymap_apply (keymap, (GtkApplication*) self);
	_g_object_unref0 (keymap);
	return self;
}

TerminalApplication*
terminal_application_new (void)
{
	return terminal_application_construct (TERMINAL_TYPE_APPLICATION);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
terminal_application_real_activate (GApplication* base)
{
	TerminalApplication * self;
	GList* _tmp0_;
	TerminalWindow* _tmp4_;
	TerminalWindow* _tmp5_;
	self = (TerminalApplication*) base;
	_tmp0_ = gtk_application_get_windows ((GtkApplication*) self);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp0_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			GtkWindow* _tmp1_;
			GtkWindow* window = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWindow*) window_it->data);
			window = _tmp1_;
			{
				GtkWindow* _tmp2_;
				_tmp2_ = window;
				if (TERMINAL_IS_WINDOW (_tmp2_)) {
					GtkWindow* _tmp3_;
					_tmp3_ = window;
					gtk_window_present (_tmp3_);
					_g_object_unref0 (window);
					return;
				}
				_g_object_unref0 (window);
			}
		}
	}
	_tmp4_ = terminal_window_new ((GtkApplication*) self, NULL, NULL, FALSE);
	g_object_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	gtk_widget_show ((GtkWidget*) _tmp5_);
	_g_object_unref0 (_tmp5_);
}

static gint
terminal_application_real_command_line (GApplication* base,
                                        GApplicationCommandLine* cmd)
{
	TerminalApplication * self;
	TerminalCommandLineOptions options = {0};
	TerminalCommandLineOptions _tmp0_ = {0};
	gboolean _tmp1_;
	gint result;
	self = (TerminalApplication*) base;
	g_return_val_if_fail (cmd != NULL, 0);
	g_application_hold ((GApplication*) self);
	_tmp1_ = terminal_command_line_parse_command_line (cmd, &_tmp0_);
	terminal_command_line_options_destroy (&options);
	options = _tmp0_;
	if (!_tmp1_) {
		g_application_release ((GApplication*) self);
		result = -1;
		terminal_command_line_options_destroy (&options);
		return result;
	} else {
		TerminalCommandLineOptions _tmp2_;
		_tmp2_ = options;
		if (_tmp2_.help) {
		} else {
			TerminalCommandLineOptions _tmp3_;
			_tmp3_ = options;
			if (_tmp3_.version) {
				g_application_command_line_print (cmd, "%s version %s%s\n", TERMINAL_APP_NAME, TERMINAL_VERSION, "");
			} else {
				TerminalCommandLineOptions _tmp4_;
				const gchar* _tmp5_;
				TerminalCommandLineOptions _tmp6_;
				const gchar* _tmp7_;
				TerminalWindow* _tmp8_;
				TerminalWindow* _tmp9_;
				_tmp4_ = options;
				_tmp5_ = _tmp4_.command;
				_tmp6_ = options;
				_tmp7_ = _tmp6_.current_working_dir;
				_tmp8_ = terminal_window_new ((GtkApplication*) self, _tmp5_, _tmp7_, FALSE);
				g_object_ref_sink (_tmp8_);
				_tmp9_ = _tmp8_;
				gtk_widget_show ((GtkWidget*) _tmp9_);
				_g_object_unref0 (_tmp9_);
			}
		}
	}
	g_application_release ((GApplication*) self);
	result = 0;
	terminal_command_line_options_destroy (&options);
	return result;
}

static void
terminal_application_on_about (TerminalApplication* self)
{
	GtkWindow* win = NULL;
	AdwAboutWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = terminal_create_about_dialog ();
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	win = _tmp1_;
	_tmp2_ = gtk_application_get_active_window ((GtkApplication*) self);
	gtk_window_set_transient_for (win, _tmp2_);
	gtk_widget_show ((GtkWidget*) win);
	_g_object_unref0 (win);
}

static void
terminal_application_on_new_window (TerminalApplication* self)
{
	GtkWindow* w = NULL;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	TerminalTerminal* _tmp2_ = NULL;
	GtkWindow* _tmp3_;
	TerminalTerminal* active_terminal = NULL;
	TerminalTerminal* _tmp7_;
	gchar* cwd = NULL;
	gchar* _tmp8_;
	TerminalWindow* _tmp9_;
	TerminalWindow* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_application_get_active_window ((GtkApplication*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	w = _tmp1_;
	_tmp3_ = w;
	if (TERMINAL_IS_WINDOW (_tmp3_)) {
		GtkWindow* _tmp4_;
		TerminalTerminal* _tmp5_;
		TerminalTerminal* _tmp6_;
		_tmp4_ = w;
		_tmp5_ = terminal_window_get_active_terminal ((TerminalWindow*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_;
	} else {
		_tmp2_ = NULL;
	}
	_tmp7_ = _g_object_ref0 (_tmp2_);
	active_terminal = _tmp7_;
	_tmp8_ = terminal_terminal_get_current_working_directory_for_new_session (active_terminal);
	cwd = _tmp8_;
	_tmp9_ = terminal_window_new ((GtkApplication*) self, NULL, cwd, FALSE);
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	gtk_widget_show ((GtkWidget*) _tmp10_);
	_g_object_unref0 (_tmp10_);
	_g_free0 (cwd);
	_g_object_unref0 (active_terminal);
	_g_object_unref0 (w);
}

static void
terminal_application_on_focus_next_tab (TerminalApplication* self)
{
	TerminalWindow* _tmp0_ = NULL;
	GtkWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = gtk_application_get_active_window ((GtkApplication*) self);
	_tmp0_ = TERMINAL_IS_WINDOW (_tmp1_) ? ((TerminalWindow*) _tmp1_) : NULL;
	if (_tmp0_ != NULL) {
		terminal_window_focus_next_tab (_tmp0_);
	}
}

static void
terminal_application_on_focus_previous_tab (TerminalApplication* self)
{
	TerminalWindow* _tmp0_ = NULL;
	GtkWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = gtk_application_get_active_window ((GtkApplication*) self);
	_tmp0_ = TERMINAL_IS_WINDOW (_tmp1_) ? ((TerminalWindow*) _tmp1_) : NULL;
	if (_tmp0_ != NULL) {
		terminal_window_focus_previous_tab (_tmp0_);
	}
}

static void
terminal_application_class_init (TerminalApplicationClass * klass,
                                 gpointer klass_data)
{
	terminal_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminalApplication_private_offset);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) terminal_application_real_activate;
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) terminal_application_real_command_line;
	G_OBJECT_CLASS (klass)->finalize = terminal_application_finalize;
}

static void
terminal_application_instance_init (TerminalApplication * self,
                                    gpointer klass)
{
	GActionEntry _tmp0_ = {0};
	GActionEntry _tmp1_ = {0};
	GActionEntry _tmp2_ = {0};
	GActionEntry _tmp3_ = {0};
	GActionEntry* _tmp4_;
	self->priv = terminal_application_get_instance_private (self);
	memset (&_tmp0_, 0, sizeof (GActionEntry));
	_tmp0_.name = "focus-next-tab";
	_tmp0_.activate = _terminal_application_on_focus_next_tab_gsimple_action_activate_callback;
	memset (&_tmp1_, 0, sizeof (GActionEntry));
	_tmp1_.name = "focus-previous-tab";
	_tmp1_.activate = _terminal_application_on_focus_previous_tab_gsimple_action_activate_callback;
	memset (&_tmp2_, 0, sizeof (GActionEntry));
	_tmp2_.name = "new-window";
	_tmp2_.activate = _terminal_application_on_new_window_gsimple_action_activate_callback;
	memset (&_tmp3_, 0, sizeof (GActionEntry));
	_tmp3_.name = "about";
	_tmp3_.activate = _terminal_application_on_about_gsimple_action_activate_callback;
	_tmp4_ = g_new0 (GActionEntry, 4);
	_tmp4_[0] = _tmp0_;
	_tmp4_[1] = _tmp1_;
	_tmp4_[2] = _tmp2_;
	_tmp4_[3] = _tmp3_;
	self->priv->ACTIONS = _tmp4_;
	self->priv->ACTIONS_length1 = 4;
	self->priv->_ACTIONS_size_ = self->priv->ACTIONS_length1;
}

static void
terminal_application_finalize (GObject * obj)
{
	TerminalApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_APPLICATION, TerminalApplication);
	self->priv->ACTIONS = (g_free (self->priv->ACTIONS), NULL);
	G_OBJECT_CLASS (terminal_application_parent_class)->finalize (obj);
}

static GType
terminal_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalApplication), 0, (GInstanceInitFunc) terminal_application_instance_init, NULL };
	GType terminal_application_type_id;
	terminal_application_type_id = g_type_register_static (adw_application_get_type (), "TerminalApplication", &g_define_type_info, 0);
	TerminalApplication_private_offset = g_type_add_instance_private (terminal_application_type_id, sizeof (TerminalApplicationPrivate));
	return terminal_application_type_id;
}

GType
terminal_application_get_type (void)
{
	static volatile gsize terminal_application_type_id__once = 0;
	if (g_once_init_enter (&terminal_application_type_id__once)) {
		GType terminal_application_type_id;
		terminal_application_type_id = terminal_application_get_type_once ();
		g_once_init_leave (&terminal_application_type_id__once, terminal_application_type_id);
	}
	return terminal_application_type_id__once;
}

