/* ProcessWatcher.c generated by valac 0.56.17, the Vala compiler
 * generated from ProcessWatcher.vala, do not modify */

/* ProcessWatcher.vala
 *
 * Copyright 2023 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>

#define TERMINAL_PROCESS_WATCHER_INTERVAL_MS ((guint) 500)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	TERMINAL_PROCESS_CONTEXT_DEFAULT,
	TERMINAL_PROCESS_CONTEXT_ROOT,
	TERMINAL_PROCESS_CONTEXT_SSH
} TerminalProcessContext;

#define TERMINAL_TYPE_PROCESS_CONTEXT (terminal_process_context_get_type ())

#define TERMINAL_TYPE_PROCESS (terminal_process_get_type ())
#define TERMINAL_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS, TerminalProcess))
#define TERMINAL_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS, TerminalProcessClass))
#define TERMINAL_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS))
#define TERMINAL_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS))
#define TERMINAL_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS, TerminalProcessClass))

typedef struct _TerminalProcess TerminalProcess;
typedef struct _TerminalProcessClass TerminalProcessClass;
typedef struct _TerminalProcessPrivate TerminalProcessPrivate;
enum  {
	TERMINAL_PROCESS_0_PROPERTY,
	TERMINAL_PROCESS_TERMINAL_FD_PROPERTY,
	TERMINAL_PROCESS_PID_PROPERTY,
	TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY,
	TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY,
	TERMINAL_PROCESS_ENDED_PROPERTY,
	TERMINAL_PROCESS_CONTEXT_PROPERTY,
	TERMINAL_PROCESS_NUM_PROPERTIES
};
static GParamSpec* terminal_process_properties[TERMINAL_PROCESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	TERMINAL_PROCESS_FOREGROUND_TASK_FINISHED_SIGNAL,
	TERMINAL_PROCESS_NUM_SIGNALS
};
static guint terminal_process_signals[TERMINAL_PROCESS_NUM_SIGNALS] = {0};

#define TERMINAL_TYPE_PROCESS_WATCHER (terminal_process_watcher_get_type ())
#define TERMINAL_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcher))
#define TERMINAL_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))
#define TERMINAL_IS_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_IS_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_PROCESS_WATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))

typedef struct _TerminalProcessWatcher TerminalProcessWatcher;
typedef struct _TerminalProcessWatcherClass TerminalProcessWatcherClass;
typedef struct _TerminalProcessWatcherPrivate TerminalProcessWatcherPrivate;
enum  {
	TERMINAL_PROCESS_WATCHER_0_PROPERTY,
	TERMINAL_PROCESS_WATCHER_NUM_PROPERTIES
};
static GParamSpec* terminal_process_watcher_properties[TERMINAL_PROCESS_WATCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block11Data Block11Data;

struct _TerminalProcess {
	GObject parent_instance;
	TerminalProcessPrivate * priv;
};

struct _TerminalProcessClass {
	GObjectClass parent_class;
};

struct _TerminalProcessPrivate {
	gint _terminal_fd;
	GPid _pid;
	GPid _foreground_pid;
	gchar* _last_foreground_task_command;
	gboolean _ended;
	TerminalProcessContext _context;
};

struct _TerminalProcessWatcher {
	GObject parent_instance;
	TerminalProcessWatcherPrivate * priv;
};

struct _TerminalProcessWatcherClass {
	GObjectClass parent_class;
};

struct _TerminalProcessWatcherPrivate {
	GeeArrayList* process_list;
	GeeArrayList* pending_process_list;
	GRecMutex __lock_pending_process_list;
	gboolean watching;
	GThread* loop_thread;
	GMutex mutex;
};

struct _Block11Data {
	int _ref_count_;
	TerminalProcessWatcher* self;
	TerminalProcess* process;
};

static gint TerminalProcess_private_offset;
static gpointer terminal_process_parent_class = NULL;
static gint TerminalProcessWatcher_private_offset;
static gpointer terminal_process_watcher_parent_class = NULL;
static TerminalProcessWatcher* terminal_process_watcher_instance;
static TerminalProcessWatcher* terminal_process_watcher_instance = NULL;

VALA_EXTERN GType terminal_process_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType terminal_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcess, g_object_unref)
VALA_EXTERN TerminalProcess* terminal_process_new (void);
VALA_EXTERN TerminalProcess* terminal_process_construct (GType object_type);
VALA_EXTERN gint terminal_process_get_terminal_fd (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_terminal_fd (TerminalProcess* self,
                                       gint value);
VALA_EXTERN GPid terminal_process_get_pid (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_pid (TerminalProcess* self,
                               GPid value);
VALA_EXTERN GPid terminal_process_get_foreground_pid (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_foreground_pid (TerminalProcess* self,
                                          GPid value);
VALA_EXTERN const gchar* terminal_process_get_last_foreground_task_command (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_last_foreground_task_command (TerminalProcess* self,
                                                        const gchar* value);
VALA_EXTERN gboolean terminal_process_get_ended (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_ended (TerminalProcess* self,
                                 gboolean value);
VALA_EXTERN TerminalProcessContext terminal_process_get_context (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_context (TerminalProcess* self,
                                   TerminalProcessContext value);
static void terminal_process_finalize (GObject * obj);
static GType terminal_process_get_type_once (void);
static void _vala_terminal_process_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_terminal_process_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
VALA_EXTERN GType terminal_process_watcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcessWatcher, g_object_unref)
static TerminalProcessWatcher* terminal_process_watcher_new (void);
static TerminalProcessWatcher* terminal_process_watcher_construct (GType object_type);
VALA_EXTERN TerminalProcessWatcher* terminal_process_watcher_get_instance (void);
VALA_EXTERN gboolean terminal_process_watcher_watch (TerminalProcessWatcher* self,
                                         TerminalProcess* process);
static void terminal_process_watcher_start_watching (TerminalProcessWatcher* self);
static void terminal_process_watcher_t_watch_loop (TerminalProcessWatcher* self);
static gpointer _terminal_process_watcher_t_watch_loop_gthread_func (gpointer self);
static void terminal_process_watcher_check_process (TerminalProcessWatcher* self,
                                             TerminalProcess* process);
static gboolean terminal_process_watcher_is_process_still_running (TerminalProcessWatcher* self,
                                                            GPid pid);
VALA_EXTERN gchar* terminal_host_or_flatpak_spawn (gchar** argv,
                                       gint argv_length1,
                                       gint* status,
                                       GError** error);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN void terminal_get_foreground_process (gint terminal_fd,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gint terminal_get_foreground_process_finish (GAsyncResult* _res_);
static void ____lambda18_ (Block11Data* _data11_,
                    GObject* _,
                    GAsyncResult* res);
VALA_EXTERN gchar* terminal_get_process_cmdline (gint pid);
static void _____lambda18__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN gint terminal_get_euid_from_pid (gint pid,
                                 GCancellable* cancellable,
                                 GError** error);
static void terminal_process_watcher_finalize (GObject * obj);
static GType terminal_process_watcher_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
terminal_process_context_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_PROCESS_CONTEXT_DEFAULT, "TERMINAL_PROCESS_CONTEXT_DEFAULT", "default"}, {TERMINAL_PROCESS_CONTEXT_ROOT, "TERMINAL_PROCESS_CONTEXT_ROOT", "root"}, {TERMINAL_PROCESS_CONTEXT_SSH, "TERMINAL_PROCESS_CONTEXT_SSH", "ssh"}, {0, NULL, NULL}};
	GType terminal_process_context_type_id;
	terminal_process_context_type_id = g_enum_register_static ("TerminalProcessContext", values);
	return terminal_process_context_type_id;
}

GType
terminal_process_context_get_type (void)
{
	static volatile gsize terminal_process_context_type_id__once = 0;
	if (g_once_init_enter (&terminal_process_context_type_id__once)) {
		GType terminal_process_context_type_id;
		terminal_process_context_type_id = terminal_process_context_get_type_once ();
		g_once_init_leave (&terminal_process_context_type_id__once, terminal_process_context_type_id);
	}
	return terminal_process_context_type_id__once;
}

static inline gpointer
terminal_process_get_instance_private (TerminalProcess* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalProcess_private_offset);
}

TerminalProcess*
terminal_process_construct (GType object_type)
{
	TerminalProcess * self = NULL;
	self = (TerminalProcess*) g_object_new (object_type, NULL);
	return self;
}

TerminalProcess*
terminal_process_new (void)
{
	return terminal_process_construct (TERMINAL_TYPE_PROCESS);
}

gint
terminal_process_get_terminal_fd (TerminalProcess* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_terminal_fd;
	return result;
}

void
terminal_process_set_terminal_fd (TerminalProcess* self,
                                  gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_process_get_terminal_fd (self);
	if (old_value != value) {
		self->priv->_terminal_fd = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_TERMINAL_FD_PROPERTY]);
	}
}

GPid
terminal_process_get_pid (TerminalProcess* self)
{
	GPid result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_pid;
	return result;
}

void
terminal_process_set_pid (TerminalProcess* self,
                          GPid value)
{
	GPid old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_process_get_pid (self);
	if (old_value != value) {
		self->priv->_pid = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_PID_PROPERTY]);
	}
}

GPid
terminal_process_get_foreground_pid (TerminalProcess* self)
{
	GPid result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_foreground_pid;
	return result;
}

void
terminal_process_set_foreground_pid (TerminalProcess* self,
                                     GPid value)
{
	GPid old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_process_get_foreground_pid (self);
	if (old_value != value) {
		self->priv->_foreground_pid = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY]);
	}
}

const gchar*
terminal_process_get_last_foreground_task_command (TerminalProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_last_foreground_task_command;
	result = _tmp0_;
	return result;
}

void
terminal_process_set_last_foreground_task_command (TerminalProcess* self,
                                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_process_get_last_foreground_task_command (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_last_foreground_task_command);
		self->priv->_last_foreground_task_command = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY]);
	}
}

gboolean
terminal_process_get_ended (TerminalProcess* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_ended;
	return result;
}

void
terminal_process_set_ended (TerminalProcess* self,
                            gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_process_get_ended (self);
	if (old_value != value) {
		self->priv->_ended = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_ENDED_PROPERTY]);
	}
}

TerminalProcessContext
terminal_process_get_context (TerminalProcess* self)
{
	TerminalProcessContext result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_context;
	return result;
}

void
terminal_process_set_context (TerminalProcess* self,
                              TerminalProcessContext value)
{
	TerminalProcessContext old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_process_get_context (self);
	if (old_value != value) {
		self->priv->_context = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_CONTEXT_PROPERTY]);
	}
}

static void
terminal_process_class_init (TerminalProcessClass * klass,
                             gpointer klass_data)
{
	terminal_process_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminalProcess_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_process_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_process_set_property;
	G_OBJECT_CLASS (klass)->finalize = terminal_process_finalize;
	/**
	   * This is the file descriptor used by the terminal we're tracking. This must
	   * be set during instanciation of this class and may not be modified later.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_TERMINAL_FD_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_TERMINAL_FD_PROPERTY] = g_param_spec_int ("terminal-fd", "terminal-fd", "terminal-fd", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	   * This is the controlling PID for a terminal session. It will point to the
	   * user's shell, in most cases. If the terminal was created with a different
	   * command (i.e., `blackbox --command "sleep 300"`), this will point to the
	   * spawned process instead.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_PID_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, (GPid) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * This is the PID of the process currently running at the top of the user's
	   * shell (e.g., if the user opened a terminal with bash, then opened Neovim
	   * with `nvim`, the foreground task for this session, and, consequently, this
	   * PID, will point to Neovim).
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY] = g_param_spec_int ("foreground-pid", "foreground-pid", "foreground-pid", G_MININT, G_MAXINT, (GPid) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY] = g_param_spec_string ("last-foreground-task-command", "last-foreground-task-command", "last-foreground-task-command", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/***/
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_ENDED_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_ENDED_PROPERTY] = g_param_spec_boolean ("ended", "ended", "ended", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_CONTEXT_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_CONTEXT_PROPERTY] = g_param_spec_enum ("context", "context", "context", TERMINAL_TYPE_PROCESS_CONTEXT, TERMINAL_PROCESS_CONTEXT_DEFAULT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * This signal is emitted when the foreground task of a shell finishes.
	   */
	terminal_process_signals[TERMINAL_PROCESS_FOREGROUND_TASK_FINISHED_SIGNAL] = g_signal_new ("foreground-task-finished", TERMINAL_TYPE_PROCESS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
terminal_process_instance_init (TerminalProcess * self,
                                gpointer klass)
{
	self->priv = terminal_process_get_instance_private (self);
	self->priv->_pid = (GPid) -1;
	self->priv->_foreground_pid = (GPid) -1;
	self->priv->_last_foreground_task_command = NULL;
	self->priv->_ended = FALSE;
	self->priv->_context = TERMINAL_PROCESS_CONTEXT_DEFAULT;
}

static void
terminal_process_finalize (GObject * obj)
{
	TerminalProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_PROCESS, TerminalProcess);
	_g_free0 (self->priv->_last_foreground_task_command);
	G_OBJECT_CLASS (terminal_process_parent_class)->finalize (obj);
}

static GType
terminal_process_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalProcess), 0, (GInstanceInitFunc) terminal_process_instance_init, NULL };
	GType terminal_process_type_id;
	terminal_process_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalProcess", &g_define_type_info, 0);
	TerminalProcess_private_offset = g_type_add_instance_private (terminal_process_type_id, sizeof (TerminalProcessPrivate));
	return terminal_process_type_id;
}

GType
terminal_process_get_type (void)
{
	static volatile gsize terminal_process_type_id__once = 0;
	if (g_once_init_enter (&terminal_process_type_id__once)) {
		GType terminal_process_type_id;
		terminal_process_type_id = terminal_process_get_type_once ();
		g_once_init_leave (&terminal_process_type_id__once, terminal_process_type_id);
	}
	return terminal_process_type_id__once;
}

static void
_vala_terminal_process_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	TerminalProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_PROCESS, TerminalProcess);
	switch (property_id) {
		case TERMINAL_PROCESS_TERMINAL_FD_PROPERTY:
		g_value_set_int (value, terminal_process_get_terminal_fd (self));
		break;
		case TERMINAL_PROCESS_PID_PROPERTY:
		g_value_set_int (value, terminal_process_get_pid (self));
		break;
		case TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY:
		g_value_set_int (value, terminal_process_get_foreground_pid (self));
		break;
		case TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY:
		g_value_set_string (value, terminal_process_get_last_foreground_task_command (self));
		break;
		case TERMINAL_PROCESS_ENDED_PROPERTY:
		g_value_set_boolean (value, terminal_process_get_ended (self));
		break;
		case TERMINAL_PROCESS_CONTEXT_PROPERTY:
		g_value_set_enum (value, terminal_process_get_context (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_terminal_process_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	TerminalProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_PROCESS, TerminalProcess);
	switch (property_id) {
		case TERMINAL_PROCESS_TERMINAL_FD_PROPERTY:
		terminal_process_set_terminal_fd (self, g_value_get_int (value));
		break;
		case TERMINAL_PROCESS_PID_PROPERTY:
		terminal_process_set_pid (self, g_value_get_int (value));
		break;
		case TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY:
		terminal_process_set_foreground_pid (self, g_value_get_int (value));
		break;
		case TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY:
		terminal_process_set_last_foreground_task_command (self, g_value_get_string (value));
		break;
		case TERMINAL_PROCESS_ENDED_PROPERTY:
		terminal_process_set_ended (self, g_value_get_boolean (value));
		break;
		case TERMINAL_PROCESS_CONTEXT_PROPERTY:
		terminal_process_set_context (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
terminal_process_watcher_get_instance_private (TerminalProcessWatcher* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalProcessWatcher_private_offset);
}

static TerminalProcessWatcher*
terminal_process_watcher_construct (GType object_type)
{
	TerminalProcessWatcher * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	self = (TerminalProcessWatcher*) g_object_new (object_type, NULL);
	_tmp0_ = gee_array_list_new (TERMINAL_TYPE_PROCESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->process_list);
	self->priv->process_list = _tmp0_;
	_tmp1_ = gee_array_list_new (TERMINAL_TYPE_PROCESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->pending_process_list);
	self->priv->pending_process_list = _tmp1_;
	return self;
}

static TerminalProcessWatcher*
terminal_process_watcher_new (void)
{
	return terminal_process_watcher_construct (TERMINAL_TYPE_PROCESS_WATCHER);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

TerminalProcessWatcher*
terminal_process_watcher_get_instance (void)
{
	TerminalProcessWatcher* _tmp0_;
	TerminalProcessWatcher* _tmp2_;
	TerminalProcessWatcher* _tmp3_;
	TerminalProcessWatcher* result;
	_tmp0_ = terminal_process_watcher_instance;
	if (_tmp0_ == NULL) {
		TerminalProcessWatcher* _tmp1_;
		_tmp1_ = terminal_process_watcher_new ();
		_g_object_unref0 (terminal_process_watcher_instance);
		terminal_process_watcher_instance = _tmp1_;
	}
	_tmp2_ = terminal_process_watcher_instance;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

gboolean
terminal_process_watcher_watch (TerminalProcessWatcher* self,
                                TerminalProcess* process)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (process != NULL, FALSE);
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->pending_process_list;
		g_rec_mutex_lock (&self->priv->__lock_pending_process_list);
		{
			GeeArrayList* _tmp1_;
			_tmp1_ = self->priv->pending_process_list;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, process);
		}
		__finally0:
		{
			GeeArrayList* _tmp2_;
			_tmp2_ = self->priv->pending_process_list;
			g_rec_mutex_unlock (&self->priv->__lock_pending_process_list);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp3_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
	}
	if (!self->priv->watching) {
		terminal_process_watcher_start_watching (self);
	}
	result = TRUE;
	return result;
}

static gpointer
_terminal_process_watcher_t_watch_loop_gthread_func (gpointer self)
{
	gpointer result;
	terminal_process_watcher_t_watch_loop ((TerminalProcessWatcher*) self);
	result = NULL;
	g_object_unref (self);
	return result;
}

static void
terminal_process_watcher_start_watching (TerminalProcessWatcher* self)
{
	GThread* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->watching = TRUE;
	_tmp0_ = g_thread_new ("process-watcher", _terminal_process_watcher_t_watch_loop_gthread_func, g_object_ref (self));
	_g_thread_unref0 (self->priv->loop_thread);
	self->priv->loop_thread = _tmp0_;
}

static void
terminal_process_watcher_t_watch_loop (TerminalProcessWatcher* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	while (TRUE) {
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gboolean ret = FALSE;
		GeeArrayList* _tmp44_;
		gint _tmp45_;
		gint _tmp46_;
		g_mutex_lock (&self->priv->mutex);
		{
			GeeArrayList* _tmp0_;
			_tmp0_ = self->priv->pending_process_list;
			g_rec_mutex_lock (&self->priv->__lock_pending_process_list);
			{
				GeeArrayList* _tmp1_;
				gint _tmp2_;
				gint _tmp3_;
				_tmp1_ = self->priv->pending_process_list;
				_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
				_tmp3_ = _tmp2_;
				if (_tmp3_ > 0) {
					GeeArrayList* _tmp16_;
					{
						GeeArrayList* _process_list = NULL;
						GeeArrayList* _tmp4_;
						gint _process_size = 0;
						GeeArrayList* _tmp5_;
						gint _tmp6_;
						gint _tmp7_;
						gint _process_index = 0;
						_tmp4_ = self->priv->pending_process_list;
						_process_list = _tmp4_;
						_tmp5_ = _process_list;
						_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
						_tmp7_ = _tmp6_;
						_process_size = _tmp7_;
						_process_index = -1;
						while (TRUE) {
							gint _tmp8_;
							gint _tmp9_;
							TerminalProcess* process = NULL;
							GeeArrayList* _tmp10_;
							gpointer _tmp11_;
							GeeArrayList* _tmp12_;
							TerminalProcess* _tmp13_;
							_process_index = _process_index + 1;
							_tmp8_ = _process_index;
							_tmp9_ = _process_size;
							if (!(_tmp8_ < _tmp9_)) {
								break;
							}
							_tmp10_ = _process_list;
							_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _process_index);
							process = (TerminalProcess*) _tmp11_;
							_tmp12_ = self->priv->process_list;
							_tmp13_ = process;
							if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp12_, _tmp13_)) {
								GeeArrayList* _tmp14_;
								TerminalProcess* _tmp15_;
								_tmp14_ = self->priv->process_list;
								_tmp15_ = process;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
							}
							_g_object_unref0 (process);
						}
					}
					_tmp16_ = self->priv->pending_process_list;
					gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp16_);
				}
			}
			__finally0:
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->pending_process_list;
				g_rec_mutex_unlock (&self->priv->__lock_pending_process_list);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp18_ = self->priv->process_list;
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
		_tmp20_ = _tmp19_;
		g_debug ("ProcessWatcher.vala:142: Watching %d processes", _tmp20_);
		{
			GeeArrayList* _process_list = NULL;
			GeeArrayList* _tmp21_;
			gint _process_size = 0;
			GeeArrayList* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			gint _process_index = 0;
			_tmp21_ = self->priv->process_list;
			_process_list = _tmp21_;
			_tmp22_ = _process_list;
			_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
			_tmp24_ = _tmp23_;
			_process_size = _tmp24_;
			_process_index = -1;
			while (TRUE) {
				gint _tmp25_;
				gint _tmp26_;
				TerminalProcess* process = NULL;
				GeeArrayList* _tmp27_;
				gpointer _tmp28_;
				TerminalProcess* _tmp29_;
				_process_index = _process_index + 1;
				_tmp25_ = _process_index;
				_tmp26_ = _process_size;
				if (!(_tmp25_ < _tmp26_)) {
					break;
				}
				_tmp27_ = _process_list;
				_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _process_index);
				process = (TerminalProcess*) _tmp28_;
				_tmp29_ = process;
				terminal_process_watcher_check_process (self, _tmp29_);
				_g_object_unref0 (process);
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp30_ = FALSE;
				_tmp30_ = TRUE;
				while (TRUE) {
					GeeArrayList* _tmp31_;
					gint _tmp32_;
					gint _tmp33_;
					GeeArrayList* _tmp34_;
					gpointer _tmp35_;
					TerminalProcess* _tmp36_;
					gboolean _tmp37_;
					gboolean _tmp38_;
					gboolean _tmp39_;
					if (!_tmp30_) {
					}
					_tmp30_ = FALSE;
					_tmp31_ = self->priv->process_list;
					_tmp32_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp31_);
					_tmp33_ = _tmp32_;
					if (!(i < _tmp33_)) {
						break;
					}
					_tmp34_ = self->priv->process_list;
					_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp34_, i);
					_tmp36_ = (TerminalProcess*) _tmp35_;
					_tmp37_ = terminal_process_get_ended (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = _tmp38_;
					_g_object_unref0 (_tmp36_);
					if (_tmp39_) {
						GeeArrayList* _tmp40_;
						gpointer _tmp41_;
						TerminalProcess* _tmp42_;
						_tmp40_ = self->priv->process_list;
						_tmp41_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp40_, i);
						_tmp42_ = (TerminalProcess*) _tmp41_;
						_g_object_unref0 (_tmp42_);
					} else {
						gint _tmp43_;
						_tmp43_ = i;
						i = _tmp43_ + 1;
					}
				}
			}
		}
		_tmp44_ = self->priv->process_list;
		_tmp45_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp44_);
		_tmp46_ = _tmp45_;
		ret = _tmp46_ > 0;
		self->priv->watching = ret;
		g_mutex_unlock (&self->priv->mutex);
		if (!ret) {
			break;
		}
		g_usleep ((gulong) (1000 * TERMINAL_PROCESS_WATCHER_INTERVAL_MS));
	}
}

static gboolean
terminal_process_watcher_is_process_still_running (TerminalProcessWatcher* self,
                                                   GPid pid)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint status = 0;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gint _tmp5_ = 0;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp0_ = g_strdup ("ps");
		_tmp1_ = g_strdup ("-p");
		_tmp2_ = g_strdup_printf ("%" G_PID_FORMAT, pid);
		_tmp3_ = g_new0 (gchar*, 3 + 1);
		_tmp3_[0] = _tmp0_;
		_tmp3_[1] = _tmp1_;
		_tmp3_[2] = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp4__length1 = 3;
		_tmp6_ = terminal_host_or_flatpak_spawn (_tmp4_, (gint) 3, &_tmp5_, &_inner_error0_);
		status = _tmp5_;
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp7_);
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		result = status == 0;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_warning ("ProcessWatcher.vala:177: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp10_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp10_;
	}
	result = FALSE;
	return result;
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		TerminalProcessWatcher* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->process);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static void
____lambda18_ (Block11Data* _data11_,
               GObject* _,
               GAsyncResult* res)
{
	TerminalProcessWatcher* self;
	gint foreground_pid = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	self = _data11_->self;
	g_return_if_fail (res != NULL);
	foreground_pid = terminal_get_foreground_process_finish (res);
	if (foreground_pid >= 0) {
		GPid _tmp2_;
		GPid _tmp3_;
		_tmp2_ = terminal_process_get_pid (_data11_->process);
		_tmp3_ = _tmp2_;
		_tmp1_ = foreground_pid != ((gint) _tmp3_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GPid _tmp4_;
		GPid _tmp5_;
		_tmp4_ = terminal_process_get_foreground_pid (_data11_->process);
		_tmp5_ = _tmp4_;
		_tmp0_ = foreground_pid != ((gint) _tmp5_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* cmdline = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = terminal_get_process_cmdline (foreground_pid);
		cmdline = _tmp6_;
		_tmp7_ = cmdline;
		if (g_strcmp0 (_tmp7_, "") == 0) {
			g_debug ("ProcessWatcher.vala:210: Skipping process with empty cmdline");
			_g_free0 (cmdline);
			return;
		}
		terminal_process_set_foreground_pid (_data11_->process, (GPid) foreground_pid);
		_tmp8_ = terminal_get_process_cmdline (foreground_pid);
		_tmp9_ = _tmp8_;
		terminal_process_set_last_foreground_task_command (_data11_->process, _tmp9_);
		_g_free0 (_tmp9_);
		_g_free0 (cmdline);
	}
}

static void
_____lambda18__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	____lambda18_ (self, source_object, res);
	block11_data_unref (self);
}

static void
terminal_process_watcher_check_process (TerminalProcessWatcher* self,
                                        TerminalProcess* process)
{
	Block11Data* _data11_;
	TerminalProcess* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (process != NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_data11_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (process);
	_g_object_unref0 (_data11_->process);
	_data11_->process = _tmp0_;
	{
		{
			gboolean _tmp1_ = FALSE;
			GPid _tmp2_;
			GPid _tmp3_;
			_tmp2_ = terminal_process_get_foreground_pid (_data11_->process);
			_tmp3_ = _tmp2_;
			if (_tmp3_ >= ((GPid) 0)) {
				GPid _tmp4_;
				GPid _tmp5_;
				_tmp4_ = terminal_process_get_foreground_pid (_data11_->process);
				_tmp5_ = _tmp4_;
				_tmp1_ = !terminal_process_watcher_is_process_still_running (self, _tmp5_);
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				g_signal_emit (_data11_->process, terminal_process_signals[TERMINAL_PROCESS_FOREGROUND_TASK_FINISHED_SIGNAL], 0);
				terminal_process_set_foreground_pid (_data11_->process, (GPid) -1);
			}
		}
		{
			gint _tmp6_;
			gint _tmp7_;
			_tmp6_ = terminal_process_get_terminal_fd (_data11_->process);
			_tmp7_ = _tmp6_;
			terminal_get_foreground_process (_tmp7_, NULL, _____lambda18__gasync_ready_callback, block11_data_ref (_data11_));
		}
		{
			gint status = 0;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GPid _tmp10_;
			GPid _tmp11_;
			gchar* _tmp12_;
			gchar** _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
			gint _tmp15_ = 0;
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp8_ = g_strdup ("ps");
			_tmp9_ = g_strdup ("-p");
			_tmp10_ = terminal_process_get_pid (_data11_->process);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strdup_printf ("%" G_PID_FORMAT, _tmp11_);
			_tmp13_ = g_new0 (gchar*, 3 + 1);
			_tmp13_[0] = _tmp8_;
			_tmp13_[1] = _tmp9_;
			_tmp13_[2] = _tmp12_;
			_tmp14_ = _tmp13_;
			_tmp14__length1 = 3;
			_tmp16_ = terminal_host_or_flatpak_spawn (_tmp14_, (gint) 3, &_tmp15_, &_inner_error0_);
			status = _tmp15_;
			_tmp17_ = _tmp16_;
			_g_free0 (_tmp17_);
			_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			terminal_process_set_ended (_data11_->process, status != 0);
		}
		{
			gboolean _tmp18_;
			gboolean _tmp19_;
			_tmp18_ = terminal_process_get_ended (_data11_->process);
			_tmp19_ = _tmp18_;
			if (!_tmp19_) {
				{
					GPid _tmp20_ = 0;
					GPid _tmp21_;
					GPid _tmp22_;
					GPid source_pid = 0;
					gint euid = 0;
					_tmp21_ = terminal_process_get_foreground_pid (_data11_->process);
					_tmp22_ = _tmp21_;
					if (_tmp22_ > ((GPid) -1)) {
						GPid _tmp23_;
						GPid _tmp24_;
						_tmp23_ = terminal_process_get_foreground_pid (_data11_->process);
						_tmp24_ = _tmp23_;
						_tmp20_ = _tmp24_;
					} else {
						GPid _tmp25_;
						GPid _tmp26_;
						_tmp25_ = terminal_process_get_pid (_data11_->process);
						_tmp26_ = _tmp25_;
						_tmp20_ = _tmp26_;
					}
					source_pid = _tmp20_;
					euid = terminal_get_euid_from_pid ((gint) source_pid, NULL, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch1_g_error;
					}
					if (euid == 0) {
						terminal_process_set_context (_data11_->process, TERMINAL_PROCESS_CONTEXT_ROOT);
					} else {
						gchar* command = NULL;
						gchar* _tmp27_;
						gboolean _tmp28_ = FALSE;
						const gchar* _tmp29_;
						_tmp27_ = terminal_get_process_cmdline ((gint) source_pid);
						command = _tmp27_;
						_tmp29_ = command;
						if (g_strcmp0 (_tmp29_, "") != 0) {
							const gchar* _tmp30_;
							_tmp30_ = command;
							_tmp28_ = g_str_has_prefix (_tmp30_, "ssh");
						} else {
							_tmp28_ = FALSE;
						}
						if (_tmp28_) {
							terminal_process_set_context (_data11_->process, TERMINAL_PROCESS_CONTEXT_SSH);
						} else {
							terminal_process_set_context (_data11_->process, TERMINAL_PROCESS_CONTEXT_DEFAULT);
						}
						_g_free0 (command);
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp31_;
					const gchar* _tmp32_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp31_ = e;
					_tmp32_ = _tmp31_->message;
					g_warning ("ProcessWatcher.vala:255: %s", _tmp32_);
					_g_error_free0 (e);
				}
				__finally1:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp33_;
		const gchar* _tmp34_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp33_ = e;
		_tmp34_ = _tmp33_->message;
		g_warning ("ProcessWatcher.vala:261: %s", _tmp34_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		block11_data_unref (_data11_);
		_data11_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	block11_data_unref (_data11_);
	_data11_ = NULL;
}

static void
terminal_process_watcher_class_init (TerminalProcessWatcherClass * klass,
                                     gpointer klass_data)
{
	terminal_process_watcher_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminalProcessWatcher_private_offset);
	G_OBJECT_CLASS (klass)->finalize = terminal_process_watcher_finalize;
}

static void
terminal_process_watcher_instance_init (TerminalProcessWatcher * self,
                                        gpointer klass)
{
	self->priv = terminal_process_watcher_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_pending_process_list);
	self->priv->watching = FALSE;
	self->priv->loop_thread = NULL;
	g_mutex_init (&self->priv->mutex);
}

static void
terminal_process_watcher_finalize (GObject * obj)
{
	TerminalProcessWatcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcher);
	_g_object_unref0 (self->priv->process_list);
	g_rec_mutex_clear (&self->priv->__lock_pending_process_list);
	_g_object_unref0 (self->priv->pending_process_list);
	_g_thread_unref0 (self->priv->loop_thread);
	_vala_clear_GMutex (&self->priv->mutex);
	G_OBJECT_CLASS (terminal_process_watcher_parent_class)->finalize (obj);
}

static GType
terminal_process_watcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalProcessWatcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_process_watcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalProcessWatcher), 0, (GInstanceInitFunc) terminal_process_watcher_instance_init, NULL };
	GType terminal_process_watcher_type_id;
	terminal_process_watcher_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalProcessWatcher", &g_define_type_info, 0);
	TerminalProcessWatcher_private_offset = g_type_add_instance_private (terminal_process_watcher_type_id, sizeof (TerminalProcessWatcherPrivate));
	return terminal_process_watcher_type_id;
}

GType
terminal_process_watcher_get_type (void)
{
	static volatile gsize terminal_process_watcher_type_id__once = 0;
	if (g_once_init_enter (&terminal_process_watcher_type_id__once)) {
		GType terminal_process_watcher_type_id;
		terminal_process_watcher_type_id = terminal_process_watcher_get_type_once ();
		g_once_init_leave (&terminal_process_watcher_type_id__once, terminal_process_watcher_type_id);
	}
	return terminal_process_watcher_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

