/* Dialogs.c generated by valac 0.56.17, the Vala compiler
 * generated from Dialogs.vala, do not modify */

/* Dialogs.vala
 *
 * Copyright 2023 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <adwaita.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB,
	TERMINAL_CONFIRM_CLOSING_CONTEXT_WINDOW
} TerminalConfirmClosingContext;

#define TERMINAL_TYPE_CONFIRM_CLOSING_CONTEXT (terminal_confirm_closing_context_get_type ())
typedef enum  {
	TERMINAL_CONFIRM_ACTION_TYPE_NO_YES,
	TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK,
	TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE,
	TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE
} TerminalConfirmActionType;

#define TERMINAL_TYPE_CONFIRM_ACTION_TYPE (terminal_confirm_action_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block14Data Block14Data;
typedef struct _TerminalConfirmActionData TerminalConfirmActionData;
typedef struct _TerminalConfirmClosingData TerminalConfirmClosingData;

struct _Block14Data {
	int _ref_count_;
	gboolean response;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gpointer _async_data_;
};

struct _TerminalConfirmActionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* title;
	gchar* body;
	TerminalConfirmActionType confirm_type;
	AdwResponseAppearance appearance1;
	AdwResponseAppearance appearance2;
	GtkWidget* extra_child;
	gboolean result;
	Block14Data* _data14_;
	gchar** labels;
	gint _tmp0_;
	gchar** _tmp1_;
	gint labels_length1;
	gint _labels_size_;
	gint _tmp2_;
	gchar** _tmp3_;
	GtkApplication* _tmp4_;
	GApplication* _tmp5_;
	GtkWindow* _tmp6_;
	GtkWindow* _tmp7_;
	AdwMessageDialog* d;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	GtkWidget* _tmp14_;
	AdwMessageDialog* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	const gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	const gchar* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	const gchar* _tmp27_;
};

struct _TerminalConfirmClosingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar** commands;
	gint commands_length1;
	TerminalConfirmClosingContext context;
	gboolean result;
	GtkWidget* child;
	gboolean _tmp0_;
	GtkListBox* list;
	gchar* _tmp1_;
	gchar** _tmp2_;
	GtkListBox* _tmp3_;
	gchar** command_collection;
	gint command_collection_length1;
	gint _command_collection_size_;
	gint command_it;
	const gchar* command;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	AdwActionRow* row;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	AdwActionRow* _tmp9_;
	GtkListBox* _tmp10_;
	AdwActionRow* _tmp11_;
	GtkListBox* _tmp12_;
	GtkWidget* _tmp13_;
	const gchar* _tmp14_;
	gchar* title;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* body;
	gchar* _tmp17_;
	gboolean response;
	const gchar* _tmp18_;
	GtkWidget* _tmp19_;
};

VALA_EXTERN GType terminal_confirm_closing_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType terminal_confirm_action_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar** terminal_confirm_action_type_get_labels (TerminalConfirmActionType self,
                                                 gint* result_length1);
VALA_EXTERN gchar** terminal_confirm_action_type_get_values (TerminalConfirmActionType self,
                                                 gint* result_length1);
static void terminal_confirm_action_data_free (gpointer _data);
VALA_EXTERN void terminal_confirm_action (const gchar* title,
                              const gchar* body,
                              TerminalConfirmActionType confirm_type,
                              AdwResponseAppearance appearance1,
                              AdwResponseAppearance appearance2,
                              GtkWidget* extra_child,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
VALA_EXTERN gboolean terminal_confirm_action_finish (GAsyncResult* _res_);
static gboolean terminal_confirm_action_co (TerminalConfirmActionData* _data_);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static gboolean _terminal_confirm_action_co_gsource_func (gpointer self);
static void __lambda53_ (Block14Data* _data14_,
                  const gchar* _response);
static void ___lambda53__adw_message_dialog_response (AdwMessageDialog* _sender,
                                               const gchar* response,
                                               gpointer self);
static void terminal_confirm_closing_data_free (gpointer _data);
VALA_EXTERN void terminal_confirm_closing (gchar** commands,
                               gint commands_length1,
                               TerminalConfirmClosingContext context,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN gboolean terminal_confirm_closing_finish (GAsyncResult* _res_);
static gboolean terminal_confirm_closing_co (TerminalConfirmClosingData* _data_);
static void terminal_confirm_closing_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
terminal_confirm_closing_context_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB, "TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB", "tab"}, {TERMINAL_CONFIRM_CLOSING_CONTEXT_WINDOW, "TERMINAL_CONFIRM_CLOSING_CONTEXT_WINDOW", "window"}, {0, NULL, NULL}};
	GType terminal_confirm_closing_context_type_id;
	terminal_confirm_closing_context_type_id = g_enum_register_static ("TerminalConfirmClosingContext", values);
	return terminal_confirm_closing_context_type_id;
}

GType
terminal_confirm_closing_context_get_type (void)
{
	static volatile gsize terminal_confirm_closing_context_type_id__once = 0;
	if (g_once_init_enter (&terminal_confirm_closing_context_type_id__once)) {
		GType terminal_confirm_closing_context_type_id;
		terminal_confirm_closing_context_type_id = terminal_confirm_closing_context_get_type_once ();
		g_once_init_leave (&terminal_confirm_closing_context_type_id__once, terminal_confirm_closing_context_type_id);
	}
	return terminal_confirm_closing_context_type_id__once;
}

gchar**
terminal_confirm_action_type_get_labels (TerminalConfirmActionType self,
                                         gint* result_length1)
{
	gchar** result;
	switch (self) {
		case TERMINAL_CONFIRM_ACTION_TYPE_NO_YES:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_;
			gint _tmp3__length1;
			_tmp0_ = g_strdup (_ ("No"));
			_tmp1_ = g_strdup (_ ("Yes"));
			_tmp2_ = g_new0 (gchar*, 2 + 1);
			_tmp2_[0] = _tmp0_;
			_tmp2_[1] = _tmp1_;
			_tmp3_ = _tmp2_;
			_tmp3__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp3__length1;
			}
			result = _tmp3_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK:
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			_tmp4_ = g_strdup (_ ("Cancel"));
			_tmp5_ = g_strdup (_ ("OK"));
			_tmp6_ = g_new0 (gchar*, 2 + 1);
			_tmp6_[0] = _tmp4_;
			_tmp6_[1] = _tmp5_;
			_tmp7_ = _tmp6_;
			_tmp7__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp7__length1;
			}
			result = _tmp7_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE:
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
			_tmp8_ = g_strdup (_ ("Keep"));
			_tmp9_ = g_strdup (_ ("Replace"));
			_tmp10_ = g_new0 (gchar*, 2 + 1);
			_tmp10_[0] = _tmp8_;
			_tmp10_[1] = _tmp9_;
			_tmp11_ = _tmp10_;
			_tmp11__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp11__length1;
			}
			result = _tmp11_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE:
		{
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			_tmp12_ = g_strdup (_ ("Cancel"));
			_tmp13_ = g_strdup (_ ("Close"));
			_tmp14_ = g_new0 (gchar*, 2 + 1);
			_tmp14_[0] = _tmp12_;
			_tmp14_[1] = _tmp13_;
			_tmp15_ = _tmp14_;
			_tmp15__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp15__length1;
			}
			result = _tmp15_;
			return result;
		}
		default:
		break;
	}
	g_error ("Dialogs.vala:40: Invalid ConfirmActionType %d", (gint) self);
}

gchar**
terminal_confirm_action_type_get_values (TerminalConfirmActionType self,
                                         gint* result_length1)
{
	gchar** result;
	switch (self) {
		case TERMINAL_CONFIRM_ACTION_TYPE_NO_YES:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_;
			gint _tmp3__length1;
			_tmp0_ = g_strdup ("no");
			_tmp1_ = g_strdup ("yes");
			_tmp2_ = g_new0 (gchar*, 2 + 1);
			_tmp2_[0] = _tmp0_;
			_tmp2_[1] = _tmp1_;
			_tmp3_ = _tmp2_;
			_tmp3__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp3__length1;
			}
			result = _tmp3_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK:
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			_tmp4_ = g_strdup ("cancel");
			_tmp5_ = g_strdup ("ok");
			_tmp6_ = g_new0 (gchar*, 2 + 1);
			_tmp6_[0] = _tmp4_;
			_tmp6_[1] = _tmp5_;
			_tmp7_ = _tmp6_;
			_tmp7__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp7__length1;
			}
			result = _tmp7_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE:
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
			_tmp8_ = g_strdup ("keep");
			_tmp9_ = g_strdup ("replace");
			_tmp10_ = g_new0 (gchar*, 2 + 1);
			_tmp10_[0] = _tmp8_;
			_tmp10_[1] = _tmp9_;
			_tmp11_ = _tmp10_;
			_tmp11__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp11__length1;
			}
			result = _tmp11_;
			return result;
		}
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE:
		{
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			_tmp12_ = g_strdup ("cancel");
			_tmp13_ = g_strdup ("close");
			_tmp14_ = g_new0 (gchar*, 2 + 1);
			_tmp14_[0] = _tmp12_;
			_tmp14_[1] = _tmp13_;
			_tmp15_ = _tmp14_;
			_tmp15__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp15__length1;
			}
			result = _tmp15_;
			return result;
		}
		default:
		break;
	}
	g_error ("Dialogs.vala:50: Invalid ConfirmActionType %d", (gint) self);
}

static GType
terminal_confirm_action_type_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_CONFIRM_ACTION_TYPE_NO_YES, "TERMINAL_CONFIRM_ACTION_TYPE_NO_YES", "no-yes"}, {TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK, "TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK", "cancel-ok"}, {TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE, "TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE", "keep-replace"}, {TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE, "TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE", "cancel-close"}, {0, NULL, NULL}};
	GType terminal_confirm_action_type_type_id;
	terminal_confirm_action_type_type_id = g_enum_register_static ("TerminalConfirmActionType", values);
	return terminal_confirm_action_type_type_id;
}

GType
terminal_confirm_action_type_get_type (void)
{
	static volatile gsize terminal_confirm_action_type_type_id__once = 0;
	if (g_once_init_enter (&terminal_confirm_action_type_type_id__once)) {
		GType terminal_confirm_action_type_type_id;
		terminal_confirm_action_type_type_id = terminal_confirm_action_type_get_type_once ();
		g_once_init_leave (&terminal_confirm_action_type_type_id__once, terminal_confirm_action_type_type_id);
	}
	return terminal_confirm_action_type_type_id__once;
}

static void
terminal_confirm_action_data_free (gpointer _data)
{
	TerminalConfirmActionData* _data_;
	_data_ = _data;
	_g_free0 (_data_->title);
	_g_free0 (_data_->body);
	_g_object_unref0 (_data_->extra_child);
	g_slice_free (TerminalConfirmActionData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
terminal_confirm_action (const gchar* title,
                         const gchar* body,
                         TerminalConfirmActionType confirm_type,
                         AdwResponseAppearance appearance1,
                         AdwResponseAppearance appearance2,
                         GtkWidget* extra_child,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	TerminalConfirmActionData* _data_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkWidget* _tmp2_;
	g_return_if_fail (title != NULL);
	g_return_if_fail (body != NULL);
	_data_ = g_slice_new0 (TerminalConfirmActionData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_confirm_action_data_free);
	_tmp0_ = g_strdup (title);
	_g_free0 (_data_->title);
	_data_->title = _tmp0_;
	_tmp1_ = g_strdup (body);
	_g_free0 (_data_->body);
	_data_->body = _tmp1_;
	_data_->confirm_type = confirm_type;
	_data_->appearance1 = appearance1;
	_data_->appearance2 = appearance2;
	_tmp2_ = _g_object_ref0 (extra_child);
	_g_object_unref0 (_data_->extra_child);
	_data_->extra_child = _tmp2_;
	terminal_confirm_action_co (_data_);
}

gboolean
terminal_confirm_action_finish (GAsyncResult* _res_)
{
	gboolean result;
	TerminalConfirmActionData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		_data14_->values = (_vala_array_free (_data14_->values, _data14_->values_length1, (GDestroyNotify) g_free), NULL);
		(_data14_->callback_target_destroy_notify == NULL) ? NULL : (_data14_->callback_target_destroy_notify (_data14_->callback_target), NULL);
		_data14_->callback = NULL;
		_data14_->callback_target = NULL;
		_data14_->callback_target_destroy_notify = NULL;
		g_slice_free (Block14Data, _data14_);
	}
}

static gboolean
_terminal_confirm_action_co_gsource_func (gpointer self)
{
	gboolean result;
	result = terminal_confirm_action_co (self);
	return result;
}

static void
__lambda53_ (Block14Data* _data14_,
             const gchar* _response)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	GSourceFunc _tmp2_;
	gpointer _tmp2__target;
	g_return_if_fail (_response != NULL);
	_tmp0_ = _data14_->values;
	_tmp0__length1 = _data14_->values_length1;
	_tmp1_ = _tmp0_[1];
	_data14_->response = g_strcmp0 (_response, _tmp1_) == 0;
	_tmp2_ = _data14_->callback;
	_tmp2__target = _data14_->callback_target;
	_tmp2_ (_tmp2__target);
}

static void
___lambda53__adw_message_dialog_response (AdwMessageDialog* _sender,
                                          const gchar* response,
                                          gpointer self)
{
	__lambda53_ (self, response);
}

static gboolean
terminal_confirm_action_co (TerminalConfirmActionData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data14_ = g_slice_new0 (Block14Data);
	_data_->_data14_->_ref_count_ = 1;
	_data_->_data14_->_async_data_ = _data_;
	_data_->_data14_->response = FALSE;
	_data_->_data14_->callback = _terminal_confirm_action_co_gsource_func;
	_data_->_data14_->callback_target = _data_;
	_data_->_data14_->callback_target_destroy_notify = NULL;
	_data_->_tmp0_ = 0;
	_data_->_tmp1_ = terminal_confirm_action_type_get_labels (_data_->confirm_type, &_data_->_tmp0_);
	_data_->labels = _data_->_tmp1_;
	_data_->labels_length1 = _data_->_tmp0_;
	_data_->_labels_size_ = _data_->labels_length1;
	_data_->_tmp2_ = 0;
	_data_->_tmp3_ = terminal_confirm_action_type_get_values (_data_->confirm_type, &_data_->_tmp2_);
	_data_->_data14_->values = _data_->_tmp3_;
	_data_->_data14_->values_length1 = _data_->_tmp2_;
	_data_->_data14_->_values_size_ = _data_->_data14_->values_length1;
	_data_->_tmp5_ = g_application_get_default ();
	_data_->_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp5_, gtk_application_get_type ()) ? ((GtkApplication*) _data_->_tmp5_) : NULL;
	_data_->_tmp6_ = NULL;
	if (_data_->_tmp4_ != NULL) {
		_data_->_tmp7_ = gtk_application_get_active_window (_data_->_tmp4_);
		_data_->_tmp6_ = _data_->_tmp7_;
	}
	_data_->_tmp8_ = _data_->_data14_->values;
	_data_->_tmp8__length1 = _data_->_data14_->values_length1;
	_data_->_tmp9_ = _data_->_tmp8_[1];
	_data_->_tmp10_ = g_strdup (_data_->_tmp9_);
	_data_->_tmp11_ = _data_->_data14_->values;
	_data_->_tmp11__length1 = _data_->_data14_->values_length1;
	_data_->_tmp12_ = _data_->_tmp11_[0];
	_data_->_tmp13_ = g_strdup (_data_->_tmp12_);
	_data_->_tmp14_ = _g_object_ref0 (_data_->extra_child);
	_data_->_tmp15_ = NULL;
	_data_->_tmp15_ = (AdwMessageDialog*) adw_message_dialog_new (_data_->_tmp6_, _data_->title, _data_->body);
	adw_message_dialog_set_default_response (_data_->_tmp15_, _data_->_tmp10_);
	_g_free0 (_data_->_tmp10_);
	adw_message_dialog_set_close_response (_data_->_tmp15_, _data_->_tmp13_);
	_g_free0 (_data_->_tmp13_);
	adw_message_dialog_set_extra_child (_data_->_tmp15_, _data_->_tmp14_);
	_g_object_unref0 (_data_->_tmp14_);
	g_object_ref_sink (_data_->_tmp15_);
	_data_->d = _data_->_tmp15_;
	_data_->_tmp16_ = _data_->_data14_->values;
	_data_->_tmp16__length1 = _data_->_data14_->values_length1;
	_data_->_tmp17_ = _data_->_tmp16_[0];
	_data_->_tmp18_ = _data_->labels;
	_data_->_tmp18__length1 = _data_->labels_length1;
	_data_->_tmp19_ = _data_->_tmp18_[0];
	adw_message_dialog_add_response (_data_->d, _data_->_tmp17_, _data_->_tmp19_);
	_data_->_tmp20_ = _data_->_data14_->values;
	_data_->_tmp20__length1 = _data_->_data14_->values_length1;
	_data_->_tmp21_ = _data_->_tmp20_[1];
	_data_->_tmp22_ = _data_->labels;
	_data_->_tmp22__length1 = _data_->labels_length1;
	_data_->_tmp23_ = _data_->_tmp22_[1];
	adw_message_dialog_add_response (_data_->d, _data_->_tmp21_, _data_->_tmp23_);
	_data_->_tmp24_ = _data_->_data14_->values;
	_data_->_tmp24__length1 = _data_->_data14_->values_length1;
	_data_->_tmp25_ = _data_->_tmp24_[0];
	adw_message_dialog_set_response_appearance (_data_->d, _data_->_tmp25_, _data_->appearance1);
	_data_->_tmp26_ = _data_->_data14_->values;
	_data_->_tmp26__length1 = _data_->_data14_->values_length1;
	_data_->_tmp27_ = _data_->_tmp26_[1];
	adw_message_dialog_set_response_appearance (_data_->d, _data_->_tmp27_, _data_->appearance2);
	g_signal_connect_data (_data_->d, "response", (GCallback) ___lambda53__adw_message_dialog_response, block14_data_ref (_data_->_data14_), (GClosureNotify) block14_data_unref, 0);
	gtk_widget_show ((GtkWidget*) _data_->d);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->result = _data_->_data14_->response;
	_g_object_unref0 (_data_->d);
	_data_->labels = (_vala_array_free (_data_->labels, _data_->labels_length1, (GDestroyNotify) g_free), NULL);
	block14_data_unref (_data_->_data14_);
	_data_->_data14_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
terminal_confirm_closing_data_free (gpointer _data)
{
	TerminalConfirmClosingData* _data_;
	_data_ = _data;
	g_slice_free (TerminalConfirmClosingData, _data_);
}

void
terminal_confirm_closing (gchar** commands,
                          gint commands_length1,
                          TerminalConfirmClosingContext context,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	TerminalConfirmClosingData* _data_;
	_data_ = g_slice_new0 (TerminalConfirmClosingData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_confirm_closing_data_free);
	_data_->commands = commands;
	_data_->commands_length1 = commands_length1;
	_data_->context = context;
	terminal_confirm_closing_co (_data_);
}

gboolean
terminal_confirm_closing_finish (GAsyncResult* _res_)
{
	gboolean result;
	TerminalConfirmClosingData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
terminal_confirm_closing_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	TerminalConfirmClosingData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	terminal_confirm_closing_co (_data_);
}

static gboolean
terminal_confirm_closing_co (TerminalConfirmClosingData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->child = NULL;
	if (_data_->commands != NULL) {
		_data_->_tmp0_ = _data_->commands_length1 > 0;
	} else {
		_data_->_tmp0_ = FALSE;
	}
	if (_data_->_tmp0_) {
		_data_->_tmp1_ = g_strdup ("boxed-list");
		_data_->_tmp2_ = g_new0 (gchar*, 1 + 1);
		_data_->_tmp2_[0] = _data_->_tmp1_;
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = (GtkListBox*) gtk_list_box_new ();
		gtk_widget_set_css_classes ((GtkWidget*) _data_->_tmp3_, _data_->_tmp2_);
		_data_->_tmp2_ = (_vala_array_free (_data_->_tmp2_, 1, (GDestroyNotify) g_free), NULL);
		gtk_list_box_set_selection_mode (_data_->_tmp3_, GTK_SELECTION_NONE);
		g_object_ref_sink (_data_->_tmp3_);
		_data_->list = _data_->_tmp3_;
		{
			_data_->command_collection_length1 = 0;
			_data_->_command_collection_size_ = 0;
			_data_->command_collection = _data_->commands;
			_data_->command_collection_length1 = _data_->commands_length1;
			for (_data_->command_it = 0; _data_->command_it < _data_->command_collection_length1; _data_->command_it = _data_->command_it + 1) {
				_data_->command = _data_->command_collection[_data_->command_it];
				{
					_data_->_tmp5_ = _data_->command;
					_data_->_tmp4_ = _data_->_tmp5_;
					if (_data_->_tmp4_ == NULL) {
						_data_->_tmp4_ = "";
					}
					_data_->_tmp6_ = g_strdup (_data_->_tmp4_);
					_data_->_tmp7_ = g_strdup ("monospace");
					_data_->_tmp8_ = g_new0 (gchar*, 1 + 1);
					_data_->_tmp8_[0] = _data_->_tmp7_;
					_data_->_tmp9_ = NULL;
					_data_->_tmp9_ = (AdwActionRow*) adw_action_row_new ();
					adw_preferences_row_set_title ((AdwPreferencesRow*) _data_->_tmp9_, _data_->_tmp6_);
					_g_free0 (_data_->_tmp6_);
					gtk_widget_set_css_classes ((GtkWidget*) _data_->_tmp9_, _data_->_tmp8_);
					_data_->_tmp8_ = (_vala_array_free (_data_->_tmp8_, 1, (GDestroyNotify) g_free), NULL);
					gtk_widget_set_can_focus ((GtkWidget*) _data_->_tmp9_, FALSE);
					g_object_ref_sink (_data_->_tmp9_);
					_data_->row = _data_->_tmp9_;
					_data_->_tmp10_ = _data_->list;
					_data_->_tmp11_ = _data_->row;
					gtk_list_box_append (_data_->_tmp10_, (GtkWidget*) _data_->_tmp11_);
					_g_object_unref0 (_data_->row);
				}
			}
		}
		_data_->_tmp12_ = _data_->list;
		_data_->_tmp13_ = _g_object_ref0 ((GtkWidget*) _data_->_tmp12_);
		_g_object_unref0 (_data_->child);
		_data_->child = _data_->_tmp13_;
		_g_object_unref0 (_data_->list);
	}
	if (_data_->context == TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB) {
		_data_->_tmp14_ = _ ("Close Tab?");
	} else {
		_data_->_tmp14_ = _ ("Close Window?");
	}
	_data_->_tmp15_ = g_strdup (_data_->_tmp14_);
	_data_->title = _data_->_tmp15_;
	if (_data_->context == TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB) {
		_data_->_tmp16_ = _ ("Some commands are still running. Closing this tab will kill them and m" \
"ay lead to unexpected outcomes.");
	} else {
		_data_->_tmp16_ = _ ("Some commands are still running. Closing this window will kill them an" \
"d may lead to unexpected outcomes.");
	}
	_data_->_tmp17_ = g_strdup (_data_->_tmp16_);
	_data_->body = _data_->_tmp17_;
	_data_->_tmp18_ = _data_->title;
	_data_->_tmp19_ = _data_->child;
	_data_->_state_ = 1;
	terminal_confirm_action (_data_->_tmp18_, _data_->body, TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE, ADW_RESPONSE_DEFAULT, ADW_RESPONSE_DESTRUCTIVE, _data_->_tmp19_, terminal_confirm_closing_ready, _data_);
	return FALSE;
	_state_1:
	_data_->response = terminal_confirm_action_finish (_data_->_res_);
	_data_->result = _data_->response;
	_g_free0 (_data_->body);
	_g_free0 (_data_->title);
	_g_object_unref0 (_data_->child);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

