/* PreferencesWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from PreferencesWindow.vala, do not modify */

/* PreferencesWindow2.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <adwaita.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <pqmarble.h>
#include <vte/vte.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>
#include <pango/pango.h>

#define TERMINAL_CONSTANTS_INFINITE_SCROLLBACK_WARNING _ ("Warning: unlimited scrollback saves content to disk, which may cause y" \
"our system to run out of storage.")
#define TERMINAL_DEVEL FALSE
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_COLOR_SCHEME_THUMBNAIL (terminal_color_scheme_thumbnail_get_type ())
#define TERMINAL_COLOR_SCHEME_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_COLOR_SCHEME_THUMBNAIL, TerminalColorSchemeThumbnail))
#define TERMINAL_COLOR_SCHEME_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_COLOR_SCHEME_THUMBNAIL, TerminalColorSchemeThumbnailClass))
#define TERMINAL_IS_COLOR_SCHEME_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_COLOR_SCHEME_THUMBNAIL))
#define TERMINAL_IS_COLOR_SCHEME_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_COLOR_SCHEME_THUMBNAIL))
#define TERMINAL_COLOR_SCHEME_THUMBNAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_COLOR_SCHEME_THUMBNAIL, TerminalColorSchemeThumbnailClass))

typedef struct _TerminalColorSchemeThumbnail TerminalColorSchemeThumbnail;
typedef struct _TerminalColorSchemeThumbnailClass TerminalColorSchemeThumbnailClass;

#define TERMINAL_TYPE_SCHEME (terminal_scheme_get_type ())
#define TERMINAL_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SCHEME, TerminalScheme))
#define TERMINAL_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))
#define TERMINAL_IS_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SCHEME))
#define TERMINAL_IS_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SCHEME))
#define TERMINAL_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))

typedef struct _TerminalScheme TerminalScheme;
typedef struct _TerminalSchemeClass TerminalSchemeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_PREFERENCES_WINDOW (terminal_preferences_window_get_type ())
#define TERMINAL_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PREFERENCES_WINDOW, TerminalPreferencesWindow))
#define TERMINAL_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PREFERENCES_WINDOW, TerminalPreferencesWindowClass))
#define TERMINAL_IS_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PREFERENCES_WINDOW))
#define TERMINAL_IS_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PREFERENCES_WINDOW))
#define TERMINAL_PREFERENCES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PREFERENCES_WINDOW, TerminalPreferencesWindowClass))

typedef struct _TerminalPreferencesWindow TerminalPreferencesWindow;
typedef struct _TerminalPreferencesWindowClass TerminalPreferencesWindowClass;
typedef struct _TerminalPreferencesWindowPrivate TerminalPreferencesWindowPrivate;

#define TERMINAL_TYPE_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_WINDOW, TerminalWindowClass))
#define TERMINAL_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_WINDOW))
#define TERMINAL_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;
enum  {
	TERMINAL_PREFERENCES_WINDOW_0_PROPERTY,
	TERMINAL_PREFERENCES_WINDOW_SHOW_CUSTOM_SCROLLBACK_ROW_PROPERTY,
	TERMINAL_PREFERENCES_WINDOW_SELECTED_THEME_PROPERTY,
	TERMINAL_PREFERENCES_WINDOW_NUM_PROPERTIES
};
static GParamSpec* terminal_preferences_window_properties[TERMINAL_PREFERENCES_WINDOW_NUM_PROPERTIES];

#define TERMINAL_TYPE_THEME_PROVIDER (terminal_theme_provider_get_type ())
#define TERMINAL_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProvider))
#define TERMINAL_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))
#define TERMINAL_IS_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_IS_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_THEME_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))

typedef struct _TerminalThemeProvider TerminalThemeProvider;
typedef struct _TerminalThemeProviderClass TerminalThemeProviderClass;
typedef struct _TerminalThemeProviderPrivate TerminalThemeProviderPrivate;
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TERMINAL_TYPE_SETTINGS (terminal_settings_get_type ())
#define TERMINAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettings))
#define TERMINAL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))
#define TERMINAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))

typedef struct _TerminalSettings TerminalSettings;
typedef struct _TerminalSettingsClass TerminalSettingsClass;

#define TERMINAL_TYPE_PADDING (terminal_padding_get_type ())
typedef struct _TerminalPadding TerminalPadding;
typedef enum  {
	TERMINAL_SCROLLBACK_MODE_FIXED = 0,
	TERMINAL_SCROLLBACK_MODE_UNLIMITED = 1,
	TERMINAL_SCROLLBACK_MODE_DISABLED = 2
} TerminalScrollbackMode;

#define TERMINAL_TYPE_SCROLLBACK_MODE (terminal_scrollback_mode_get_type ())
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef enum  {
	TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION = 0,
	TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY = 1,
	TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM = 2
} TerminalWorkingDirectoryMode;

#define TERMINAL_TYPE_WORKING_DIRECTORY_MODE (terminal_working_directory_mode_get_type ())

#define TERMINAL_TYPE_SHORTCUT_EDITOR (terminal_shortcut_editor_get_type ())
#define TERMINAL_SHORTCUT_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SHORTCUT_EDITOR, TerminalShortcutEditor))
#define TERMINAL_SHORTCUT_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SHORTCUT_EDITOR, TerminalShortcutEditorClass))
#define TERMINAL_IS_SHORTCUT_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SHORTCUT_EDITOR))
#define TERMINAL_IS_SHORTCUT_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SHORTCUT_EDITOR))
#define TERMINAL_SHORTCUT_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SHORTCUT_EDITOR, TerminalShortcutEditorClass))

typedef struct _TerminalShortcutEditor TerminalShortcutEditor;
typedef struct _TerminalShortcutEditorClass TerminalShortcutEditorClass;
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))

struct _TerminalPreferencesWindow {
	AdwPreferencesWindow parent_instance;
	TerminalPreferencesWindowPrivate * priv;
};

struct _TerminalPreferencesWindowClass {
	AdwPreferencesWindowClass parent_class;
};

struct _TerminalPreferencesWindowPrivate {
	AdwActionRow* use_sixel_action_row;
	AdwComboRow* cursor_shape_combo_row;
	AdwComboRow* cursor_blink_mode_combo_row;
	AdwComboRow* scrollback_mode_combo_row;
	AdwComboRow* working_directory_mode_combo_row;
	AdwComboRow* style_preference_combo_row;
	AdwEntryRow* custom_command_entry_row;
	AdwEntryRow* custom_working_directory_entry_row;
	GtkAdjustment* cell_height_spacing_adjustment;
	GtkAdjustment* cell_width_spacing_adjustment;
	GtkAdjustment* custom_scrollback_adjustment;
	GtkAdjustment* floating_controls_delay_adjustment;
	GtkAdjustment* floating_controls_hover_area_adjustment;
	GtkCheckButton* filter_themes_check_button;
	GtkFlowBox* preview_flow_box;
	GtkLabel* font_label;
	GtkLabel* no_sixel_support_label;
	GtkSpinButton* custom_scrollback_spin_button;
	GtkSpinButton* padding_spin_button;
	GtkSwitch* easy_copy_paste_switch;
	GtkSwitch* fill_tabs_switch;
	GtkSwitch* floating_controls_switch;
	GtkSwitch* use_sixel_switch;
	GtkSwitch* pretty_switch;
	GtkSwitch* bold_is_bright_switch;
	GtkSpinButton* opacity_spin_button;
	GtkSwitch* remember_window_size_switch;
	GtkSwitch* run_command_as_login_switch;
	GtkSwitch* show_headerbar_switch;
	GtkSwitch* context_aware_header_bar_switch;
	GtkSwitch* show_menu_button_switch;
	GtkSwitch* show_scrollbars_switch;
	GtkSwitch* use_custom_shell_command_switch;
	GtkSwitch* use_overlay_scrolling_switch;
	GtkSwitch* drag_area_switch;
	GtkSwitch* terminal_bell_switch;
	GtkSwitch* notify_process_completion_switch;
	GtkToggleButton* dark_theme_toggle;
	GtkToggleButton* light_theme_toggle;
	TerminalWindow* window;
	gboolean _show_custom_scrollback_row;
};

struct _TerminalThemeProvider {
	GObject parent_instance;
	TerminalThemeProviderPrivate * priv;
	GHashTable* themes;
};

struct _TerminalThemeProviderClass {
	GObjectClass parent_class;
};

struct _Block2Data {
	int _ref_count_;
	TerminalPreferencesWindow* self;
	TerminalColorSchemeThumbnail* t;
};

struct _TerminalPadding {
	guint top;
	guint right;
	guint bottom;
	guint left;
};

struct _Block3Data {
	int _ref_count_;
	TerminalPreferencesWindow* self;
	GtkFontChooserDialog* fc;
};

struct _Block4Data {
	int _ref_count_;
	TerminalPreferencesWindow* self;
	GtkMessageDialog* d;
};

static gint TerminalPreferencesWindow_private_offset;
static gpointer terminal_preferences_window_parent_class = NULL;

VALA_EXTERN gboolean dark_themes_filter_func (GtkFlowBoxChild* child);
VALA_EXTERN GType terminal_color_scheme_thumbnail_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalColorSchemeThumbnail, g_object_unref)
VALA_EXTERN GType terminal_scheme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalScheme, g_object_unref)
VALA_EXTERN TerminalScheme* terminal_color_scheme_thumbnail_get_scheme (TerminalColorSchemeThumbnail* self);
VALA_EXTERN gboolean terminal_scheme_get_is_dark (TerminalScheme* self);
VALA_EXTERN gboolean light_themes_filter_func (GtkFlowBoxChild* child);
VALA_EXTERN GType terminal_preferences_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalPreferencesWindow, g_object_unref)
VALA_EXTERN GType terminal_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalWindow, g_object_unref)
VALA_EXTERN TerminalPreferencesWindow* terminal_preferences_window_new (TerminalWindow* window);
VALA_EXTERN TerminalPreferencesWindow* terminal_preferences_window_construct (GType object_type,
                                                                  TerminalWindow* window);
static void terminal_preferences_window_build_ui (TerminalPreferencesWindow* self);
static void terminal_preferences_window_bind_data (TerminalPreferencesWindow* self);
VALA_EXTERN void terminal_color_scheme_thumbnail_provider_init_resource (void);
VALA_EXTERN GType terminal_theme_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalThemeProvider, g_object_unref)
VALA_EXTERN TerminalThemeProvider* terminal_window_get_theme_provider (TerminalWindow* self);
static void __lambda30_ (TerminalPreferencesWindow* self,
                  const gchar* name,
                  TerminalScheme* scheme);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN TerminalColorSchemeThumbnail* terminal_color_scheme_thumbnail_new (TerminalScheme* scheme);
VALA_EXTERN TerminalColorSchemeThumbnail* terminal_color_scheme_thumbnail_construct (GType object_type,
                                                                         TerminalScheme* scheme);
static gboolean ___lambda33_ (Block2Data* _data2_,
                       GBinding* _,
                       GValue* from,
                       GValue* to);
VALA_EXTERN const gchar* terminal_scheme_get_name (TerminalScheme* self);
static gboolean ____lambda33__gbinding_transform_func (GBinding* binding,
                                                GValue* from_value,
                                                GValue* to_value,
                                                gpointer self);
static void ___lambda30__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static gint __lambda34_ (TerminalPreferencesWindow* self,
                  GtkFlowBoxChild* child1,
                  GtkFlowBoxChild* child2);
static gint ___lambda34__gtk_flow_box_sort_func (GtkFlowBoxChild* child1,
                                          GtkFlowBoxChild* child2,
                                          gpointer self);
VALA_EXTERN GType terminal_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalSettings, g_object_unref)
VALA_EXTERN TerminalSettings* terminal_settings_get_default (void);
static gboolean __lambda35_ (GValue* to_val,
                      GVariant* settings_variant);
static gboolean ___lambda35__gsettings_bind_get_mapping (GValue* value,
                                                  GVariant* variant,
                                                  void* user_data);
static GVariant* __lambda36_ (GValue* value);
static GVariant* ___lambda36__gsettings_bind_set_mapping (GValue* value,
                                                   const GVariantType* expected_type,
                                                   void* user_data);
static gboolean __lambda37_ (GValue* to_value,
                      GVariant* settings_vari);
static gboolean ___lambda37__gsettings_bind_get_mapping (GValue* value,
                                                  GVariant* variant,
                                                  void* user_data);
static GVariant* __lambda38_ (GValue* value);
static GVariant* ___lambda38__gsettings_bind_set_mapping (GValue* value,
                                                   const GVariantType* expected_type,
                                                   void* user_data);
static gboolean __lambda39_ (GValue* to_val,
                      GVariant* settings_vari);
VALA_EXTERN GType terminal_padding_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalPadding* terminal_padding_dup (const TerminalPadding* self);
VALA_EXTERN void terminal_padding_free (TerminalPadding* self);
VALA_EXTERN void terminal_padding_from_variant (GVariant* vari,
                                    TerminalPadding* result);
static gboolean ___lambda39__gsettings_bind_get_mapping (GValue* value,
                                                  GVariant* variant,
                                                  void* user_data);
static GVariant* __lambda40_ (GValue* spin_val,
                       const GVariantType* _);
VALA_EXTERN GVariant* terminal_padding_to_variant (TerminalPadding *self);
static GVariant* ___lambda40__gsettings_bind_set_mapping (GValue* value,
                                                   const GVariantType* expected_type,
                                                   void* user_data);
static gboolean __lambda41_ (TerminalPreferencesWindow* self,
                      GBinding* _,
                      GValue* from_value,
                      GValue* to_value);
static gboolean ___lambda41__gbinding_transform_func (GBinding* binding,
                                               GValue* from_value,
                                               GValue* to_value,
                                               gpointer self);
static gboolean __lambda42_ (TerminalPreferencesWindow* self,
                      GBinding* _,
                      GValue* mode_value,
                      GValue* subtitle);
VALA_EXTERN GType terminal_scrollback_mode_get_type (void) G_GNUC_CONST ;
static gboolean ___lambda42__gbinding_transform_func (GBinding* binding,
                                               GValue* from_value,
                                               GValue* to_value,
                                               gpointer self);
static void __lambda43_ (TerminalPreferencesWindow* self,
                  GtkFlowBoxChild* child);
VALA_EXTERN void terminal_preferences_window_set_selected_theme (TerminalPreferencesWindow* self,
                                                     const gchar* value);
static void ___lambda43__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                GtkFlowBoxChild* child,
                                                gpointer self);
static void __lambda44_ (TerminalPreferencesWindow* self);
static void terminal_preferences_window_set_themes_filter_func (TerminalPreferencesWindow* self);
static void ___lambda44__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda45_ (TerminalPreferencesWindow* self);
static void ___lambda45__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda46_ (TerminalPreferencesWindow* self);
static void ___lambda46__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda47_ (TerminalPreferencesWindow* self);
static gboolean terminal_preferences_window_is_custom_working_directory_valid (TerminalPreferencesWindow* self);
static void ___lambda47__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN TerminalThemeProvider* terminal_theme_provider_get_default (void);
VALA_EXTERN gboolean terminal_theme_provider_get_is_dark_style_active (TerminalThemeProvider* self);
static void __lambda48_ (TerminalPreferencesWindow* self);
static void ___lambda48__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda49_ (TerminalPreferencesWindow* self);
static void ___lambda49__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean _light_themes_filter_func_gtk_flow_box_filter_func (GtkFlowBoxChild* child,
                                                             gpointer self);
static gboolean _dark_themes_filter_func_gtk_flow_box_filter_func (GtkFlowBoxChild* child,
                                                            gpointer self);
static void terminal_preferences_window_do_reset_preferences (TerminalPreferencesWindow* self);
VALA_EXTERN const gchar* terminal_settings_get_custom_working_directory (TerminalSettings* self);
static void terminal_preferences_window_on_font_row_activated (TerminalPreferencesWindow* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN const gchar* terminal_settings_get_font (TerminalSettings* self);
static gboolean __lambda50_ (TerminalPreferencesWindow* self,
                      PangoFontFamily* desc);
static gboolean ___lambda50__gtk_font_filter_func (PangoFontFamily* family,
                                            PangoFontFace* face,
                                            gpointer self);
static void __lambda51_ (Block3Data* _data3_,
                  gint response);
VALA_EXTERN void terminal_settings_set_font (TerminalSettings* self,
                                 const gchar* value);
static void ___lambda51__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void _terminal_preferences_window_on_font_row_activated_adw_action_row_activated (AdwActionRow* _sender,
                                                                                  gpointer self);
static void terminal_preferences_window_on_reset_request (TerminalPreferencesWindow* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda52_ (Block4Data* _data4_,
                  gint response);
static void ___lambda52__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void _terminal_preferences_window_on_reset_request_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void terminal_preferences_window_on_get_more_themes_online (TerminalPreferencesWindow* self);
static void _terminal_preferences_window_on_get_more_themes_online_gtk_button_clicked (GtkButton* _sender,
                                                                                gpointer self);
static void terminal_preferences_window_on_open_themes_folder (TerminalPreferencesWindow* self);
VALA_EXTERN gchar* terminal_constants_get_user_schemes_dir (void);
static void _terminal_preferences_window_on_open_themes_folder_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
VALA_EXTERN GType terminal_working_directory_mode_get_type (void) G_GNUC_CONST ;
static gboolean terminal_preferences_window_show_custom_working_directory_entry_row (TerminalPreferencesWindow* self,
                                                                              TerminalWorkingDirectoryMode cwd_mode);
static gchar* terminal_preferences_window_explain_working_directory_mode (TerminalPreferencesWindow* self,
                                                                   TerminalWorkingDirectoryMode cwd_mode);
static void terminal_preferences_window_set_custom_working_dir_to_home (TerminalPreferencesWindow* self);
VALA_EXTERN void terminal_settings_set_custom_working_directory (TerminalSettings* self,
                                                     const gchar* value);
static void _terminal_preferences_window_set_custom_working_dir_to_home_gtk_button_clicked (GtkButton* _sender,
                                                                                     gpointer self);
VALA_EXTERN gboolean terminal_preferences_window_get_show_custom_scrollback_row (TerminalPreferencesWindow* self);
VALA_EXTERN void terminal_preferences_window_set_show_custom_scrollback_row (TerminalPreferencesWindow* self,
                                                                 gboolean value);
VALA_EXTERN const gchar* terminal_preferences_window_get_selected_theme (TerminalPreferencesWindow* self);
VALA_EXTERN const gchar* terminal_settings_get_theme_light (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_settings_get_theme_dark (TerminalSettings* self);
VALA_EXTERN void terminal_settings_set_theme_light (TerminalSettings* self,
                                        const gchar* value);
VALA_EXTERN void terminal_settings_set_theme_dark (TerminalSettings* self,
                                       const gchar* value);
static GObject * terminal_preferences_window_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
VALA_EXTERN GType terminal_shortcut_editor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalShortcutEditor, g_object_unref)
static void terminal_preferences_window_finalize (GObject * obj);
static GType terminal_preferences_window_get_type_once (void);
static void _vala_terminal_preferences_window_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_terminal_preferences_window_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
dark_themes_filter_func (GtkFlowBoxChild* child)
{
	TerminalColorSchemeThumbnail* thumbnail = NULL;
	TerminalColorSchemeThumbnail* _tmp0_;
	TerminalScheme* _tmp1_;
	TerminalScheme* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (child != NULL, FALSE);
	_tmp0_ = _g_object_ref0 (TERMINAL_IS_COLOR_SCHEME_THUMBNAIL (child) ? ((TerminalColorSchemeThumbnail*) child) : NULL);
	thumbnail = _tmp0_;
	_tmp1_ = terminal_color_scheme_thumbnail_get_scheme (thumbnail);
	_tmp2_ = _tmp1_;
	_tmp3_ = terminal_scheme_get_is_dark (_tmp2_);
	_tmp4_ = _tmp3_;
	result = _tmp4_;
	_g_object_unref0 (thumbnail);
	return result;
}

gboolean
light_themes_filter_func (GtkFlowBoxChild* child)
{
	TerminalColorSchemeThumbnail* thumbnail = NULL;
	TerminalColorSchemeThumbnail* _tmp0_;
	TerminalScheme* _tmp1_;
	TerminalScheme* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (child != NULL, FALSE);
	_tmp0_ = _g_object_ref0 (TERMINAL_IS_COLOR_SCHEME_THUMBNAIL (child) ? ((TerminalColorSchemeThumbnail*) child) : NULL);
	thumbnail = _tmp0_;
	_tmp1_ = terminal_color_scheme_thumbnail_get_scheme (thumbnail);
	_tmp2_ = _tmp1_;
	_tmp3_ = terminal_scheme_get_is_dark (_tmp2_);
	_tmp4_ = _tmp3_;
	result = !_tmp4_;
	_g_object_unref0 (thumbnail);
	return result;
}

static inline gpointer
terminal_preferences_window_get_instance_private (TerminalPreferencesWindow* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalPreferencesWindow_private_offset);
}

TerminalPreferencesWindow*
terminal_preferences_window_construct (GType object_type,
                                       TerminalWindow* window)
{
	TerminalPreferencesWindow * self = NULL;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	TerminalWindow* _tmp2_;
	GtkAdjustment* _tmp3_;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) window);
	_tmp1_ = _tmp0_;
	self = (TerminalPreferencesWindow*) g_object_new (object_type, "application", _tmp1_, "transient-for", window, "destroy-with-parent", TRUE, NULL);
	_tmp2_ = _g_object_ref0 (window);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp2_;
	_tmp3_ = self->priv->custom_scrollback_adjustment;
	gtk_adjustment_set_upper (_tmp3_, (gdouble) G_MAXUINT);
	terminal_preferences_window_build_ui (self);
	terminal_preferences_window_bind_data (self);
	return self;
}

TerminalPreferencesWindow*
terminal_preferences_window_new (TerminalWindow* window)
{
	return terminal_preferences_window_construct (TERMINAL_TYPE_PREFERENCES_WINDOW, window);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		TerminalPreferencesWindow* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->t);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gboolean
___lambda33_ (Block2Data* _data2_,
              GBinding* _,
              GValue* from,
              GValue* to)
{
	TerminalPreferencesWindow* self;
	const gchar* _tmp0_;
	TerminalColorSchemeThumbnail* _tmp1_;
	TerminalScheme* _tmp2_;
	TerminalScheme* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GValue _tmp6_ = {0};
	gboolean result;
	self = _data2_->self;
	g_return_val_if_fail (_ != NULL, FALSE);
	g_return_val_if_fail (from != NULL, FALSE);
	g_return_val_if_fail (to != NULL, FALSE);
	_tmp0_ = g_value_get_string (from);
	_tmp1_ = _data2_->t;
	_tmp2_ = terminal_color_scheme_thumbnail_get_scheme (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = terminal_scheme_get_name (_tmp3_);
	_tmp5_ = _tmp4_;
	g_value_init (&_tmp6_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp6_, g_strcmp0 (_tmp0_, _tmp5_) == 0);
	G_IS_VALUE (to) ? (g_value_unset (to), NULL) : NULL;
	*to = _tmp6_;
	result = TRUE;
	return result;
}

static gboolean
____lambda33__gbinding_transform_func (GBinding* binding,
                                       GValue* from_value,
                                       GValue* to_value,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda33_ (self, binding, from_value, to_value);
	return result;
}

static void
__lambda30_ (TerminalPreferencesWindow* self,
             const gchar* name,
             TerminalScheme* scheme)
{
	g_return_if_fail (name != NULL);
	if (scheme != NULL) {
		Block2Data* _data2_;
		TerminalColorSchemeThumbnail* _tmp0_;
		TerminalColorSchemeThumbnail* _tmp1_;
		GtkFlowBox* _tmp2_;
		TerminalColorSchemeThumbnail* _tmp3_;
		_data2_ = g_slice_new0 (Block2Data);
		_data2_->_ref_count_ = 1;
		_data2_->self = g_object_ref (self);
		_tmp0_ = terminal_color_scheme_thumbnail_new (scheme);
		g_object_ref_sink (_tmp0_);
		_data2_->t = _tmp0_;
		_tmp1_ = _data2_->t;
		g_object_bind_property_with_closures ((GObject*) self, "selected-theme", (GObject*) _tmp1_, "selected", G_BINDING_SYNC_CREATE, (GClosure*) ((____lambda33__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) ____lambda33__gbinding_transform_func, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
		_tmp2_ = self->priv->preview_flow_box;
		_tmp3_ = _data2_->t;
		gtk_flow_box_append (_tmp2_, (GtkWidget*) _tmp3_);
		block2_data_unref (_data2_);
		_data2_ = NULL;
	}
}

static void
___lambda30__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
	__lambda30_ ((TerminalPreferencesWindow*) self, (const gchar*) key, (TerminalScheme*) value);
}

static gint
__lambda34_ (TerminalPreferencesWindow* self,
             GtkFlowBoxChild* child1,
             GtkFlowBoxChild* child2)
{
	TerminalColorSchemeThumbnail* a = NULL;
	TerminalColorSchemeThumbnail* _tmp0_;
	TerminalColorSchemeThumbnail* b = NULL;
	TerminalColorSchemeThumbnail* _tmp1_;
	GCompareFunc _tmp2_;
	TerminalScheme* _tmp3_;
	TerminalScheme* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	TerminalScheme* _tmp9_;
	TerminalScheme* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gint _tmp15_;
	gint result;
	g_return_val_if_fail (child1 != NULL, 0);
	g_return_val_if_fail (child2 != NULL, 0);
	_tmp0_ = _g_object_ref0 (TERMINAL_IS_COLOR_SCHEME_THUMBNAIL (child1) ? ((TerminalColorSchemeThumbnail*) child1) : NULL);
	a = _tmp0_;
	_tmp1_ = _g_object_ref0 (TERMINAL_IS_COLOR_SCHEME_THUMBNAIL (child2) ? ((TerminalColorSchemeThumbnail*) child2) : NULL);
	b = _tmp1_;
	_tmp2_ = ((GCompareFunc) g_strcmp0);
	_tmp3_ = terminal_color_scheme_thumbnail_get_scheme (a);
	_tmp4_ = _tmp3_;
	_tmp5_ = terminal_scheme_get_name (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
	_tmp8_ = _tmp7_;
	_tmp9_ = terminal_color_scheme_thumbnail_get_scheme (b);
	_tmp10_ = _tmp9_;
	_tmp11_ = terminal_scheme_get_name (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
	_tmp14_ = _tmp13_;
	_tmp15_ = _tmp2_ (_tmp8_, _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp8_);
	result = _tmp15_;
	_g_object_unref0 (b);
	_g_object_unref0 (a);
	return result;
}

static gint
___lambda34__gtk_flow_box_sort_func (GtkFlowBoxChild* child1,
                                     GtkFlowBoxChild* child2,
                                     gpointer self)
{
	gint result;
	result = __lambda34_ ((TerminalPreferencesWindow*) self, child1, child2);
	return result;
}

static void
terminal_preferences_window_build_ui (TerminalPreferencesWindow* self)
{
	TerminalWindow* _tmp0_;
	TerminalThemeProvider* _tmp1_;
	TerminalThemeProvider* _tmp2_;
	GHashTable* _tmp3_;
	GtkFlowBox* _tmp4_;
	g_return_if_fail (self != NULL);
	terminal_color_scheme_thumbnail_provider_init_resource ();
	_tmp0_ = self->priv->window;
	_tmp1_ = terminal_window_get_theme_provider (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_->themes;
	g_hash_table_foreach (_tmp3_, ___lambda30__gh_func, self);
	_tmp4_ = self->priv->preview_flow_box;
	gtk_flow_box_set_sort_func (_tmp4_, ___lambda34__gtk_flow_box_sort_func, g_object_ref (self), g_object_unref);
}

static gboolean
__lambda35_ (GValue* to_val,
             GVariant* settings_variant)
{
	GValue _tmp0_ = {0};
	gboolean result;
	g_return_val_if_fail (to_val != NULL, FALSE);
	g_return_val_if_fail (settings_variant != NULL, FALSE);
	g_value_init (&_tmp0_, G_TYPE_UINT);
	g_value_set_uint (&_tmp0_, g_variant_get_uint32 (settings_variant));
	*to_val = _tmp0_;
	G_IS_VALUE (&_tmp0_) ? (g_value_unset (&_tmp0_), NULL) : NULL;
	result = TRUE;
	return result;
}

static gboolean
___lambda35__gsettings_bind_get_mapping (GValue* value,
                                         GVariant* variant,
                                         void* user_data)
{
	gboolean result;
	result = __lambda35_ (value, variant);
	return result;
}

static GVariant*
__lambda36_ (GValue* value)
{
	GVariant* _tmp0_;
	GVariant* result;
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = g_variant_new_uint32 ((guint32) ((guint) g_value_get_double (value)));
	g_variant_ref_sink (_tmp0_);
	result = _tmp0_;
	return result;
}

static GVariant*
___lambda36__gsettings_bind_set_mapping (GValue* value,
                                         const GVariantType* expected_type,
                                         void* user_data)
{
	GVariant* result;
	result = __lambda36_ (value);
	return result;
}

static gboolean
__lambda37_ (GValue* to_value,
             GVariant* settings_vari)
{
	GValue _tmp0_ = {0};
	gboolean result;
	g_return_val_if_fail (to_value != NULL, FALSE);
	g_return_val_if_fail (settings_vari != NULL, FALSE);
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp0_, (gdouble) g_variant_get_uint32 (settings_vari));
	*to_value = _tmp0_;
	G_IS_VALUE (&_tmp0_) ? (g_value_unset (&_tmp0_), NULL) : NULL;
	result = TRUE;
	return result;
}

static gboolean
___lambda37__gsettings_bind_get_mapping (GValue* value,
                                         GVariant* variant,
                                         void* user_data)
{
	gboolean result;
	result = __lambda37_ (value, variant);
	return result;
}

static GVariant*
__lambda38_ (GValue* value)
{
	GVariant* _tmp0_;
	GVariant* result;
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = g_variant_new_uint32 ((guint32) g_value_get_double (value));
	g_variant_ref_sink (_tmp0_);
	result = _tmp0_;
	return result;
}

static GVariant*
___lambda38__gsettings_bind_set_mapping (GValue* value,
                                         const GVariantType* expected_type,
                                         void* user_data)
{
	GVariant* result;
	result = __lambda38_ (value);
	return result;
}

static gboolean
__lambda39_ (GValue* to_val,
             GVariant* settings_vari)
{
	TerminalPadding pad = {0};
	TerminalPadding _tmp0_ = {0};
	TerminalPadding _tmp1_;
	GValue _tmp2_ = {0};
	gboolean result;
	g_return_val_if_fail (to_val != NULL, FALSE);
	g_return_val_if_fail (settings_vari != NULL, FALSE);
	terminal_padding_from_variant (settings_vari, &_tmp0_);
	pad = _tmp0_;
	_tmp1_ = pad;
	g_value_init (&_tmp2_, G_TYPE_UINT);
	g_value_set_uint (&_tmp2_, _tmp1_.top);
	*to_val = _tmp2_;
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
	result = TRUE;
	return result;
}

static gboolean
___lambda39__gsettings_bind_get_mapping (GValue* value,
                                         GVariant* variant,
                                         void* user_data)
{
	gboolean result;
	result = __lambda39_ (value, variant);
	return result;
}

static GVariant*
__lambda40_ (GValue* spin_val,
             const GVariantType* _)
{
	guint pad = 0U;
	TerminalPadding _pad = {0};
	TerminalPadding _tmp0_ = {0};
	GVariant* _tmp1_;
	GVariant* result;
	g_return_val_if_fail (spin_val != NULL, NULL);
	g_return_val_if_fail (_ != NULL, NULL);
	pad = (guint) g_value_get_double (spin_val);
	memset (&_tmp0_, 0, sizeof (TerminalPadding));
	_tmp0_.top = pad;
	_tmp0_.right = pad;
	_tmp0_.bottom = pad;
	_tmp0_.left = pad;
	_pad = _tmp0_;
	_tmp1_ = terminal_padding_to_variant (&_pad);
	result = _tmp1_;
	return result;
}

static GVariant*
___lambda40__gsettings_bind_set_mapping (GValue* value,
                                         const GVariantType* expected_type,
                                         void* user_data)
{
	GVariant* result;
	result = __lambda40_ (value, expected_type);
	return result;
}

static gboolean
__lambda41_ (TerminalPreferencesWindow* self,
             GBinding* _,
             GValue* from_value,
             GValue* to_value)
{
	GValue _tmp0_ = {0};
	gboolean result;
	g_return_val_if_fail (_ != NULL, FALSE);
	g_return_val_if_fail (from_value != NULL, FALSE);
	g_return_val_if_fail (to_value != NULL, FALSE);
	g_value_init (&_tmp0_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp0_, g_value_get_uint (from_value) == ((guint) 0));
	G_IS_VALUE (to_value) ? (g_value_unset (to_value), NULL) : NULL;
	*to_value = _tmp0_;
	result = TRUE;
	return result;
}

static gboolean
___lambda41__gbinding_transform_func (GBinding* binding,
                                      GValue* from_value,
                                      GValue* to_value,
                                      gpointer self)
{
	gboolean result;
	result = __lambda41_ ((TerminalPreferencesWindow*) self, binding, from_value, to_value);
	return result;
}

static gboolean
__lambda42_ (TerminalPreferencesWindow* self,
             GBinding* _,
             GValue* mode_value,
             GValue* subtitle)
{
	const gchar* _tmp0_ = NULL;
	GValue _tmp1_ = {0};
	gboolean result;
	g_return_val_if_fail (_ != NULL, FALSE);
	g_return_val_if_fail (mode_value != NULL, FALSE);
	g_return_val_if_fail (subtitle != NULL, FALSE);
	if (g_value_get_uint (mode_value) == ((guint) TERMINAL_SCROLLBACK_MODE_UNLIMITED)) {
		_tmp0_ = TERMINAL_CONSTANTS_INFINITE_SCROLLBACK_WARNING;
	} else {
		_tmp0_ = "";
	}
	g_value_init (&_tmp1_, G_TYPE_STRING);
	g_value_set_string (&_tmp1_, _tmp0_);
	G_IS_VALUE (subtitle) ? (g_value_unset (subtitle), NULL) : NULL;
	*subtitle = _tmp1_;
	result = TRUE;
	return result;
}

static gboolean
___lambda42__gbinding_transform_func (GBinding* binding,
                                      GValue* from_value,
                                      GValue* to_value,
                                      gpointer self)
{
	gboolean result;
	result = __lambda42_ ((TerminalPreferencesWindow*) self, binding, from_value, to_value);
	return result;
}

static void
__lambda43_ (TerminalPreferencesWindow* self,
             GtkFlowBoxChild* child)
{
	TerminalColorSchemeThumbnail* _tmp0_ = NULL;
	TerminalScheme* _tmp1_ = NULL;
	gchar* name = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (child != NULL);
	_tmp0_ = TERMINAL_IS_COLOR_SCHEME_THUMBNAIL (child) ? ((TerminalColorSchemeThumbnail*) child) : NULL;
	_tmp1_ = NULL;
	if (_tmp0_ != NULL) {
		TerminalScheme* _tmp2_;
		TerminalScheme* _tmp3_;
		_tmp2_ = terminal_color_scheme_thumbnail_get_scheme (_tmp0_);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_;
	}
	_tmp4_ = terminal_scheme_get_name (_tmp1_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup (_tmp5_);
	name = _tmp6_;
	terminal_preferences_window_set_selected_theme (self, name);
	_g_free0 (name);
}

static void
___lambda43__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                           GtkFlowBoxChild* child,
                                           gpointer self)
{
	__lambda43_ ((TerminalPreferencesWindow*) self, child);
}

static void
__lambda44_ (TerminalPreferencesWindow* self)
{
	g_object_notify ((GObject*) self, "selected-theme");
	terminal_preferences_window_set_themes_filter_func (self);
}

static void
___lambda44__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda44_ ((TerminalPreferencesWindow*) self);
}

static void
__lambda45_ (TerminalPreferencesWindow* self)
{
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->light_theme_toggle;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		g_object_notify ((GObject*) self, "selected-theme");
	}
}

static void
___lambda45__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda45_ ((TerminalPreferencesWindow*) self);
}

static void
__lambda46_ (TerminalPreferencesWindow* self)
{
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->dark_theme_toggle;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		g_object_notify ((GObject*) self, "selected-theme");
	}
}

static void
___lambda46__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda46_ ((TerminalPreferencesWindow*) self);
}

static void
__lambda47_ (TerminalPreferencesWindow* self)
{
	if (terminal_preferences_window_is_custom_working_directory_valid (self)) {
		AdwEntryRow* _tmp0_;
		_tmp0_ = self->priv->custom_working_directory_entry_row;
		gtk_widget_remove_css_class ((GtkWidget*) _tmp0_, "error");
	} else {
		AdwEntryRow* _tmp1_;
		_tmp1_ = self->priv->custom_working_directory_entry_row;
		gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "error");
	}
}

static void
___lambda47__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda47_ ((TerminalPreferencesWindow*) self);
}

static void
__lambda48_ (TerminalPreferencesWindow* self)
{
	TerminalThemeProvider* _tmp0_;
	TerminalThemeProvider* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	_tmp0_ = terminal_theme_provider_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = terminal_theme_provider_get_is_dark_style_active (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GtkToggleButton* _tmp5_;
		_tmp5_ = self->priv->dark_theme_toggle;
		gtk_toggle_button_set_active (_tmp5_, TRUE);
	} else {
		GtkToggleButton* _tmp6_;
		_tmp6_ = self->priv->light_theme_toggle;
		gtk_toggle_button_set_active (_tmp6_, TRUE);
	}
}

static void
___lambda48__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda48_ ((TerminalPreferencesWindow*) self);
}

static void
__lambda49_ (TerminalPreferencesWindow* self)
{
	terminal_preferences_window_set_themes_filter_func (self);
}

static void
___lambda49__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda49_ ((TerminalPreferencesWindow*) self);
}

static void
terminal_preferences_window_bind_data (TerminalPreferencesWindow* self)
{
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	gboolean is_sixel_supported = FALSE;
	AdwActionRow* _tmp1_;
	GtkLabel* _tmp2_;
	TerminalSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GtkLabel* _tmp6_;
	TerminalSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GtkSwitch* _tmp10_;
	TerminalSettings* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	AdwEntryRow* _tmp14_;
	TerminalSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	AdwEntryRow* _tmp18_;
	TerminalSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GtkSwitch* _tmp22_;
	TerminalSettings* _tmp23_;
	GSettings* _tmp24_;
	GSettings* _tmp25_;
	GtkSwitch* _tmp26_;
	TerminalSettings* _tmp27_;
	GSettings* _tmp28_;
	GSettings* _tmp29_;
	GtkSwitch* _tmp30_;
	TerminalSettings* _tmp31_;
	GSettings* _tmp32_;
	GSettings* _tmp33_;
	GtkSwitch* _tmp34_;
	TerminalSettings* _tmp35_;
	GSettings* _tmp36_;
	GSettings* _tmp37_;
	GtkSpinButton* _tmp38_;
	TerminalSettings* _tmp39_;
	GSettings* _tmp40_;
	GSettings* _tmp41_;
	GtkSwitch* _tmp42_;
	TerminalSettings* _tmp43_;
	GSettings* _tmp44_;
	GSettings* _tmp45_;
	GtkSwitch* _tmp46_;
	TerminalSettings* _tmp47_;
	GSettings* _tmp48_;
	GSettings* _tmp49_;
	GtkSwitch* _tmp50_;
	TerminalSettings* _tmp51_;
	GSettings* _tmp52_;
	GSettings* _tmp53_;
	GtkSwitch* _tmp54_;
	TerminalSettings* _tmp55_;
	GSettings* _tmp56_;
	GSettings* _tmp57_;
	GtkSwitch* _tmp58_;
	TerminalSettings* _tmp59_;
	GSettings* _tmp60_;
	GSettings* _tmp61_;
	GtkSwitch* _tmp62_;
	TerminalSettings* _tmp63_;
	GSettings* _tmp64_;
	GSettings* _tmp65_;
	GtkSwitch* _tmp66_;
	TerminalSettings* _tmp67_;
	GSettings* _tmp68_;
	GSettings* _tmp69_;
	GtkSwitch* _tmp70_;
	TerminalSettings* _tmp71_;
	GSettings* _tmp72_;
	GSettings* _tmp73_;
	GtkSwitch* _tmp74_;
	TerminalSettings* _tmp75_;
	GSettings* _tmp76_;
	GSettings* _tmp77_;
	GtkSpinButton* _tmp78_;
	TerminalSettings* _tmp79_;
	GSettings* _tmp80_;
	GSettings* _tmp81_;
	GtkSpinButton* _tmp82_;
	TerminalSettings* _tmp83_;
	GSettings* _tmp84_;
	GSettings* _tmp85_;
	GtkSwitch* _tmp86_;
	TerminalSettings* _tmp87_;
	GSettings* _tmp88_;
	GSettings* _tmp89_;
	GtkSwitch* _tmp90_;
	TerminalSettings* _tmp91_;
	GSettings* _tmp92_;
	GSettings* _tmp93_;
	GtkSpinButton* _tmp94_;
	TerminalSettings* _tmp95_;
	TerminalSettings* _tmp96_;
	GSettings* _tmp97_;
	GSettings* _tmp98_;
	AdwComboRow* _tmp99_;
	TerminalSettings* _tmp100_;
	GSettings* _tmp101_;
	GSettings* _tmp102_;
	AdwComboRow* _tmp103_;
	TerminalSettings* _tmp104_;
	GSettings* _tmp105_;
	GSettings* _tmp106_;
	AdwEntryRow* _tmp107_;
	TerminalSettings* _tmp108_;
	AdwComboRow* _tmp109_;
	TerminalSettings* _tmp110_;
	GSettings* _tmp111_;
	GSettings* _tmp112_;
	AdwComboRow* _tmp113_;
	TerminalSettings* _tmp114_;
	GSettings* _tmp115_;
	GSettings* _tmp116_;
	AdwComboRow* _tmp117_;
	TerminalSettings* _tmp118_;
	GSettings* _tmp119_;
	GSettings* _tmp120_;
	AdwComboRow* _tmp121_;
	TerminalSettings* _tmp122_;
	GSettings* _tmp123_;
	GSettings* _tmp124_;
	GtkSwitch* _tmp125_;
	TerminalSettings* _tmp126_;
	GSettings* _tmp127_;
	GSettings* _tmp128_;
	GtkAdjustment* _tmp129_;
	TerminalSettings* _tmp130_;
	GSettings* _tmp131_;
	GSettings* _tmp132_;
	GtkAdjustment* _tmp133_;
	TerminalSettings* _tmp134_;
	GSettings* _tmp135_;
	GSettings* _tmp136_;
	GtkAdjustment* _tmp137_;
	TerminalSettings* _tmp138_;
	GSettings* _tmp139_;
	GSettings* _tmp140_;
	GtkAdjustment* _tmp141_;
	GtkFlowBox* _tmp142_;
	GtkToggleButton* _tmp143_;
	TerminalSettings* _tmp144_;
	TerminalSettings* _tmp145_;
	TerminalSettings* _tmp146_;
	TerminalSettings* _tmp147_;
	TerminalThemeProvider* _tmp148_;
	TerminalThemeProvider* _tmp149_;
	gboolean _tmp150_;
	gboolean _tmp151_;
	gboolean _tmp152_;
	TerminalThemeProvider* _tmp155_;
	TerminalThemeProvider* _tmp156_;
	GtkCheckButton* _tmp157_;
	g_return_if_fail (self != NULL);
	_tmp0_ = terminal_settings_get_default ();
	settings = _tmp0_;
	is_sixel_supported = (vte_get_feature_flags () & VTE_FEATURE_FLAG_SIXEL) != 0;
	_tmp1_ = self->priv->use_sixel_action_row;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, is_sixel_supported);
	_tmp2_ = self->priv->no_sixel_support_label;
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, !is_sixel_supported);
	_tmp3_ = settings;
	_tmp4_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->font_label;
	g_settings_bind (_tmp5_, "font", (GObject*) _tmp6_, "label", G_SETTINGS_BIND_DEFAULT);
	_tmp7_ = settings;
	_tmp8_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->run_command_as_login_switch;
	g_settings_bind (_tmp9_, "command-as-login-shell", (GObject*) _tmp10_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp11_ = settings;
	_tmp12_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = self->priv->custom_command_entry_row;
	g_settings_bind (_tmp13_, "custom-shell-command", (GObject*) _tmp14_, "text", G_SETTINGS_BIND_DEFAULT);
	_tmp15_ = settings;
	_tmp16_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->custom_command_entry_row;
	g_settings_bind (_tmp17_, "use-custom-command", (GObject*) _tmp18_, "sensitive", G_SETTINGS_BIND_DEFAULT);
	_tmp19_ = settings;
	_tmp20_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = self->priv->use_custom_shell_command_switch;
	g_settings_bind (_tmp21_, "use-custom-command", (GObject*) _tmp22_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp23_ = settings;
	_tmp24_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = self->priv->notify_process_completion_switch;
	g_settings_bind (_tmp25_, "notify-process-completion", (GObject*) _tmp26_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp27_ = settings;
	_tmp28_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = self->priv->pretty_switch;
	g_settings_bind (_tmp29_, "pretty", (GObject*) _tmp30_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp31_ = settings;
	_tmp32_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp31_);
	_tmp33_ = _tmp32_;
	_tmp34_ = self->priv->bold_is_bright_switch;
	g_settings_bind (_tmp33_, "theme-bold-is-bright", (GObject*) _tmp34_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp35_ = settings;
	_tmp36_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp35_);
	_tmp37_ = _tmp36_;
	_tmp38_ = self->priv->opacity_spin_button;
	g_settings_bind_with_mapping (_tmp37_, "opacity", (GObject*) _tmp38_, "value", G_SETTINGS_BIND_DEFAULT, ___lambda35__gsettings_bind_get_mapping, ___lambda36__gsettings_bind_set_mapping, NULL, NULL);
	_tmp39_ = settings;
	_tmp40_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp39_);
	_tmp41_ = _tmp40_;
	_tmp42_ = self->priv->terminal_bell_switch;
	g_settings_bind (_tmp41_, "terminal-bell", (GObject*) _tmp42_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp43_ = settings;
	_tmp44_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = self->priv->fill_tabs_switch;
	g_settings_bind (_tmp45_, "fill-tabs", (GObject*) _tmp46_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp47_ = settings;
	_tmp48_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp47_);
	_tmp49_ = _tmp48_;
	_tmp50_ = self->priv->show_menu_button_switch;
	g_settings_bind (_tmp49_, "show-menu-button", (GObject*) _tmp50_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp51_ = settings;
	_tmp52_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp51_);
	_tmp53_ = _tmp52_;
	_tmp54_ = self->priv->show_headerbar_switch;
	g_settings_bind (_tmp53_, "show-headerbar", (GObject*) _tmp54_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp55_ = settings;
	_tmp56_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp55_);
	_tmp57_ = _tmp56_;
	_tmp58_ = self->priv->context_aware_header_bar_switch;
	g_settings_bind (_tmp57_, "context-aware-header-bar", (GObject*) _tmp58_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp59_ = settings;
	_tmp60_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp59_);
	_tmp61_ = _tmp60_;
	_tmp62_ = self->priv->drag_area_switch;
	g_settings_bind (_tmp61_, "headerbar-drag-area", (GObject*) _tmp62_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp63_ = settings;
	_tmp64_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp63_);
	_tmp65_ = _tmp64_;
	_tmp66_ = self->priv->easy_copy_paste_switch;
	g_settings_bind (_tmp65_, "easy-copy-paste", (GObject*) _tmp66_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp67_ = settings;
	_tmp68_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp67_);
	_tmp69_ = _tmp68_;
	_tmp70_ = self->priv->show_scrollbars_switch;
	g_settings_bind (_tmp69_, "show-scrollbars", (GObject*) _tmp70_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp71_ = settings;
	_tmp72_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp71_);
	_tmp73_ = _tmp72_;
	_tmp74_ = self->priv->use_overlay_scrolling_switch;
	g_settings_bind (_tmp73_, "use-overlay-scrolling", (GObject*) _tmp74_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp75_ = settings;
	_tmp76_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp75_);
	_tmp77_ = _tmp76_;
	_tmp78_ = self->priv->custom_scrollback_spin_button;
	g_settings_bind (_tmp77_, "scrollback-lines", (GObject*) _tmp78_, "value", G_SETTINGS_BIND_DEFAULT);
	_tmp79_ = settings;
	_tmp80_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp79_);
	_tmp81_ = _tmp80_;
	_tmp82_ = self->priv->custom_scrollback_spin_button;
	g_settings_bind_with_mapping (_tmp81_, "scrollback-lines", (GObject*) _tmp82_, "value", G_SETTINGS_BIND_DEFAULT, ___lambda37__gsettings_bind_get_mapping, ___lambda38__gsettings_bind_set_mapping, NULL, NULL);
	_tmp83_ = settings;
	_tmp84_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp83_);
	_tmp85_ = _tmp84_;
	_tmp86_ = self->priv->use_sixel_switch;
	g_settings_bind (_tmp85_, "use-sixel", (GObject*) _tmp86_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp87_ = settings;
	_tmp88_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp87_);
	_tmp89_ = _tmp88_;
	_tmp90_ = self->priv->remember_window_size_switch;
	g_settings_bind (_tmp89_, "remember-window-size", (GObject*) _tmp90_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp91_ = settings;
	_tmp92_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp91_);
	_tmp93_ = _tmp92_;
	_tmp94_ = self->priv->padding_spin_button;
	g_settings_bind_with_mapping (_tmp93_, "terminal-padding", (GObject*) _tmp94_, "value", G_SETTINGS_BIND_DEFAULT, ___lambda39__gsettings_bind_get_mapping, ___lambda40__gsettings_bind_set_mapping, NULL, NULL);
	_tmp95_ = settings;
	g_object_bind_property_with_closures ((GObject*) _tmp95_, "scrollback-mode", (GObject*) self, "show-custom-scrollback-row", G_BINDING_SYNC_CREATE, (GClosure*) ((___lambda41__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda41__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp96_ = settings;
	_tmp97_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp96_);
	_tmp98_ = _tmp97_;
	_tmp99_ = self->priv->scrollback_mode_combo_row;
	g_settings_bind (_tmp98_, "scrollback-mode", (GObject*) _tmp99_, "selected", G_SETTINGS_BIND_DEFAULT);
	_tmp100_ = settings;
	_tmp101_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp100_);
	_tmp102_ = _tmp101_;
	_tmp103_ = self->priv->working_directory_mode_combo_row;
	g_settings_bind (_tmp102_, "working-directory-mode", (GObject*) _tmp103_, "selected", G_SETTINGS_BIND_DEFAULT);
	_tmp104_ = settings;
	_tmp105_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp104_);
	_tmp106_ = _tmp105_;
	_tmp107_ = self->priv->custom_working_directory_entry_row;
	g_settings_bind (_tmp106_, "custom-working-directory", (GObject*) _tmp107_, "text", G_SETTINGS_BIND_DEFAULT);
	_tmp108_ = settings;
	_tmp109_ = self->priv->scrollback_mode_combo_row;
	g_object_bind_property_with_closures ((GObject*) _tmp108_, "scrollback-mode", (GObject*) _tmp109_, "subtitle", G_BINDING_SYNC_CREATE, (GClosure*) ((___lambda42__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda42__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp110_ = settings;
	_tmp111_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp110_);
	_tmp112_ = _tmp111_;
	_tmp113_ = self->priv->cursor_shape_combo_row;
	g_settings_bind (_tmp112_, "cursor-shape", (GObject*) _tmp113_, "selected", G_SETTINGS_BIND_DEFAULT);
	_tmp114_ = settings;
	_tmp115_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp114_);
	_tmp116_ = _tmp115_;
	_tmp117_ = self->priv->cursor_blink_mode_combo_row;
	g_settings_bind (_tmp116_, "cursor-blink-mode", (GObject*) _tmp117_, "selected", G_SETTINGS_BIND_DEFAULT);
	_tmp118_ = settings;
	_tmp119_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp118_);
	_tmp120_ = _tmp119_;
	_tmp121_ = self->priv->style_preference_combo_row;
	g_settings_bind (_tmp120_, "style-preference", (GObject*) _tmp121_, "selected", G_SETTINGS_BIND_DEFAULT);
	_tmp122_ = settings;
	_tmp123_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp122_);
	_tmp124_ = _tmp123_;
	_tmp125_ = self->priv->floating_controls_switch;
	g_settings_bind (_tmp124_, "floating-controls", (GObject*) _tmp125_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp126_ = settings;
	_tmp127_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp126_);
	_tmp128_ = _tmp127_;
	_tmp129_ = self->priv->floating_controls_hover_area_adjustment;
	g_settings_bind (_tmp128_, "floating-controls-hover-area", (GObject*) _tmp129_, "value", G_SETTINGS_BIND_DEFAULT);
	_tmp130_ = settings;
	_tmp131_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp130_);
	_tmp132_ = _tmp131_;
	_tmp133_ = self->priv->floating_controls_delay_adjustment;
	g_settings_bind (_tmp132_, "delay-before-showing-floating-controls", (GObject*) _tmp133_, "value", G_SETTINGS_BIND_DEFAULT);
	_tmp134_ = settings;
	_tmp135_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp134_);
	_tmp136_ = _tmp135_;
	_tmp137_ = self->priv->cell_width_spacing_adjustment;
	g_settings_bind (_tmp136_, "terminal-cell-width", (GObject*) _tmp137_, "value", G_SETTINGS_BIND_DEFAULT);
	_tmp138_ = settings;
	_tmp139_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp138_);
	_tmp140_ = _tmp139_;
	_tmp141_ = self->priv->cell_height_spacing_adjustment;
	g_settings_bind (_tmp140_, "terminal-cell-height", (GObject*) _tmp141_, "value", G_SETTINGS_BIND_DEFAULT);
	_tmp142_ = self->priv->preview_flow_box;
	g_signal_connect_object (_tmp142_, "child-activated", (GCallback) ___lambda43__gtk_flow_box_child_activated, self, 0);
	_tmp143_ = self->priv->light_theme_toggle;
	g_signal_connect_object ((GObject*) _tmp143_, "notify::active", (GCallback) ___lambda44__g_object_notify, self, 0);
	_tmp144_ = settings;
	g_signal_connect_object ((GObject*) _tmp144_, "notify::theme-light", (GCallback) ___lambda45__g_object_notify, self, 0);
	_tmp145_ = settings;
	g_signal_connect_object ((GObject*) _tmp145_, "notify::theme-dark", (GCallback) ___lambda46__g_object_notify, self, 0);
	_tmp146_ = settings;
	g_signal_connect_object ((GObject*) _tmp146_, "notify::custom-working-directory", (GCallback) ___lambda47__g_object_notify, self, 0);
	_tmp147_ = settings;
	g_object_notify ((GObject*) _tmp147_, "custom-working-directory");
	_tmp148_ = terminal_theme_provider_get_default ();
	_tmp149_ = _tmp148_;
	_tmp150_ = terminal_theme_provider_get_is_dark_style_active (_tmp149_);
	_tmp151_ = _tmp150_;
	_tmp152_ = _tmp151_;
	_g_object_unref0 (_tmp149_);
	if (_tmp152_) {
		GtkToggleButton* _tmp153_;
		_tmp153_ = self->priv->dark_theme_toggle;
		gtk_toggle_button_set_active (_tmp153_, TRUE);
	} else {
		GtkToggleButton* _tmp154_;
		_tmp154_ = self->priv->light_theme_toggle;
		gtk_toggle_button_set_active (_tmp154_, TRUE);
	}
	_tmp155_ = terminal_theme_provider_get_default ();
	_tmp156_ = _tmp155_;
	g_signal_connect_object ((GObject*) _tmp156_, "notify::is-dark-style-active", (GCallback) ___lambda48__g_object_notify, self, 0);
	_g_object_unref0 (_tmp156_);
	_tmp157_ = self->priv->filter_themes_check_button;
	g_signal_connect_object ((GObject*) _tmp157_, "notify::active", (GCallback) ___lambda49__g_object_notify, self, 0);
	terminal_preferences_window_set_themes_filter_func (self);
	_g_object_unref0 (settings);
}

static gboolean
_light_themes_filter_func_gtk_flow_box_filter_func (GtkFlowBoxChild* child,
                                                    gpointer self)
{
	gboolean result;
	result = light_themes_filter_func (child);
	return result;
}

static gboolean
_dark_themes_filter_func_gtk_flow_box_filter_func (GtkFlowBoxChild* child,
                                                   gpointer self)
{
	gboolean result;
	result = dark_themes_filter_func (child);
	return result;
}

static void
terminal_preferences_window_set_themes_filter_func (TerminalPreferencesWindow* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->filter_themes_check_button;
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		GtkFlowBox* _tmp3_;
		_tmp3_ = self->priv->preview_flow_box;
		gtk_flow_box_set_filter_func (_tmp3_, NULL, NULL, NULL);
	} else {
		GtkToggleButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->light_theme_toggle;
		_tmp5_ = gtk_toggle_button_get_active (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_) {
			GtkFlowBox* _tmp7_;
			_tmp7_ = self->priv->preview_flow_box;
			gtk_flow_box_set_filter_func (_tmp7_, _light_themes_filter_func_gtk_flow_box_filter_func, NULL, NULL);
		} else {
			GtkFlowBox* _tmp8_;
			_tmp8_ = self->priv->preview_flow_box;
			gtk_flow_box_set_filter_func (_tmp8_, _dark_themes_filter_func_gtk_flow_box_filter_func, NULL, NULL);
		}
	}
}

static void
terminal_preferences_window_do_reset_preferences (TerminalPreferencesWindow* self)
{
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettingsSchema* _tmp4_;
	GSettingsSchema* _tmp5_;
	GSettingsSchema* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = terminal_settings_get_default ();
	settings = _tmp0_;
	_tmp1_ = settings;
	_tmp2_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp1_);
	_tmp3_ = _tmp2_;
	g_object_get (_tmp3_, "settings-schema", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp8_ = _tmp7_ = g_settings_schema_list_keys (_tmp6_);
	_tmp9_ = _tmp8_;
	_tmp9__length1 = _vala_array_length (_tmp7_);
	_g_settings_schema_unref0 (_tmp6_);
	{
		gchar** key_collection = NULL;
		gint key_collection_length1 = 0;
		gint _key_collection_size_ = 0;
		gint key_it = 0;
		key_collection = _tmp9_;
		key_collection_length1 = _tmp9__length1;
		for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
			gchar* _tmp10_;
			gchar* key = NULL;
			_tmp10_ = g_strdup (key_collection[key_it]);
			key = _tmp10_;
			{
				TerminalSettings* _tmp11_;
				GSettings* _tmp12_;
				GSettings* _tmp13_;
				const gchar* _tmp14_;
				_tmp11_ = settings;
				_tmp12_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = key;
				g_settings_reset (_tmp13_, _tmp14_);
				_g_free0 (key);
			}
		}
		key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_object_unref0 (settings);
}

static gboolean
terminal_preferences_window_is_custom_working_directory_valid (TerminalPreferencesWindow* self)
{
	gchar* filename = NULL;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = terminal_settings_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = terminal_settings_get_custom_working_directory (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp1_);
	filename = _tmp5_;
	result = g_file_test (filename, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_DIR);
	_g_free0 (filename);
	return result;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		TerminalPreferencesWindow* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->fc);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gboolean
__lambda50_ (TerminalPreferencesWindow* self,
             PangoFontFamily* desc)
{
	gboolean result;
	g_return_val_if_fail (desc != NULL, FALSE);
	result = pango_font_family_is_monospace (desc);
	return result;
}

static gboolean
___lambda50__gtk_font_filter_func (PangoFontFamily* family,
                                   PangoFontFace* face,
                                   gpointer self)
{
	gboolean result;
	result = __lambda50_ ((TerminalPreferencesWindow*) self, family);
	return result;
}

static void
__lambda51_ (Block3Data* _data3_,
             gint response)
{
	TerminalPreferencesWindow* self;
	gboolean _tmp0_ = FALSE;
	self = _data3_->self;
	if (response == ((gint) GTK_RESPONSE_OK)) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = gtk_font_chooser_get_font ((GtkFontChooser*) _data3_->fc);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_ != NULL;
		_g_free0 (_tmp3_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		TerminalSettings* _tmp4_;
		TerminalSettings* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp4_ = terminal_settings_get_default ();
		_tmp5_ = _tmp4_;
		_tmp6_ = gtk_font_chooser_get_font ((GtkFontChooser*) _data3_->fc);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_;
		terminal_settings_set_font (_tmp5_, _tmp8_);
		_g_free0 (_tmp8_);
		_g_object_unref0 (_tmp5_);
	}
	gtk_window_destroy ((GtkWindow*) _data3_->fc);
}

static void
___lambda51__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda51_ (self, response_id);
}

static void
terminal_preferences_window_on_font_row_activated (TerminalPreferencesWindow* self)
{
	Block3Data* _data3_;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GtkFontChooserDialog* _tmp5_ = NULL;
	GtkFontChooserDialog* _tmp6_;
	g_return_if_fail (self != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = terminal_settings_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = terminal_settings_get_font (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup (_tmp3_);
	_tmp5_ = (GtkFontChooserDialog*) gtk_font_chooser_dialog_new (_ ("Terminal Font"), (GtkWindow*) self);
	gtk_font_chooser_set_level ((GtkFontChooser*) _tmp5_, (GTK_FONT_CHOOSER_LEVEL_FAMILY | GTK_FONT_CHOOSER_LEVEL_SIZE) | GTK_FONT_CHOOSER_LEVEL_STYLE);
	gtk_font_chooser_set_font ((GtkFontChooser*) _tmp5_, _tmp4_);
	_g_free0 (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp1_);
	_data3_->fc = _tmp6_;
	gtk_font_chooser_set_filter_func ((GtkFontChooser*) _data3_->fc, ___lambda50__gtk_font_filter_func, g_object_ref (self), g_object_unref);
	g_signal_connect_data ((GtkDialog*) _data3_->fc, "response", (GCallback) ___lambda51__gtk_dialog_response, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, G_CONNECT_AFTER);
	gtk_widget_show ((GtkWidget*) _data3_->fc);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static void
_terminal_preferences_window_on_font_row_activated_adw_action_row_activated (AdwActionRow* _sender,
                                                                             gpointer self)
{
	terminal_preferences_window_on_font_row_activated ((TerminalPreferencesWindow*) self);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		TerminalPreferencesWindow* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->d);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
__lambda52_ (Block4Data* _data4_,
             gint response)
{
	TerminalPreferencesWindow* self;
	GtkMessageDialog* _tmp0_;
	self = _data4_->self;
	if (response == ((gint) GTK_RESPONSE_YES)) {
		terminal_preferences_window_do_reset_preferences (self);
	}
	_tmp0_ = _data4_->d;
	gtk_window_destroy ((GtkWindow*) _tmp0_);
}

static void
___lambda52__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda52_ (self, response_id);
}

static void
terminal_preferences_window_on_reset_request (TerminalPreferencesWindow* self)
{
	Block4Data* _data4_;
	GtkMessageDialog* _tmp0_;
	GtkWidget* yes_button = NULL;
	GtkMessageDialog* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_ = NULL;
	GtkWidget* _tmp5_;
	GtkWidget* no_button = NULL;
	GtkMessageDialog* _tmp6_;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_ = NULL;
	GtkWidget* _tmp10_;
	GtkMessageDialog* _tmp11_;
	GtkMessageDialog* _tmp12_;
	GtkMessageDialog* _tmp13_;
	g_return_if_fail (self != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, "Are you sure you want to reset all settings?");
	g_object_ref_sink (_tmp0_);
	_data4_->d = _tmp0_;
	_tmp1_ = _data4_->d;
	_tmp2_ = gtk_dialog_get_widget_for_response ((GtkDialog*) _tmp1_, (gint) GTK_RESPONSE_YES);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	yes_button = _tmp3_;
	_tmp5_ = yes_button;
	_tmp4_ = _tmp5_;
	if (_tmp4_ != NULL) {
		gtk_widget_add_css_class (_tmp4_, "destructive-action");
	}
	_tmp6_ = _data4_->d;
	_tmp7_ = gtk_dialog_get_widget_for_response ((GtkDialog*) _tmp6_, (gint) GTK_RESPONSE_NO);
	_tmp8_ = _g_object_ref0 (_tmp7_);
	no_button = _tmp8_;
	_tmp10_ = no_button;
	_tmp9_ = _tmp10_;
	if (_tmp9_ != NULL) {
		gtk_widget_add_css_class (_tmp9_, "suggested-action");
	}
	_tmp11_ = _data4_->d;
	gtk_dialog_set_default_response ((GtkDialog*) _tmp11_, (gint) GTK_RESPONSE_NO);
	_tmp12_ = _data4_->d;
	g_signal_connect_data ((GtkDialog*) _tmp12_, "response", (GCallback) ___lambda52__gtk_dialog_response, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp13_ = _data4_->d;
	gtk_window_present ((GtkWindow*) _tmp13_);
	_g_object_unref0 (no_button);
	_g_object_unref0 (yes_button);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static void
_terminal_preferences_window_on_reset_request_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
	terminal_preferences_window_on_reset_request ((TerminalPreferencesWindow*) self);
}

static void
terminal_preferences_window_on_get_more_themes_online (TerminalPreferencesWindow* self)
{
	GtkUriLauncher* _tmp0_;
	GtkUriLauncher* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_uri_launcher_new ("https://github.com/storm119/Tilix-Themes");
	_tmp1_ = _tmp0_;
	gtk_uri_launcher_launch (_tmp1_, NULL, NULL, NULL, NULL);
	_g_object_unref0 (_tmp1_);
}

static void
_terminal_preferences_window_on_get_more_themes_online_gtk_button_clicked (GtkButton* _sender,
                                                                           gpointer self)
{
	terminal_preferences_window_on_get_more_themes_online ((TerminalPreferencesWindow*) self);
}

static void
terminal_preferences_window_on_open_themes_folder (TerminalPreferencesWindow* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GtkFileLauncher* _tmp4_;
	GtkFileLauncher* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = terminal_constants_get_user_schemes_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_new_for_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_file_launcher_new (_tmp3_);
	_tmp5_ = _tmp4_;
	gtk_file_launcher_launch (_tmp5_, NULL, NULL, NULL, NULL);
	_g_object_unref0 (_tmp5_);
	_g_object_unref0 (_tmp3_);
	_g_free0 (_tmp1_);
}

static void
_terminal_preferences_window_on_open_themes_folder_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
	terminal_preferences_window_on_open_themes_folder ((TerminalPreferencesWindow*) self);
}

static gboolean
terminal_preferences_window_show_custom_working_directory_entry_row (TerminalPreferencesWindow* self,
                                                                     TerminalWorkingDirectoryMode cwd_mode)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = cwd_mode == TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM;
	return result;
}

static gchar*
terminal_preferences_window_explain_working_directory_mode (TerminalPreferencesWindow* self,
                                                            TerminalWorkingDirectoryMode cwd_mode)
{
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	switch (cwd_mode) {
		case TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Reuse previous tab's directory."));
			result = _tmp0_;
			return result;
		}
		case TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Use the current user's home as working directory."));
			result = _tmp1_;
			return result;
		}
		case TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Use a custom path as working directory."));
			result = _tmp2_;
			return result;
		}
		default:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("");
			result = _tmp3_;
			return result;
		}
	}
}

static void
terminal_preferences_window_set_custom_working_dir_to_home (TerminalPreferencesWindow* self)
{
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = terminal_settings_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_get_home_dir ();
	terminal_settings_set_custom_working_directory (_tmp1_, _tmp2_);
	_g_object_unref0 (_tmp1_);
}

static void
_terminal_preferences_window_set_custom_working_dir_to_home_gtk_button_clicked (GtkButton* _sender,
                                                                                gpointer self)
{
	terminal_preferences_window_set_custom_working_dir_to_home ((TerminalPreferencesWindow*) self);
}

gboolean
terminal_preferences_window_get_show_custom_scrollback_row (TerminalPreferencesWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_custom_scrollback_row;
	return result;
}

void
terminal_preferences_window_set_show_custom_scrollback_row (TerminalPreferencesWindow* self,
                                                            gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_preferences_window_get_show_custom_scrollback_row (self);
	if (old_value != value) {
		self->priv->_show_custom_scrollback_row = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_preferences_window_properties[TERMINAL_PREFERENCES_WINDOW_SHOW_CUSTOM_SCROLLBACK_ROW_PROPERTY]);
	}
}

const gchar*
terminal_preferences_window_get_selected_theme (TerminalPreferencesWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->light_theme_toggle;
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		TerminalSettings* _tmp4_;
		TerminalSettings* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp4_ = terminal_settings_get_default ();
		_tmp5_ = _tmp4_;
		_tmp6_ = terminal_settings_get_theme_light (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp0_ = _tmp7_;
		_g_object_unref0 (_tmp5_);
	} else {
		TerminalSettings* _tmp8_;
		TerminalSettings* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp8_ = terminal_settings_get_default ();
		_tmp9_ = _tmp8_;
		_tmp10_ = terminal_settings_get_theme_dark (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp0_ = _tmp11_;
		_g_object_unref0 (_tmp9_);
	}
	result = _tmp0_;
	return result;
}

void
terminal_preferences_window_set_selected_theme (TerminalPreferencesWindow* self,
                                                const gchar* value)
{
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->light_theme_toggle;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		TerminalSettings* _tmp3_;
		TerminalSettings* _tmp4_;
		_tmp3_ = terminal_settings_get_default ();
		_tmp4_ = _tmp3_;
		terminal_settings_set_theme_light (_tmp4_, value);
		_g_object_unref0 (_tmp4_);
	} else {
		TerminalSettings* _tmp5_;
		TerminalSettings* _tmp6_;
		_tmp5_ = terminal_settings_get_default ();
		_tmp6_ = _tmp5_;
		terminal_settings_set_theme_dark (_tmp6_, value);
		_g_object_unref0 (_tmp6_);
	}
	g_object_notify_by_pspec ((GObject *) self, terminal_preferences_window_properties[TERMINAL_PREFERENCES_WINDOW_SELECTED_THEME_PROPERTY]);
}

static GObject *
terminal_preferences_window_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TerminalPreferencesWindow * self;
	parent_class = G_OBJECT_CLASS (terminal_preferences_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_PREFERENCES_WINDOW, TerminalPreferencesWindow);
	if (TERMINAL_DEVEL) {
		gtk_widget_add_css_class ((GtkWidget*) self, "devel");
	}
	return obj;
}

static void
terminal_preferences_window_class_init (TerminalPreferencesWindowClass * klass,
                                        gpointer klass_data)
{
	GTypeClass* _tmp0_;
	GTypeClass* _tmp1_;
	terminal_preferences_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminalPreferencesWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_preferences_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_preferences_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = terminal_preferences_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = terminal_preferences_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PREFERENCES_WINDOW_SHOW_CUSTOM_SCROLLBACK_ROW_PROPERTY, terminal_preferences_window_properties[TERMINAL_PREFERENCES_WINDOW_SHOW_CUSTOM_SCROLLBACK_ROW_PROPERTY] = g_param_spec_boolean ("show-custom-scrollback-row", "show-custom-scrollback-row", "show-custom-scrollback-row", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PREFERENCES_WINDOW_SELECTED_THEME_PROPERTY, terminal_preferences_window_properties[TERMINAL_PREFERENCES_WINDOW_SELECTED_THEME_PROPERTY] = g_param_spec_string ("selected-theme", "selected-theme", "selected-theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/raggesilver/BlackBox/gtk/preferences-window.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_sixel_action_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, use_sixel_action_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cursor_shape_combo_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, cursor_shape_combo_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cursor_blink_mode_combo_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, cursor_blink_mode_combo_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scrollback_mode_combo_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, scrollback_mode_combo_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "working_directory_mode_combo_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, working_directory_mode_combo_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "style_preference_combo_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, style_preference_combo_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_command_entry_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, custom_command_entry_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_working_directory_entry_row", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, custom_working_directory_entry_row));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cell_height_spacing_adjustment", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, cell_height_spacing_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cell_width_spacing_adjustment", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, cell_width_spacing_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_scrollback_adjustment", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, custom_scrollback_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "floating_controls_delay_adjustment", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, floating_controls_delay_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "floating_controls_hover_area_adjustment", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, floating_controls_hover_area_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "filter_themes_check_button", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, filter_themes_check_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_flow_box", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, preview_flow_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "font_label", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, font_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "no_sixel_support_label", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, no_sixel_support_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_scrollback_spin_button", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, custom_scrollback_spin_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "padding_spin_button", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, padding_spin_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_copy_paste_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, easy_copy_paste_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fill_tabs_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, fill_tabs_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "floating_controls_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, floating_controls_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_sixel_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, use_sixel_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pretty_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, pretty_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bold_is_bright_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, bold_is_bright_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "opacity_spin_button", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, opacity_spin_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "remember_window_size_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, remember_window_size_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "run_command_as_login_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, run_command_as_login_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_headerbar_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, show_headerbar_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "context_aware_header_bar_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, context_aware_header_bar_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_menu_button_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, show_menu_button_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_scrollbars_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, show_scrollbars_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_custom_shell_command_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, use_custom_shell_command_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_overlay_scrolling_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, use_overlay_scrolling_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "drag_area_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, drag_area_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "terminal_bell_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, terminal_bell_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notify_process_completion_switch", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, notify_process_completion_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "dark_theme_toggle", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, dark_theme_toggle));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "light_theme_toggle", FALSE, TerminalPreferencesWindow_private_offset + G_STRUCT_OFFSET (TerminalPreferencesWindowPrivate, light_theme_toggle));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_font_row_activated", G_CALLBACK(_terminal_preferences_window_on_font_row_activated_adw_action_row_activated));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_reset_request", G_CALLBACK(_terminal_preferences_window_on_reset_request_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_get_more_themes_online", G_CALLBACK(_terminal_preferences_window_on_get_more_themes_online_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_open_themes_folder", G_CALLBACK(_terminal_preferences_window_on_open_themes_folder_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "show_custom_working_directory_entry_row", G_CALLBACK(terminal_preferences_window_show_custom_working_directory_entry_row));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "explain_working_directory_mode", G_CALLBACK(terminal_preferences_window_explain_working_directory_mode));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "set_custom_working_dir_to_home", G_CALLBACK(_terminal_preferences_window_set_custom_working_dir_to_home_gtk_button_clicked));
	_tmp0_ = g_type_class_ref (TERMINAL_TYPE_SHORTCUT_EDITOR);
	_tmp1_ = _tmp0_;
	_g_type_class_unref0 (_tmp1_);
}

static void
terminal_preferences_window_instance_init (TerminalPreferencesWindow * self,
                                           gpointer klass)
{
	self->priv = terminal_preferences_window_get_instance_private (self);
	self->priv->_show_custom_scrollback_row = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
terminal_preferences_window_finalize (GObject * obj)
{
	TerminalPreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_PREFERENCES_WINDOW, TerminalPreferencesWindow);
	_g_object_unref0 (self->priv->window);
	G_OBJECT_CLASS (terminal_preferences_window_parent_class)->finalize (obj);
}

static GType
terminal_preferences_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalPreferencesWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_preferences_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalPreferencesWindow), 0, (GInstanceInitFunc) terminal_preferences_window_instance_init, NULL };
	GType terminal_preferences_window_type_id;
	terminal_preferences_window_type_id = g_type_register_static (adw_preferences_window_get_type (), "TerminalPreferencesWindow", &g_define_type_info, 0);
	TerminalPreferencesWindow_private_offset = g_type_add_instance_private (terminal_preferences_window_type_id, sizeof (TerminalPreferencesWindowPrivate));
	return terminal_preferences_window_type_id;
}

GType
terminal_preferences_window_get_type (void)
{
	static volatile gsize terminal_preferences_window_type_id__once = 0;
	if (g_once_init_enter (&terminal_preferences_window_type_id__once)) {
		GType terminal_preferences_window_type_id;
		terminal_preferences_window_type_id = terminal_preferences_window_get_type_once ();
		g_once_init_leave (&terminal_preferences_window_type_id__once, terminal_preferences_window_type_id);
	}
	return terminal_preferences_window_type_id__once;
}

static void
_vala_terminal_preferences_window_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	TerminalPreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_PREFERENCES_WINDOW, TerminalPreferencesWindow);
	switch (property_id) {
		case TERMINAL_PREFERENCES_WINDOW_SHOW_CUSTOM_SCROLLBACK_ROW_PROPERTY:
		g_value_set_boolean (value, terminal_preferences_window_get_show_custom_scrollback_row (self));
		break;
		case TERMINAL_PREFERENCES_WINDOW_SELECTED_THEME_PROPERTY:
		g_value_set_string (value, terminal_preferences_window_get_selected_theme (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_terminal_preferences_window_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	TerminalPreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_PREFERENCES_WINDOW, TerminalPreferencesWindow);
	switch (property_id) {
		case TERMINAL_PREFERENCES_WINDOW_SHOW_CUSTOM_SCROLLBACK_ROW_PROPERTY:
		terminal_preferences_window_set_show_custom_scrollback_row (self, g_value_get_boolean (value));
		break;
		case TERMINAL_PREFERENCES_WINDOW_SELECTED_THEME_PROPERTY:
		terminal_preferences_window_set_selected_theme (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

