/* ShortcutDialog.c generated by valac 0.56.17, the Vala compiler
 * generated from ShortcutDialog.vala, do not modify */

/* ShortcutDialog.vala
 *
 * Copyright 2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define TERMINAL_DEVEL FALSE
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_SHORTCUT_DIALOG (terminal_shortcut_dialog_get_type ())
#define TERMINAL_SHORTCUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog))
#define TERMINAL_SHORTCUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialogClass))
#define TERMINAL_IS_SHORTCUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SHORTCUT_DIALOG))
#define TERMINAL_IS_SHORTCUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SHORTCUT_DIALOG))
#define TERMINAL_SHORTCUT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialogClass))

typedef struct _TerminalShortcutDialog TerminalShortcutDialog;
typedef struct _TerminalShortcutDialogClass TerminalShortcutDialogClass;
typedef struct _TerminalShortcutDialogPrivate TerminalShortcutDialogPrivate;
enum  {
	TERMINAL_SHORTCUT_DIALOG_0_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY,
	TERMINAL_SHORTCUT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_KEYMAP (terminal_keymap_get_type ())
#define TERMINAL_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymap))
#define TERMINAL_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))
#define TERMINAL_IS_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_IS_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_KEYMAP))
#define TERMINAL_KEYMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_KEYMAP, TerminalKeymapClass))

typedef struct _TerminalKeymap TerminalKeymap;
typedef struct _TerminalKeymapClass TerminalKeymapClass;
enum  {
	TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL,
	TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL,
	TERMINAL_SHORTCUT_DIALOG_NUM_SIGNALS
};
static guint terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_NUM_SIGNALS] = {0};

struct _TerminalShortcutDialog {
	AdwWindow parent_instance;
	TerminalShortcutDialogPrivate * priv;
};

struct _TerminalShortcutDialogClass {
	AdwWindowClass parent_class;
};

struct _TerminalShortcutDialogPrivate {
	gchar* _shortcut_name;
	gchar* _current_accel;
	gchar* _new_accel;
	gboolean _is_in_use;
	gboolean _is_shortcut_set;
	GtkShortcutLabel* shortcut_label;
};

static gint TerminalShortcutDialog_private_offset;
static gpointer terminal_shortcut_dialog_parent_class = NULL;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_ESCAPE;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_ESCAPE = NULL;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_BACKSPACE;
static GtkKeyvalTrigger* terminal_shortcut_dialog_JUST_BACKSPACE = NULL;

VALA_EXTERN GType terminal_shortcut_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalShortcutDialog, g_object_unref)
static void terminal_shortcut_dialog_setup_key_controller (TerminalShortcutDialog* self);
static gboolean __lambda56_ (TerminalShortcutDialog* self,
                      GtkEventControllerKey* event,
                      guint keyval,
                      guint _keycode,
                      GdkModifierType modifier);
static void terminal_shortcut_dialog_cancel (TerminalShortcutDialog* self);
static void terminal_shortcut_dialog_apply (TerminalShortcutDialog* self);
static GdkModifierType* _gdk_modifier_type_dup (GdkModifierType* self);
VALA_EXTERN GType terminal_keymap_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalKeymap, g_object_unref)
VALA_EXTERN TerminalKeymap* terminal_keymap_get_default (void);
VALA_EXTERN gchar* terminal_keymap_get_action_for_shortcut (TerminalKeymap* self,
                                                const gchar* shortcut);
static void terminal_shortcut_dialog_set_is_in_use (TerminalShortcutDialog* self,
                                             gboolean value);
VALA_EXTERN gboolean terminal_shortcut_dialog_get_is_in_use (TerminalShortcutDialog* self);
VALA_EXTERN void terminal_shortcut_dialog_set_is_shortcut_set (TerminalShortcutDialog* self,
                                                   gboolean value);
VALA_EXTERN gboolean terminal_shortcut_dialog_get_is_shortcut_set (TerminalShortcutDialog* self);
static gboolean ___lambda56__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                            guint keyval,
                                                            guint keycode,
                                                            GdkModifierType state,
                                                            gpointer self);
static void _terminal_shortcut_dialog_cancel_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void _terminal_shortcut_dialog_apply_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self);
VALA_EXTERN TerminalShortcutDialog* terminal_shortcut_dialog_new (void);
VALA_EXTERN TerminalShortcutDialog* terminal_shortcut_dialog_construct (GType object_type);
VALA_EXTERN const gchar* terminal_shortcut_dialog_get_shortcut_name (TerminalShortcutDialog* self);
VALA_EXTERN void terminal_shortcut_dialog_set_shortcut_name (TerminalShortcutDialog* self,
                                                 const gchar* value);
VALA_EXTERN const gchar* terminal_shortcut_dialog_get_current_accel (TerminalShortcutDialog* self);
VALA_EXTERN void terminal_shortcut_dialog_set_current_accel (TerminalShortcutDialog* self,
                                                 const gchar* value);
VALA_EXTERN const gchar* terminal_shortcut_dialog_get_new_accel (TerminalShortcutDialog* self);
static void terminal_shortcut_dialog_set_new_accel (TerminalShortcutDialog* self,
                                             const gchar* value);
VALA_EXTERN gchar* terminal_shortcut_dialog_get_heading_text (TerminalShortcutDialog* self);
static GObject * terminal_shortcut_dialog_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _gtk_window_close_terminal_shortcut_dialog_response (TerminalShortcutDialog* _sender,
                                                          GtkResponseType response,
                                                          gpointer self);
static void _terminal_shortcut_dialog___lambda57_ (TerminalShortcutDialog* self);
static void __terminal_shortcut_dialog___lambda57__g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static gboolean _terminal_shortcut_dialog___lambda58_ (TerminalShortcutDialog* self,
                                                GBinding* _binding,
                                                GValue* from_value,
                                                GValue* to_value_ref);
static gboolean __terminal_shortcut_dialog___lambda58__gbinding_transform_func (GBinding* binding,
                                                                         GValue* from_value,
                                                                         GValue* to_value,
                                                                         gpointer self);
static void terminal_shortcut_dialog_finalize (GObject * obj);
static GType terminal_shortcut_dialog_get_type_once (void);
static void _vala_terminal_shortcut_dialog_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_terminal_shortcut_dialog_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
terminal_shortcut_dialog_get_instance_private (TerminalShortcutDialog* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalShortcutDialog_private_offset);
}

static GdkModifierType*
_gdk_modifier_type_dup (GdkModifierType* self)
{
	GdkModifierType* dup;
	dup = g_new0 (GdkModifierType, 1);
	memcpy (dup, self, sizeof (GdkModifierType));
	return dup;
}

static gpointer
__gdk_modifier_type_dup0 (gpointer self)
{
	return self ? _gdk_modifier_type_dup (self) : NULL;
}

static gboolean
__lambda56_ (TerminalShortcutDialog* self,
             GtkEventControllerKey* event,
             guint keyval,
             guint _keycode,
             GdkModifierType modifier)
{
	static const GdkModifierType valid_modifiers = (GDK_CONTROL_MASK | GDK_SHIFT_MASK) | GDK_ALT_MASK;
	GdkModifierType real_modifiers = 0U;
	GtkKeyvalTrigger* k = NULL;
	GtkKeyvalTrigger* _tmp0_;
	GtkKeyvalTrigger* _tmp1_;
	GtkKeyvalTrigger* _tmp2_;
	guint accel_key = 0U;
	GdkModifierType mods = 0U;
	gboolean is_valid_gtk_accel = FALSE;
	GtkKeyvalTrigger* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	guint _tmp8_ = 0U;
	GdkModifierType _tmp9_ = 0U;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GdkKeyEvent* _tmp12_ = NULL;
	GdkEvent* _tmp13_;
	GdkModifierType* _tmp14_ = NULL;
	GdkModifierType* _tmp17_ = NULL;
	GdkModifierType* _tmp18_;
	GdkModifierType consumed = 0U;
	GdkModifierType* _tmp21_;
	GdkModifierType* _tmp22_;
	GdkModifierType _tmp23_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean is_valid = FALSE;
	GtkShortcutLabel* _tmp31_;
	GtkKeyvalTrigger* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	TerminalKeymap* _tmp35_;
	TerminalKeymap* _tmp36_;
	GtkKeyvalTrigger* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gboolean _tmp42_ = FALSE;
	gchar* _tmp44_ = NULL;
	gboolean _tmp45_;
	gboolean result;
	g_return_val_if_fail (event != NULL, FALSE);
	real_modifiers = valid_modifiers & modifier;
	_tmp0_ = (GtkKeyvalTrigger*) gtk_keyval_trigger_new (keyval, real_modifiers);
	k = _tmp0_;
	_tmp1_ = k;
	_tmp2_ = terminal_shortcut_dialog_JUST_ESCAPE;
	if (gtk_shortcut_trigger_compare ((GtkShortcutTrigger*) _tmp1_, (GtkShortcutTrigger*) _tmp2_) == 0) {
		terminal_shortcut_dialog_cancel (self);
		result = FALSE;
		_g_object_unref0 (k);
		return result;
	} else {
		GtkKeyvalTrigger* _tmp3_;
		GtkKeyvalTrigger* _tmp4_;
		_tmp3_ = k;
		_tmp4_ = terminal_shortcut_dialog_JUST_BACKSPACE;
		if (gtk_shortcut_trigger_compare ((GtkShortcutTrigger*) _tmp3_, (GtkShortcutTrigger*) _tmp4_) == 0) {
			g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL], 0, NULL);
			terminal_shortcut_dialog_apply (self);
			result = TRUE;
			_g_object_unref0 (k);
			return result;
		}
	}
	accel_key = (guint) 0;
	mods = 0;
	_tmp5_ = k;
	_tmp6_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp10_ = gtk_accelerator_parse (_tmp7_, &_tmp8_, &_tmp9_);
	accel_key = _tmp8_;
	mods = _tmp9_;
	_tmp11_ = _tmp10_;
	_g_free0 (_tmp7_);
	is_valid_gtk_accel = _tmp11_;
	_tmp13_ = gtk_event_controller_get_current_event ((GtkEventController*) event);
	_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, gdk_key_event_get_type ()) ? ((GdkKeyEvent*) _tmp13_) : NULL;
	_tmp14_ = NULL;
	if (_tmp12_ != NULL) {
		GdkModifierType _tmp15_;
		GdkModifierType* _tmp16_;
		_tmp15_ = gdk_key_event_get_consumed_modifiers (_tmp12_);
		_tmp16_ = __gdk_modifier_type_dup0 (&_tmp15_);
		_g_free0 (_tmp14_);
		_tmp14_ = _tmp16_;
	}
	_tmp18_ = _tmp14_;
	_tmp14_ = NULL;
	_tmp17_ = _tmp18_;
	if (_tmp17_ == NULL) {
		GdkModifierType _tmp19_;
		GdkModifierType* _tmp20_;
		_tmp19_ = 0;
		_tmp20_ = __gdk_modifier_type_dup0 (&_tmp19_);
		_g_free0 (_tmp17_);
		_tmp17_ = _tmp20_;
	}
	_tmp21_ = _tmp17_;
	_tmp17_ = NULL;
	_tmp22_ = _tmp21_;
	_tmp23_ = *_tmp22_;
	_g_free0 (_tmp22_);
	consumed = _tmp23_;
	mods &= ~consumed;
	if (is_valid_gtk_accel) {
		const gchar* _tmp27_;
		_tmp27_ = gdk_keyval_name (keyval);
		_tmp26_ = !g_str_has_suffix (_tmp27_, "_L");
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		const gchar* _tmp28_;
		_tmp28_ = gdk_keyval_name (keyval);
		_tmp25_ = !g_str_has_suffix (_tmp28_, "_R");
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		gboolean _tmp29_ = FALSE;
		gboolean _tmp30_ = FALSE;
		if (keyval >= GDK_KEY_F1) {
			_tmp30_ = keyval <= GDK_KEY_F35;
		} else {
			_tmp30_ = FALSE;
		}
		if (_tmp30_) {
			_tmp29_ = TRUE;
		} else {
			_tmp29_ = mods > 0;
		}
		_tmp24_ = _tmp29_;
	} else {
		_tmp24_ = FALSE;
	}
	is_valid = _tmp24_;
	_tmp31_ = self->priv->shortcut_label;
	_tmp32_ = k;
	_tmp33_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp32_);
	_tmp34_ = _tmp33_;
	gtk_shortcut_label_set_accelerator (_tmp31_, _tmp34_);
	_g_free0 (_tmp34_);
	_tmp35_ = terminal_keymap_get_default ();
	_tmp36_ = _tmp35_;
	_tmp37_ = k;
	_tmp38_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp37_);
	_tmp39_ = _tmp38_;
	_tmp40_ = terminal_keymap_get_action_for_shortcut (_tmp36_, _tmp39_);
	_tmp41_ = _tmp40_;
	terminal_shortcut_dialog_set_is_in_use (self, _tmp41_ != NULL);
	_g_free0 (_tmp41_);
	_g_free0 (_tmp39_);
	_g_object_unref0 (_tmp36_);
	if (is_valid) {
		gboolean _tmp43_;
		_tmp43_ = self->priv->_is_in_use;
		_tmp42_ = !_tmp43_;
	} else {
		_tmp42_ = FALSE;
	}
	terminal_shortcut_dialog_set_is_shortcut_set (self, _tmp42_);
	_tmp45_ = self->priv->_is_shortcut_set;
	if (_tmp45_) {
		GtkKeyvalTrigger* _tmp46_;
		gchar* _tmp47_;
		_tmp46_ = k;
		_tmp47_ = gtk_shortcut_trigger_to_string ((GtkShortcutTrigger*) _tmp46_);
		_g_free0 (_tmp44_);
		_tmp44_ = _tmp47_;
	} else {
		_g_free0 (_tmp44_);
		_tmp44_ = NULL;
	}
	g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL], 0, _tmp44_);
	result = TRUE;
	_g_free0 (_tmp44_);
	_g_free0 (_tmp17_);
	_g_free0 (_tmp14_);
	_g_object_unref0 (k);
	return result;
}

static gboolean
___lambda56__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                   guint keyval,
                                                   guint keycode,
                                                   GdkModifierType state,
                                                   gpointer self)
{
	gboolean result;
	result = __lambda56_ ((TerminalShortcutDialog*) self, _sender, keyval, keycode, state);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
terminal_shortcut_dialog_setup_key_controller (TerminalShortcutDialog* self)
{
	GtkEventControllerKey* kpc = NULL;
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
	kpc = _tmp0_;
	_tmp1_ = kpc;
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) ___lambda56__gtk_event_controller_key_key_pressed, self, 0);
	_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
	if (_tmp2_ != NULL) {
		GtkEventControllerKey* _tmp3_;
		GtkEventController* _tmp4_;
		_tmp3_ = kpc;
		_tmp4_ = _g_object_ref0 ((GtkEventController*) _tmp3_);
		gtk_widget_add_controller (_tmp2_, _tmp4_);
	}
	_g_object_unref0 (kpc);
}

static void
terminal_shortcut_dialog_cancel (TerminalShortcutDialog* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL], 0, GTK_RESPONSE_CANCEL);
}

static void
_terminal_shortcut_dialog_cancel_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
	terminal_shortcut_dialog_cancel ((TerminalShortcutDialog*) self);
}

static void
terminal_shortcut_dialog_apply (TerminalShortcutDialog* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL], 0, GTK_RESPONSE_APPLY);
}

static void
_terminal_shortcut_dialog_apply_gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self)
{
	terminal_shortcut_dialog_apply ((TerminalShortcutDialog*) self);
}

TerminalShortcutDialog*
terminal_shortcut_dialog_construct (GType object_type)
{
	TerminalShortcutDialog * self = NULL;
	self = (TerminalShortcutDialog*) g_object_new (object_type, NULL);
	return self;
}

TerminalShortcutDialog*
terminal_shortcut_dialog_new (void)
{
	return terminal_shortcut_dialog_construct (TERMINAL_TYPE_SHORTCUT_DIALOG);
}

const gchar*
terminal_shortcut_dialog_get_shortcut_name (TerminalShortcutDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_shortcut_name;
	result = _tmp0_;
	return result;
}

void
terminal_shortcut_dialog_set_shortcut_name (TerminalShortcutDialog* self,
                                            const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_shortcut_dialog_get_shortcut_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_shortcut_name);
		self->priv->_shortcut_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY]);
	}
}

const gchar*
terminal_shortcut_dialog_get_current_accel (TerminalShortcutDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_accel;
	result = _tmp0_;
	return result;
}

void
terminal_shortcut_dialog_set_current_accel (TerminalShortcutDialog* self,
                                            const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_shortcut_dialog_get_current_accel (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_current_accel);
		self->priv->_current_accel = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY]);
	}
}

const gchar*
terminal_shortcut_dialog_get_new_accel (TerminalShortcutDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_new_accel;
	result = _tmp0_;
	return result;
}

static void
terminal_shortcut_dialog_set_new_accel (TerminalShortcutDialog* self,
                                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_shortcut_dialog_get_new_accel (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_new_accel);
		self->priv->_new_accel = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY]);
	}
}

gboolean
terminal_shortcut_dialog_get_is_in_use (TerminalShortcutDialog* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_in_use;
	return result;
}

static void
terminal_shortcut_dialog_set_is_in_use (TerminalShortcutDialog* self,
                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_shortcut_dialog_get_is_in_use (self);
	if (old_value != value) {
		self->priv->_is_in_use = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY]);
	}
}

gboolean
terminal_shortcut_dialog_get_is_shortcut_set (TerminalShortcutDialog* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_shortcut_set;
	return result;
}

void
terminal_shortcut_dialog_set_is_shortcut_set (TerminalShortcutDialog* self,
                                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_shortcut_dialog_get_is_shortcut_set (self);
	if (old_value != value) {
		self->priv->_is_shortcut_set = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY]);
	}
}

gchar*
terminal_shortcut_dialog_get_heading_text (TerminalShortcutDialog* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_shortcut_name;
	if (_tmp1_ == NULL) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("Enter new shortcut"));
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	} else {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = self->priv->_shortcut_name;
		_tmp4_ = g_strdup_printf (_ ("Enter new shortcut for \"%s\""), _tmp3_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	return result;
}

static void
_gtk_window_close_terminal_shortcut_dialog_response (TerminalShortcutDialog* _sender,
                                                     GtkResponseType response,
                                                     gpointer self)
{
	gtk_window_close ((GtkWindow*) self);
}

static void
_terminal_shortcut_dialog___lambda57_ (TerminalShortcutDialog* self)
{
	g_object_notify ((GObject*) self, "heading-text");
}

static void
__terminal_shortcut_dialog___lambda57__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
	_terminal_shortcut_dialog___lambda57_ ((TerminalShortcutDialog*) self);
}

static gboolean
_terminal_shortcut_dialog___lambda58_ (TerminalShortcutDialog* self,
                                       GBinding* _binding,
                                       GValue* from_value,
                                       GValue* to_value_ref)
{
	gchar* current = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	GValue _tmp4_ = {0};
	gboolean result;
	g_return_val_if_fail (_binding != NULL, FALSE);
	g_return_val_if_fail (from_value != NULL, FALSE);
	g_return_val_if_fail (to_value_ref != NULL, FALSE);
	_tmp0_ = g_value_get_string (from_value);
	_tmp1_ = g_strdup (_tmp0_);
	current = _tmp1_;
	_tmp3_ = current;
	_tmp2_ = _tmp3_;
	if (_tmp2_ == NULL) {
		_tmp2_ = "";
	}
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_set_string (&_tmp4_, _tmp2_);
	G_IS_VALUE (to_value_ref) ? (g_value_unset (to_value_ref), NULL) : NULL;
	*to_value_ref = _tmp4_;
	result = TRUE;
	_g_free0 (current);
	return result;
}

static gboolean
__terminal_shortcut_dialog___lambda58__gbinding_transform_func (GBinding* binding,
                                                                GValue* from_value,
                                                                GValue* to_value,
                                                                gpointer self)
{
	gboolean result;
	result = _terminal_shortcut_dialog___lambda58_ ((TerminalShortcutDialog*) self, binding, from_value, to_value);
	return result;
}

static GObject *
terminal_shortcut_dialog_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TerminalShortcutDialog * self;
	GtkShortcutLabel* _tmp0_;
	parent_class = G_OBJECT_CLASS (terminal_shortcut_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
	if (TERMINAL_DEVEL) {
		gtk_widget_add_css_class ((GtkWidget*) self, "devel");
	}
	g_signal_connect_object (self, "response", (GCallback) _gtk_window_close_terminal_shortcut_dialog_response, (GtkWindow*) self, G_CONNECT_AFTER);
	g_signal_connect_object ((GObject*) self, "notify::shortcut-name", (GCallback) __terminal_shortcut_dialog___lambda57__g_object_notify, self, 0);
	_tmp0_ = self->priv->shortcut_label;
	g_object_bind_property_with_closures ((GObject*) self, "current-accel", (GObject*) _tmp0_, "accelerator", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((__terminal_shortcut_dialog___lambda58__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) __terminal_shortcut_dialog___lambda58__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	terminal_shortcut_dialog_setup_key_controller (self);
	return obj;
}

static void
terminal_shortcut_dialog_class_init (TerminalShortcutDialogClass * klass,
                                     gpointer klass_data)
{
	GtkKeyvalTrigger* _tmp0_;
	GtkKeyvalTrigger* _tmp1_;
	terminal_shortcut_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminalShortcutDialog_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_shortcut_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_shortcut_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = terminal_shortcut_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = terminal_shortcut_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY] = g_param_spec_string ("shortcut-name", "shortcut-name", "shortcut-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY] = g_param_spec_string ("current-accel", "current-accel", "current-accel", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY] = g_param_spec_string ("new-accel", "new-accel", "new-accel", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY] = g_param_spec_boolean ("is-in-use", "is-in-use", "is-in-use", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY] = g_param_spec_boolean ("is-shortcut-set", "is-shortcut-set", "is-shortcut-set", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY, terminal_shortcut_dialog_properties[TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY] = g_param_spec_string ("heading-text", "heading-text", "heading-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/raggesilver/BlackBox/gtk/shortcut-dialog.ui");
	terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_RESPONSE_SIGNAL] = g_signal_new ("response", TERMINAL_TYPE_SHORTCUT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, gtk_response_type_get_type ());
	terminal_shortcut_dialog_signals[TERMINAL_SHORTCUT_DIALOG_SHORTCUT_SET_SIGNAL] = g_signal_new ("shortcut-set", TERMINAL_TYPE_SHORTCUT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	_tmp0_ = (GtkKeyvalTrigger*) gtk_keyval_trigger_new (GDK_KEY_Escape, 0);
	terminal_shortcut_dialog_JUST_ESCAPE = _tmp0_;
	_tmp1_ = (GtkKeyvalTrigger*) gtk_keyval_trigger_new (GDK_KEY_BackSpace, 0);
	terminal_shortcut_dialog_JUST_BACKSPACE = _tmp1_;
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "shortcut_label", FALSE, TerminalShortcutDialog_private_offset + G_STRUCT_OFFSET (TerminalShortcutDialogPrivate, shortcut_label));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel", G_CALLBACK(_terminal_shortcut_dialog_cancel_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "apply", G_CALLBACK(_terminal_shortcut_dialog_apply_gtk_button_clicked));
}

static void
terminal_shortcut_dialog_instance_init (TerminalShortcutDialog * self,
                                        gpointer klass)
{
	self->priv = terminal_shortcut_dialog_get_instance_private (self);
	self->priv->_shortcut_name = NULL;
	self->priv->_current_accel = NULL;
	self->priv->_new_accel = NULL;
	self->priv->_is_in_use = FALSE;
	self->priv->_is_shortcut_set = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
terminal_shortcut_dialog_finalize (GObject * obj)
{
	TerminalShortcutDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
	_g_free0 (self->priv->_shortcut_name);
	_g_free0 (self->priv->_current_accel);
	_g_free0 (self->priv->_new_accel);
	G_OBJECT_CLASS (terminal_shortcut_dialog_parent_class)->finalize (obj);
}

static GType
terminal_shortcut_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalShortcutDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_shortcut_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalShortcutDialog), 0, (GInstanceInitFunc) terminal_shortcut_dialog_instance_init, NULL };
	GType terminal_shortcut_dialog_type_id;
	terminal_shortcut_dialog_type_id = g_type_register_static (adw_window_get_type (), "TerminalShortcutDialog", &g_define_type_info, 0);
	TerminalShortcutDialog_private_offset = g_type_add_instance_private (terminal_shortcut_dialog_type_id, sizeof (TerminalShortcutDialogPrivate));
	return terminal_shortcut_dialog_type_id;
}

GType
terminal_shortcut_dialog_get_type (void)
{
	static volatile gsize terminal_shortcut_dialog_type_id__once = 0;
	if (g_once_init_enter (&terminal_shortcut_dialog_type_id__once)) {
		GType terminal_shortcut_dialog_type_id;
		terminal_shortcut_dialog_type_id = terminal_shortcut_dialog_get_type_once ();
		g_once_init_leave (&terminal_shortcut_dialog_type_id__once, terminal_shortcut_dialog_type_id);
	}
	return terminal_shortcut_dialog_type_id__once;
}

static void
_vala_terminal_shortcut_dialog_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	TerminalShortcutDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
	switch (property_id) {
		case TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY:
		g_value_set_string (value, terminal_shortcut_dialog_get_shortcut_name (self));
		break;
		case TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY:
		g_value_set_string (value, terminal_shortcut_dialog_get_current_accel (self));
		break;
		case TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY:
		g_value_set_string (value, terminal_shortcut_dialog_get_new_accel (self));
		break;
		case TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY:
		g_value_set_boolean (value, terminal_shortcut_dialog_get_is_in_use (self));
		break;
		case TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY:
		g_value_set_boolean (value, terminal_shortcut_dialog_get_is_shortcut_set (self));
		break;
		case TERMINAL_SHORTCUT_DIALOG_HEADING_TEXT_PROPERTY:
		g_value_take_string (value, terminal_shortcut_dialog_get_heading_text (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_terminal_shortcut_dialog_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	TerminalShortcutDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_SHORTCUT_DIALOG, TerminalShortcutDialog);
	switch (property_id) {
		case TERMINAL_SHORTCUT_DIALOG_SHORTCUT_NAME_PROPERTY:
		terminal_shortcut_dialog_set_shortcut_name (self, g_value_get_string (value));
		break;
		case TERMINAL_SHORTCUT_DIALOG_CURRENT_ACCEL_PROPERTY:
		terminal_shortcut_dialog_set_current_accel (self, g_value_get_string (value));
		break;
		case TERMINAL_SHORTCUT_DIALOG_NEW_ACCEL_PROPERTY:
		terminal_shortcut_dialog_set_new_accel (self, g_value_get_string (value));
		break;
		case TERMINAL_SHORTCUT_DIALOG_IS_IN_USE_PROPERTY:
		terminal_shortcut_dialog_set_is_in_use (self, g_value_get_boolean (value));
		break;
		case TERMINAL_SHORTCUT_DIALOG_IS_SHORTCUT_SET_PROPERTY:
		terminal_shortcut_dialog_set_is_shortcut_set (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

