/* Terminal.c generated by valac 0.56.17, the Vala compiler
 * generated from Terminal.vala, do not modify */

/* Terminal.vala
 *
 * Copyright 2020-2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#define _GNU_SOURCE

#include <vte/vte.h>
#include <glib-object.h>
#include <adwaita.h>
#include <glib.h>
#include <gio/gio.h>
#include <pqmarble.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pcre2.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>

#define TERMINAL_APP_NAME "BlackBox"
#define TERMINAL_CONSTANTS_SCHEME "(?:news:|telnet:|nntp:|file:\\/|https?:|ftps?:|sftp:|webcal:" "|irc:|sftp:|ldaps?:|nfs:|smb:|rsync:|ssh:|rlogin:|telnet:|git:" "|git\\+ssh:|bzr:|bzr\\+ssh:|svn:|svn\\+ssh:|hg:|mailto:|magnet:)"
#define TERMINAL_CONSTANTS_USERCHARS "-[:alnum:]"
#define TERMINAL_CONSTANTS_USERCHARS_CLASS "[" TERMINAL_CONSTANTS_USERCHARS "]"
#define TERMINAL_CONSTANTS_PASSCHARS_CLASS "[-[:alnum:]\\Q,?;.:/!%$^*&~\"#'\\E]"
#define TERMINAL_CONSTANTS_USERPASS TERMINAL_CONSTANTS_USERCHARS_CLASS "+(?:" TERMINAL_CONSTANTS_PASSCHARS_CLASS "+)?"
#define TERMINAL_CONSTANTS_HOSTCHARS_CLASS "[-[:alnum:]]"
#define TERMINAL_CONSTANTS_HOST TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+(\\." TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+)*"
#define TERMINAL_CONSTANTS_PORT "(?:\\:[[:digit:]]{1,5})?"
#define TERMINAL_CONSTANTS_PATHCHARS_CLASS "[-[:alnum:]\\Q_$.+!*,;:@&=?/~#%\\E]"
#define TERMINAL_CONSTANTS_PATHTERM_CLASS "[^\\Q]'.}>) \t\r\n,\"\\E]"
#define TERMINAL_CONSTANTS_URLPATH "(?:(/" TERMINAL_CONSTANTS_PATHCHARS_CLASS "+(?:[(]" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*[)])*" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*)*" TERMINAL_CONSTANTS_PATHTERM_CLASS ")?"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_TERMINAL (terminal_terminal_get_type ())
#define TERMINAL_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminal))
#define TERMINAL_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))
#define TERMINAL_IS_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_IS_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_TERMINAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))

typedef struct _TerminalTerminal TerminalTerminal;
typedef struct _TerminalTerminalClass TerminalTerminalClass;
typedef struct _TerminalTerminalPrivate TerminalTerminalPrivate;

#define TERMINAL_TYPE_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_WINDOW, TerminalWindowClass))
#define TERMINAL_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_WINDOW))
#define TERMINAL_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;

#define TERMINAL_TYPE_SCHEME (terminal_scheme_get_type ())
#define TERMINAL_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SCHEME, TerminalScheme))
#define TERMINAL_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))
#define TERMINAL_IS_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SCHEME))
#define TERMINAL_IS_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SCHEME))
#define TERMINAL_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))

typedef struct _TerminalScheme TerminalScheme;
typedef struct _TerminalSchemeClass TerminalSchemeClass;

#define TERMINAL_TYPE_PROCESS (terminal_process_get_type ())
#define TERMINAL_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS, TerminalProcess))
#define TERMINAL_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS, TerminalProcessClass))
#define TERMINAL_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS))
#define TERMINAL_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS))
#define TERMINAL_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS, TerminalProcessClass))

typedef struct _TerminalProcess TerminalProcess;
typedef struct _TerminalProcessClass TerminalProcessClass;

#define TERMINAL_TYPE_SETTINGS (terminal_settings_get_type ())
#define TERMINAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettings))
#define TERMINAL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))
#define TERMINAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))

typedef struct _TerminalSettings TerminalSettings;
typedef struct _TerminalSettingsClass TerminalSettingsClass;
enum  {
	TERMINAL_TERMINAL_0_PROPERTY,
	TERMINAL_TERMINAL_SCHEME_PROPERTY,
	TERMINAL_TERMINAL_PID_PROPERTY,
	TERMINAL_TERMINAL_PROCESS_PROPERTY,
	TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY,
	TERMINAL_TERMINAL_NUM_PROPERTIES
};
static GParamSpec* terminal_terminal_properties[TERMINAL_TERMINAL_NUM_PROPERTIES];
typedef enum  {
	TERMINAL_TERMINAL_DROP_TARGETS_URILIST,
	TERMINAL_TERMINAL_DROP_TARGETS_STRING,
	TERMINAL_TERMINAL_DROP_TARGETS_TEXT
} TerminalTerminalDropTargets;

#define TERMINAL_TERMINAL_TYPE_DROP_TARGETS (terminal_terminal_drop_targets_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_THEME_PROVIDER (terminal_theme_provider_get_type ())
#define TERMINAL_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProvider))
#define TERMINAL_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))
#define TERMINAL_IS_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_IS_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_THEME_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))

typedef struct _TerminalThemeProvider TerminalThemeProvider;
typedef struct _TerminalThemeProviderClass TerminalThemeProviderClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkFileList_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkFileList_free (var), NULL)))
#define _vte_regex_unref0(var) ((var == NULL) ? NULL : (var = (vte_regex_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
typedef struct _TerminalThemeProviderPrivate TerminalThemeProviderPrivate;

#define TERMINAL_TYPE_PADDING (terminal_padding_get_type ())
typedef struct _TerminalPadding TerminalPadding;
#define _gdk_event_unref0(var) ((var == NULL) ? NULL : (var = (gdk_event_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef enum  {
	TERMINAL_PROCESS_CONTEXT_DEFAULT,
	TERMINAL_PROCESS_CONTEXT_ROOT,
	TERMINAL_PROCESS_CONTEXT_SSH
} TerminalProcessContext;

#define TERMINAL_TYPE_PROCESS_CONTEXT (terminal_process_context_get_type ())

#define TERMINAL_TYPE_PROCESS_WATCHER (terminal_process_watcher_get_type ())
#define TERMINAL_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcher))
#define TERMINAL_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))
#define TERMINAL_IS_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_IS_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_PROCESS_WATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))

typedef struct _TerminalProcessWatcher TerminalProcessWatcher;
typedef struct _TerminalProcessWatcherClass TerminalProcessWatcherClass;
typedef void (*TerminalHostCommandExitedCallback) (guint pid, guint status, gpointer user_data);
typedef struct _TerminalTerminalSpawnOnFlatpakData TerminalTerminalSpawnOnFlatpakData;
typedef struct _TerminalTerminalGetCanCloseData TerminalTerminalGetCanCloseData;
typedef struct _TerminalTerminalDoPasteFromSelectionClipboardData TerminalTerminalDoPasteFromSelectionClipboardData;
typedef enum  {
	TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION = 0,
	TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY = 1,
	TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM = 2
} TerminalWorkingDirectoryMode;

#define TERMINAL_TYPE_WORKING_DIRECTORY_MODE (terminal_working_directory_mode_get_type ())
typedef enum  {
	TERMINAL_SCROLLBACK_MODE_FIXED = 0,
	TERMINAL_SCROLLBACK_MODE_UNLIMITED = 1,
	TERMINAL_SCROLLBACK_MODE_DISABLED = 2
} TerminalScrollbackMode;

#define TERMINAL_TYPE_SCROLLBACK_MODE (terminal_scrollback_mode_get_type ())
enum  {
	TERMINAL_TERMINAL_EXIT_SIGNAL,
	TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL,
	TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL,
	TERMINAL_TERMINAL_NUM_SIGNALS
};
static guint terminal_terminal_signals[TERMINAL_TERMINAL_NUM_SIGNALS] = {0};

struct _TerminalTerminal {
	VteTerminal parent_instance;
	TerminalTerminalPrivate * priv;
	TerminalWindow* window;
};

struct _TerminalTerminalClass {
	VteTerminalClass parent_class;
};

struct _TerminalTerminalPrivate {
	TerminalScheme* _scheme;
	GPid _pid;
	TerminalProcess* _process;
	guint original_scrollback_lines;
	GCancellable* fp_spawn_host_command_callback_cancellable;
	TerminalSettings* settings;
	GtkCssProvider* padding_provider;
};

struct _TerminalThemeProvider {
	GObject parent_instance;
	TerminalThemeProviderPrivate * priv;
	GHashTable* themes;
};

struct _TerminalThemeProviderClass {
	GObjectClass parent_class;
};

struct _TerminalPadding {
	guint top;
	guint right;
	guint bottom;
	guint left;
};

struct _TerminalTerminalSpawnOnFlatpakData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	VtePtyFlags flags;
	gchar* cwd;
	GArray* argv;
	GArray* envv;
	GPid p;
	gboolean result;
	VtePty* _ppty;
	VtePty* _tmp0_;
	VtePty* _tmp1_;
	VtePty* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	gint pty_master;
	VtePty* _tmp5_;
	gint* pty_slaves;
	gint* _tmp6_;
	gint pty_slaves_length1;
	gint _pty_slaves_size_;
	const gchar* _tmp7_;
	gint* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	gint* _tmp10_;
	gint _tmp10__length1;
	gint _tmp11_;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
	GCancellable* _tmp14_;
	gboolean res;
	gint* _tmp15_;
	gint _tmp15__length1;
	GCancellable* _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_;
	VtePty* _tmp19_;
	GError* _inner_error0_;
};

struct _TerminalTerminalGetCanCloseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	gchar* command;
	gboolean result;
	gboolean _tmp0_;
	GPid _tmp1_;
	VtePty* _tmp2_;
	VtePty* _tmp3_;
	gint fd;
	VtePty* _tmp4_;
	VtePty* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint fgpid;
	GPid _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
};

struct _TerminalTerminalDoPasteFromSelectionClipboardData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	GdkClipboard* clipboard;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
	gchar* text;
	gchar* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

static gint TerminalTerminal_private_offset;
static gpointer terminal_terminal_parent_class = NULL;
static gchar** terminal_terminal_blackbox_envv;
static gint terminal_terminal_blackbox_envv_length1;
static gchar** terminal_terminal_blackbox_envv = NULL;
static gint terminal_terminal_blackbox_envv_length1 = 0;
static gint _terminal_terminal_blackbox_envv_size_ = 0;

VALA_EXTERN GType terminal_terminal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalTerminal, g_object_unref)
VALA_EXTERN GType terminal_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalWindow, g_object_unref)
VALA_EXTERN GType terminal_scheme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalScheme, g_object_unref)
VALA_EXTERN GType terminal_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcess, g_object_unref)
VALA_EXTERN GType terminal_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalSettings, g_object_unref)
static GType terminal_terminal_drop_targets_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN gchar* terminal_constants_get_user_schemes_dir (void);
VALA_EXTERN TerminalTerminal* terminal_terminal_new (TerminalWindow* window,
                                         const gchar* command,
                                         const gchar* cwd);
VALA_EXTERN TerminalTerminal* terminal_terminal_construct (GType object_type,
                                               TerminalWindow* window,
                                               const gchar* command,
                                               const gchar* cwd);
static void terminal_terminal_on_child_exited (TerminalTerminal* self,
                                        gint status);
static void _terminal_terminal_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                                   gint status,
                                                                   gpointer self);
VALA_EXTERN TerminalSettings* terminal_settings_get_default (void);
VALA_EXTERN GType terminal_theme_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalThemeProvider, g_object_unref)
VALA_EXTERN TerminalThemeProvider* terminal_theme_provider_get_default (void);
static void terminal_terminal_on_theme_changed (TerminalTerminal* self);
static void _terminal_terminal_on_theme_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void terminal_terminal_on_font_changed (TerminalTerminal* self);
static void _terminal_terminal_on_font_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void terminal_terminal_on_padding_changed (TerminalTerminal* self);
static void _terminal_terminal_on_padding_changed_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void terminal_terminal_setup_drag_drop (TerminalTerminal* self);
static void terminal_terminal_setup_regexes (TerminalTerminal* self);
static void terminal_terminal_connect_signals (TerminalTerminal* self);
static void terminal_terminal_bind_data (TerminalTerminal* self);
static void terminal_terminal_spawn (TerminalTerminal* self,
                              const gchar* command,
                              const gchar* cwd,
                              GError** error);
static void terminal_terminal_real_dispose (GObject* base);
static gboolean terminal_terminal_on_drag_data_received (TerminalTerminal* self,
                                                  GtkDropTarget* target,
                                                  GValue* value,
                                                  gdouble x,
                                                  gdouble y);
static gboolean _terminal_terminal_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                                        GValue* value,
                                                                        gdouble x,
                                                                        gdouble y,
                                                                        gpointer self);
static GdkFileList* _vala_GdkFileList_copy (GdkFileList* self);
static void _vala_GdkFileList_free (GdkFileList* self);
VALA_EXTERN const gchar* terminal_settings_get_font (TerminalSettings* self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void terminal_terminal_get_background_color (TerminalTerminal* self,
                                             TerminalScheme* theme,
                                             GdkRGBA* result);
VALA_EXTERN GdkRGBA* terminal_scheme_get_background_color (TerminalScheme* self);
VALA_EXTERN guint terminal_settings_get_opacity (TerminalSettings* self);
static void _vala_GdkRGBA_free (GdkRGBA* self);
VALA_EXTERN const gchar* terminal_theme_provider_get_current_theme (TerminalThemeProvider* self);
VALA_EXTERN GdkRGBA* terminal_scheme_get_foreground_color (TerminalScheme* self);
VALA_EXTERN GArray* terminal_scheme_get_palette (TerminalScheme* self);
VALA_EXTERN GType terminal_padding_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalPadding* terminal_padding_dup (const TerminalPadding* self);
VALA_EXTERN void terminal_padding_free (TerminalPadding* self);
VALA_EXTERN void terminal_settings_get_padding (TerminalSettings* self,
                                    TerminalPadding* result);
static gboolean terminal_terminal_on_key_pressed (TerminalTerminal* self,
                                           guint keyval,
                                           guint keycode,
                                           GdkModifierType state);
static gboolean _terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                 guint keyval,
                                                                                 guint keycode,
                                                                                 GdkModifierType state,
                                                                                 gpointer self);
static void __lambda11_ (TerminalTerminal* self,
                  GtkGestureClick* gesture,
                  gint n_clicked,
                  gdouble x,
                  gdouble y);
static void ___lambda11__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void __lambda12_ (TerminalTerminal* self);
static void ___lambda12__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda13_ (TerminalTerminal* self);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
VALA_EXTERN gboolean terminal_settings_get_use_custom_command (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_settings_get_custom_shell_command (TerminalSettings* self);
VALA_EXTERN gboolean terminal_settings_get_command_as_login_shell (TerminalSettings* self);
static void __lambda14_ (TerminalTerminal* self,
                  VteTerminal* _,
                  GPid pid,
                  GError* _error_);
VALA_EXTERN void terminal_terminal_set_pid (TerminalTerminal* self,
                                GPid value);
static void terminal_terminal_on_spawn_finished (TerminalTerminal* self);
static void ___lambda14__vte_terminal_spawn_async_callback (VteTerminal* terminal,
                                                     GPid pid,
                                                     GError* _error_,
                                                     gpointer self);
VALA_EXTERN GPid terminal_terminal_get_pid (TerminalTerminal* self);
VALA_EXTERN TerminalProcess* terminal_process_new (void);
VALA_EXTERN TerminalProcess* terminal_process_construct (GType object_type);
VALA_EXTERN void terminal_process_set_terminal_fd (TerminalProcess* self,
                                       gint value);
VALA_EXTERN void terminal_process_set_pid (TerminalProcess* self,
                               GPid value);
VALA_EXTERN void terminal_process_set_foreground_pid (TerminalProcess* self,
                                          GPid value);
VALA_EXTERN void terminal_terminal_set_process (TerminalTerminal* self,
                                    TerminalProcess* value);
VALA_EXTERN TerminalProcess* terminal_terminal_get_process (TerminalTerminal* self);
static void __lambda15_ (TerminalTerminal* self,
                  TerminalProcess* _process);
VALA_EXTERN gboolean terminal_settings_get_notify_process_completion (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_process_get_last_foreground_task_command (TerminalProcess* self);
static void ___lambda15__terminal_process_foreground_task_finished (TerminalProcess* _sender,
                                                             gpointer self);
static void __lambda16_ (TerminalTerminal* self,
                  GObject* __process,
                  GParamSpec* spec);
VALA_EXTERN GType terminal_process_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalProcessContext terminal_process_get_context (TerminalProcess* self);
static TerminalProcessContext* _terminal_process_context_dup (TerminalProcessContext* self);
static void ___lambda16__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN GType terminal_process_watcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcessWatcher, g_object_unref)
VALA_EXTERN TerminalProcessWatcher* terminal_process_watcher_get_instance (void);
VALA_EXTERN gboolean terminal_process_watcher_watch (TerminalProcessWatcher* self,
                                         TerminalProcess* process);
static void terminal_terminal_spawn_on_flatpak_data_free (gpointer _data);
static void terminal_terminal_spawn_on_flatpak (TerminalTerminal* self,
                                         VtePtyFlags flags,
                                         const gchar* cwd,
                                         GArray* argv,
                                         GArray* envv,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static gboolean terminal_terminal_spawn_on_flatpak_finish (TerminalTerminal* self,
                                                    GAsyncResult* _res_,
                                                    GPid* p,
                                                    GError** error);
static gboolean terminal_terminal_spawn_on_flatpak_co (TerminalTerminalSpawnOnFlatpakData* _data_);
static void _vala_array_add3 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add4 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add5 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
VALA_EXTERN void terminal_send_host_command (const gchar* cwd,
                                 GArray* argv,
                                 GArray* envv,
                                 gint* fds,
                                 gint fds_length1,
                                 TerminalHostCommandExitedCallback callback,
                                 gpointer callback_target,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN gboolean terminal_send_host_command_finish (GAsyncResult* _res_,
                                            gint* pid,
                                            GError** error);
static void terminal_terminal_on_host_command_exited (TerminalTerminal* self,
                                               guint _pid,
                                               guint status);
static void _terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback (guint pid,
                                                                                      guint status,
                                                                                      gpointer self);
static void terminal_terminal_spawn_on_flatpak_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
VALA_EXTERN gboolean terminal_settings_get_easy_copy_paste (TerminalSettings* self);
VALA_EXTERN void terminal_terminal_do_copy_clipboard (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_do_paste_clipboard (TerminalTerminal* self);
static void terminal_terminal_get_can_close_data_free (gpointer _data);
VALA_EXTERN void terminal_terminal_get_can_close (TerminalTerminal* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gboolean terminal_terminal_get_can_close_finish (TerminalTerminal* self,
                                                 GAsyncResult* _res_,
                                                 gchar** command);
static gboolean terminal_terminal_get_can_close_co (TerminalTerminalGetCanCloseData* _data_);
VALA_EXTERN void terminal_get_foreground_process (gint terminal_fd,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gint terminal_get_foreground_process_finish (GAsyncResult* _res_);
static void terminal_terminal_get_can_close_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
VALA_EXTERN gchar* terminal_get_process_cmdline (gint pid);
VALA_EXTERN void terminal_terminal_zoom_in (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_zoom_out (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_zoom_default (TerminalTerminal* self);
static void terminal_terminal_do_paste_from_selection_clipboard_data_free (gpointer _data);
VALA_EXTERN void terminal_terminal_do_paste_from_selection_clipboard (TerminalTerminal* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN void terminal_terminal_do_paste_from_selection_clipboard_finish (TerminalTerminal* self,
                                                                 GAsyncResult* _res_);
static gboolean terminal_terminal_do_paste_from_selection_clipboard_co (TerminalTerminalDoPasteFromSelectionClipboardData* _data_);
static void terminal_terminal_do_paste_from_selection_clipboard_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory (TerminalTerminal* self);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal);
VALA_EXTERN guint terminal_settings_get_working_directory_mode (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_settings_get_custom_working_directory (TerminalSettings* self);
VALA_EXTERN GType terminal_working_directory_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalScheme* terminal_terminal_get_scheme (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_set_scheme (TerminalTerminal* self,
                                   TerminalScheme* value);
VALA_EXTERN guint terminal_terminal_get_user_scrollback_lines (TerminalTerminal* self);
VALA_EXTERN guint terminal_settings_get_scrollback_mode (TerminalSettings* self);
VALA_EXTERN GType terminal_scrollback_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint terminal_settings_get_scrollback_lines (TerminalSettings* self);
static void terminal_terminal_finalize (GObject * obj);
static GType terminal_terminal_get_type_once (void);
static void _vala_terminal_terminal_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_terminal_terminal_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const gchar* TERMINAL_CONSTANTS_URL_REGEX_STRINGS[5];

static inline gpointer
terminal_terminal_get_instance_private (TerminalTerminal* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalTerminal_private_offset);
}

/**
   * List of available drop targets for Terminal
   */
static GType
terminal_terminal_drop_targets_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_TERMINAL_DROP_TARGETS_URILIST, "TERMINAL_TERMINAL_DROP_TARGETS_URILIST", "urilist"}, {TERMINAL_TERMINAL_DROP_TARGETS_STRING, "TERMINAL_TERMINAL_DROP_TARGETS_STRING", "string"}, {TERMINAL_TERMINAL_DROP_TARGETS_TEXT, "TERMINAL_TERMINAL_DROP_TARGETS_TEXT", "text"}, {0, NULL, NULL}};
	GType terminal_terminal_drop_targets_type_id;
	terminal_terminal_drop_targets_type_id = g_enum_register_static ("TerminalTerminalDropTargets", values);
	return terminal_terminal_drop_targets_type_id;
}

static GType
terminal_terminal_drop_targets_get_type (void)
{
	static volatile gsize terminal_terminal_drop_targets_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_drop_targets_type_id__once)) {
		GType terminal_terminal_drop_targets_type_id;
		terminal_terminal_drop_targets_type_id = terminal_terminal_drop_targets_get_type_once ();
		g_once_init_leave (&terminal_terminal_drop_targets_type_id__once, terminal_terminal_drop_targets_type_id);
	}
	return terminal_terminal_drop_targets_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_terminal_terminal_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                              gint status,
                                                              gpointer self)
{
	terminal_terminal_on_child_exited ((TerminalTerminal*) self, status);
}

static void
_terminal_terminal_on_theme_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	terminal_terminal_on_theme_changed ((TerminalTerminal*) self);
}

static void
_terminal_terminal_on_font_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
	terminal_terminal_on_font_changed ((TerminalTerminal*) self);
}

static void
_terminal_terminal_on_padding_changed_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
	terminal_terminal_on_padding_changed ((TerminalTerminal*) self);
}

TerminalTerminal*
terminal_terminal_construct (GType object_type,
                             TerminalWindow* window,
                             const gchar* command,
                             const gchar* cwd)
{
	TerminalTerminal * self = NULL;
	guint _tmp0_;
	guint _tmp1_;
	TerminalWindow* _tmp2_;
	TerminalSettings* _tmp3_;
	TerminalThemeProvider* _tmp4_;
	TerminalThemeProvider* _tmp5_;
	TerminalSettings* _tmp6_;
	TerminalSettings* _tmp7_;
	TerminalSettings* _tmp8_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	self = (TerminalTerminal*) g_object_new (object_type, "allow-hyperlink", TRUE, "receives-default", TRUE, "scroll-unit-is-pixels", TRUE, NULL);
	_tmp0_ = vte_terminal_get_scrollback_lines ((VteTerminal*) self);
	_tmp1_ = _tmp0_;
	self->priv->original_scrollback_lines = _tmp1_;
	_tmp2_ = _g_object_ref0 (window);
	_g_object_unref0 (self->window);
	self->window = _tmp2_;
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
	g_signal_connect_object ((VteTerminal*) self, "child-exited", (GCallback) _terminal_terminal_on_child_exited_vte_terminal_child_exited, self, 0);
	_tmp3_ = terminal_settings_get_default ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp3_;
	_tmp4_ = terminal_theme_provider_get_default ();
	_tmp5_ = _tmp4_;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::current-theme", (GCallback) _terminal_terminal_on_theme_changed_g_object_notify, self, 0);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp6_, "notify::font", (GCallback) _terminal_terminal_on_font_changed_g_object_notify, self, 0);
	_tmp7_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp7_, "notify::terminal-padding", (GCallback) _terminal_terminal_on_padding_changed_g_object_notify, self, 0);
	_tmp8_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp8_, "notify::opacity", (GCallback) _terminal_terminal_on_theme_changed_g_object_notify, self, 0);
	terminal_terminal_setup_drag_drop (self);
	terminal_terminal_setup_regexes (self);
	terminal_terminal_connect_signals (self);
	terminal_terminal_bind_data (self);
	terminal_terminal_on_theme_changed (self);
	terminal_terminal_on_font_changed (self);
	terminal_terminal_on_padding_changed (self);
	{
		terminal_terminal_spawn (self, command, cwd, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("Terminal.vala:120: %s", _tmp10_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	return self;
}

TerminalTerminal*
terminal_terminal_new (TerminalWindow* window,
                       const gchar* command,
                       const gchar* cwd)
{
	return terminal_terminal_construct (TERMINAL_TYPE_TERMINAL, window, command, cwd);
}

static void
terminal_terminal_real_dispose (GObject* base)
{
	TerminalTerminal * self;
	GCancellable* _tmp0_ = NULL;
	GCancellable* _tmp1_;
	self = (TerminalTerminal*) base;
	_tmp1_ = self->priv->fp_spawn_host_command_callback_cancellable;
	_tmp0_ = _tmp1_;
	if (_tmp0_ != NULL) {
		g_cancellable_cancel (_tmp0_);
	}
	G_OBJECT_CLASS (terminal_terminal_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, vte_terminal_get_type (), VteTerminal));
}

static gboolean
_terminal_terminal_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                               GValue* value,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
	gboolean result;
	result = terminal_terminal_on_drag_data_received ((TerminalTerminal*) self, _sender, value, x, y);
	return result;
}

static void
terminal_terminal_setup_drag_drop (TerminalTerminal* self)
{
	GtkDropTarget* target = NULL;
	GtkDropTarget* _tmp0_;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
	GtkEventController* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_drop_target_new (G_TYPE_INVALID, GDK_ACTION_COPY);
	target = _tmp0_;
	_tmp1_ = g_new0 (GType, 3);
	_tmp1_[0] = gdk_file_list_get_type ();
	_tmp1_[1] = g_file_get_type ();
	_tmp1_[2] = G_TYPE_STRING;
	_tmp2_ = _tmp1_;
	_tmp2__length1 = 3;
	gtk_drop_target_set_gtypes (target, _tmp2_, (gsize) 3);
	_tmp2_ = (g_free (_tmp2_), NULL);
	g_signal_connect_object (target, "drop", (GCallback) _terminal_terminal_on_drag_data_received_gtk_drop_target_drop, self, 0);
	_tmp3_ = _g_object_ref0 ((GtkEventController*) target);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp3_);
	_g_object_unref0 (target);
}

static GdkFileList*
_vala_GdkFileList_copy (GdkFileList* self)
{
	return g_boxed_copy (gdk_file_list_get_type (), self);
}

static gpointer
__vala_GdkFileList_copy0 (gpointer self)
{
	return self ? _vala_GdkFileList_copy (self) : NULL;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static void
_vala_GdkFileList_free (GdkFileList* self)
{
	g_boxed_free (gdk_file_list_get_type (), self);
}

static gboolean
terminal_terminal_on_drag_data_received (TerminalTerminal* self,
                                         GtkDropTarget* target,
                                         GValue* value,
                                         gdouble x,
                                         gdouble y)
{
	GType vtype = 0UL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (target != NULL, FALSE);
	g_return_val_if_fail (value != NULL, FALSE);
	vtype = G_VALUE_TYPE (value);
	if (vtype == gdk_file_list_get_type ()) {
		GdkFileList* list = NULL;
		void* _tmp0_;
		GdkFileList* _tmp1_;
		GdkFileList* _tmp2_;
		GSList* _tmp3_;
		_tmp0_ = g_value_get_boxed (value);
		_tmp1_ = __vala_GdkFileList_copy0 ((GdkFileList*) _tmp0_);
		list = _tmp1_;
		_tmp2_ = list;
		_tmp3_ = gdk_file_list_get_files (_tmp2_);
		{
			GSList* file_collection = NULL;
			GSList* file_it = NULL;
			file_collection = _tmp3_;
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
				GFile* file = NULL;
				file = (GFile*) file_it->data;
				{
					GFile* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					guint8* _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_ = 0;
					guint8* _tmp11_;
					gint _tmp11__length1;
					guint8* _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_ = 0;
					guint8* _tmp14_;
					gint _tmp14__length1;
					_tmp4_ = file;
					_tmp5_ = g_file_get_path (_tmp4_);
					_tmp6_ = _tmp5_;
					_tmp7_ = g_shell_quote (_tmp6_);
					_tmp8_ = _tmp7_;
					_tmp9_ = string_get_data (_tmp8_, &_tmp10_);
					_tmp9__length1 = _tmp10_;
					_tmp11_ = _tmp9_;
					_tmp11__length1 = _tmp9__length1;
					vte_terminal_feed_child ((VteTerminal*) self, _tmp11_, (gssize) _tmp11__length1);
					_g_free0 (_tmp8_);
					_g_free0 (_tmp6_);
					_tmp12_ = string_get_data (" ", &_tmp13_);
					_tmp12__length1 = _tmp13_;
					_tmp14_ = _tmp12_;
					_tmp14__length1 = _tmp12__length1;
					vte_terminal_feed_child ((VteTerminal*) self, _tmp14_, (gssize) _tmp14__length1);
				}
			}
			(file_collection == NULL) ? NULL : (file_collection = (g_slist_free (file_collection), NULL));
		}
		result = TRUE;
		__vala_GdkFileList_free0 (list);
		return result;
	} else {
		if (vtype == g_file_get_type ()) {
			GFile* file = NULL;
			GObject* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_;
			gchar* _tmp19_ = NULL;
			gchar* path = NULL;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			_tmp15_ = g_value_get_object (value);
			_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, g_file_get_type (), GFile));
			file = _tmp16_;
			_tmp18_ = file;
			_tmp17_ = _tmp18_;
			_tmp19_ = NULL;
			if (_tmp17_ != NULL) {
				gchar* _tmp20_;
				_tmp20_ = g_file_get_path (_tmp17_);
				_g_free0 (_tmp19_);
				_tmp19_ = _tmp20_;
			}
			_tmp21_ = _tmp19_;
			_tmp19_ = NULL;
			path = _tmp21_;
			_tmp22_ = path;
			if (_tmp22_ != NULL) {
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				guint8* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_ = 0;
				guint8* _tmp28_;
				gint _tmp28__length1;
				guint8* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_ = 0;
				guint8* _tmp31_;
				gint _tmp31__length1;
				_tmp23_ = path;
				_tmp24_ = g_shell_quote (_tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = string_get_data (_tmp25_, &_tmp27_);
				_tmp26__length1 = _tmp27_;
				_tmp28_ = _tmp26_;
				_tmp28__length1 = _tmp26__length1;
				vte_terminal_feed_child ((VteTerminal*) self, _tmp28_, (gssize) _tmp28__length1);
				_g_free0 (_tmp25_);
				_tmp29_ = string_get_data (" ", &_tmp30_);
				_tmp29__length1 = _tmp30_;
				_tmp31_ = _tmp29_;
				_tmp31__length1 = _tmp29__length1;
				vte_terminal_feed_child ((VteTerminal*) self, _tmp31_, (gssize) _tmp31__length1);
			}
			result = TRUE;
			_g_free0 (path);
			_g_free0 (_tmp19_);
			_g_object_unref0 (file);
			return result;
		} else {
			if (vtype == G_TYPE_STRING) {
				gchar* text = NULL;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				const gchar* _tmp34_;
				_tmp32_ = g_value_get_string (value);
				_tmp33_ = g_strdup (_tmp32_);
				text = _tmp33_;
				_tmp34_ = text;
				if (_tmp34_ != NULL) {
					const gchar* _tmp35_;
					guint8* _tmp36_;
					gint _tmp36__length1;
					gint _tmp37_ = 0;
					guint8* _tmp38_;
					gint _tmp38__length1;
					_tmp35_ = text;
					_tmp36_ = string_get_data (_tmp35_, &_tmp37_);
					_tmp36__length1 = _tmp37_;
					_tmp38_ = _tmp36_;
					_tmp38__length1 = _tmp36__length1;
					vte_terminal_feed_child ((VteTerminal*) self, _tmp38_, (gssize) _tmp38__length1);
				}
				result = TRUE;
				_g_free0 (text);
				return result;
			}
		}
	}
	g_warning ("Terminal.vala:193: You dropped something Terminal can't handle yet :(");
	result = FALSE;
	return result;
}

static void
terminal_terminal_setup_regexes (TerminalTerminal* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		const gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
		str_collection = TERMINAL_CONSTANTS_URL_REGEX_STRINGS;
		str_collection_length1 = G_N_ELEMENTS (TERMINAL_CONSTANTS_URL_REGEX_STRINGS);
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
			const gchar* str = NULL;
			str = str_collection[str_it];
			{
				{
					VteRegex* reg = NULL;
					const gchar* _tmp0_;
					VteRegex* _tmp1_;
					gint id = 0;
					VteRegex* _tmp2_;
					_tmp0_ = str;
					_tmp1_ = vte_regex_new_for_match (_tmp0_, (gssize) -1, (guint32) PCRE2_MULTILINE, &_inner_error0_);
					reg = _tmp1_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp2_ = reg;
					id = vte_terminal_match_add_regex ((VteTerminal*) self, _tmp2_, (guint32) 0);
					vte_terminal_match_set_cursor_name ((VteTerminal*) self, id, "pointer");
					_vte_regex_unref0 (reg);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp3_;
					const gchar* _tmp4_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp3_ = e;
					_tmp4_ = _tmp3_->message;
					g_warning ("Terminal.vala:207: %s", _tmp4_);
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
	}
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
	g_boxed_free (pango_font_description_get_type (), self);
}

static void
terminal_terminal_on_font_changed (TerminalTerminal* self)
{
	TerminalSettings* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PangoFontDescription* _tmp3_;
	PangoFontDescription* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = terminal_settings_get_font (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = pango_font_description_from_string (_tmp2_);
	_tmp4_ = _tmp3_;
	g_object_set ((VteTerminal*) self, "font-desc", _tmp4_, NULL);
	__vala_PangoFontDescription_free0 (_tmp4_);
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
	g_boxed_free (gdk_rgba_get_type (), self);
}

static void
terminal_terminal_get_background_color (TerminalTerminal* self,
                                        TerminalScheme* theme,
                                        GdkRGBA* result)
{
	GdkRGBA* bg_transparent = NULL;
	GdkRGBA* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	TerminalSettings* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	GdkRGBA* _tmp6_;
	GdkRGBA _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (theme != NULL);
	_tmp0_ = terminal_scheme_get_background_color (theme);
	_tmp1_ = _tmp0_;
	_tmp2_ = gdk_rgba_copy (_tmp1_);
	bg_transparent = _tmp2_;
	_tmp3_ = self->priv->settings;
	_tmp4_ = terminal_settings_get_opacity (_tmp3_);
	_tmp5_ = _tmp4_;
	(*bg_transparent).alpha = _tmp5_ * 0.01f;
	_tmp6_ = bg_transparent;
	_tmp7_ = *_tmp6_;
	__vala_GdkRGBA_free0 (_tmp6_);
	*result = _tmp7_;
	return;
}

static void
terminal_terminal_on_theme_changed (TerminalTerminal* self)
{
	TerminalThemeProvider* theme_provider = NULL;
	TerminalThemeProvider* _tmp0_;
	gchar* theme_name = NULL;
	TerminalThemeProvider* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	TerminalScheme* theme = NULL;
	TerminalThemeProvider* _tmp5_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	gconstpointer _tmp8_;
	TerminalScheme* _tmp9_;
	TerminalScheme* _tmp10_;
	GdkRGBA bg = {0};
	TerminalScheme* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	TerminalScheme* _tmp14_;
	GdkRGBA* _tmp15_;
	GdkRGBA* _tmp16_;
	GdkRGBA _tmp17_;
	TerminalScheme* _tmp18_;
	GArray* _tmp19_;
	GArray* _tmp20_;
	gpointer* _tmp21_;
	gint _tmp21__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = terminal_theme_provider_get_default ();
	theme_provider = _tmp0_;
	_tmp1_ = theme_provider;
	_tmp2_ = terminal_theme_provider_get_current_theme (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup (_tmp3_);
	theme_name = _tmp4_;
	_tmp5_ = theme_provider;
	_tmp6_ = _tmp5_->themes;
	_tmp7_ = theme_name;
	_tmp8_ = g_hash_table_lookup (_tmp6_, _tmp7_);
	_tmp9_ = _g_object_ref0 ((TerminalScheme*) _tmp8_);
	theme = _tmp9_;
	_tmp10_ = theme;
	if (_tmp10_ == NULL) {
		const gchar* _tmp11_;
		_tmp11_ = theme_name;
		g_warning ("Terminal.vala:230: INVALID THEME '%s'", _tmp11_);
		_g_object_unref0 (theme);
		_g_free0 (theme_name);
		_g_object_unref0 (theme_provider);
		return;
	}
	_tmp12_ = theme;
	terminal_terminal_get_background_color (self, _tmp12_, &_tmp13_);
	bg = _tmp13_;
	_tmp14_ = theme;
	_tmp15_ = terminal_scheme_get_foreground_color (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = bg;
	_tmp18_ = theme;
	_tmp19_ = terminal_scheme_get_palette (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_->data;
	_tmp21__length1 = _tmp20_->len;
	vte_terminal_set_colors ((VteTerminal*) self, _tmp16_, &_tmp17_, _tmp21_, (gsize) _tmp21__length1);
	_g_object_unref0 (theme);
	_g_free0 (theme_name);
	_g_object_unref0 (theme_provider);
}

static void
terminal_terminal_on_padding_changed (TerminalTerminal* self)
{
	TerminalPadding pad = {0};
	TerminalSettings* _tmp0_;
	TerminalPadding _tmp1_ = {0};
	GtkCssProvider* _tmp2_;
	TerminalPadding _tmp5_;
	TerminalPadding _tmp6_;
	TerminalPadding _tmp7_;
	TerminalPadding _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkCssProvider* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkCssProvider* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	terminal_settings_get_padding (_tmp0_, &_tmp1_);
	pad = _tmp1_;
	_tmp2_ = self->priv->padding_provider;
	if (_tmp2_ != NULL) {
		GtkStyleContext* _tmp3_;
		GtkCssProvider* _tmp4_;
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp4_ = self->priv->padding_provider;
		gtk_style_context_remove_provider (_tmp3_, (GtkStyleProvider*) _tmp4_);
		_g_object_unref0 (self->priv->padding_provider);
		self->priv->padding_provider = NULL;
	}
	_tmp5_ = pad;
	_tmp6_ = pad;
	_tmp7_ = pad;
	_tmp8_ = pad;
	_tmp9_ = g_strdup_printf ("vte-terminal { padding: %upx %upx %upx %upx; }", _tmp5_.top, _tmp6_.right, _tmp7_.bottom, _tmp8_.left);
	_tmp10_ = _tmp9_;
	_tmp11_ = pq_marble_get_css_provider_for_data (_tmp10_);
	_g_object_unref0 (self->priv->padding_provider);
	self->priv->padding_provider = _tmp11_;
	_g_free0 (_tmp10_);
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp13_ = self->priv->padding_provider;
	gtk_style_context_add_provider (_tmp12_, (GtkStyleProvider*) _tmp13_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
}

static void
terminal_terminal_bind_data (TerminalTerminal* self)
{
	TerminalSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	TerminalSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	TerminalSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	TerminalSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	TerminalSettings* _tmp12_;
	TerminalSettings* _tmp13_;
	TerminalSettings* _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp0_);
	_tmp2_ = _tmp1_;
	g_settings_bind (_tmp2_, "theme-bold-is-bright", (GObject*) self, "bold-is-bright", G_SETTINGS_BIND_DEFAULT);
	_tmp3_ = self->priv->settings;
	_tmp4_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp3_);
	_tmp5_ = _tmp4_;
	g_settings_bind (_tmp5_, "terminal-bell", (GObject*) self, "audible-bell", G_SETTINGS_BIND_DEFAULT);
	_tmp6_ = self->priv->settings;
	_tmp7_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp6_);
	_tmp8_ = _tmp7_;
	g_settings_bind (_tmp8_, "terminal-cell-width", (GObject*) self, "cell-width-scale", G_SETTINGS_BIND_DEFAULT);
	_tmp9_ = self->priv->settings;
	_tmp10_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp9_);
	_tmp11_ = _tmp10_;
	g_settings_bind (_tmp11_, "terminal-cell-height", (GObject*) self, "cell-height-scale", G_SETTINGS_BIND_DEFAULT);
	_tmp12_ = self->priv->settings;
	g_object_bind_property_with_closures ((GObject*) _tmp12_, "cursor-shape", (GObject*) self, "cursor-shape", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp13_ = self->priv->settings;
	g_object_bind_property_with_closures ((GObject*) _tmp13_, "cursor-blink-mode", (GObject*) self, "cursor-blink-mode", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_object_bind_property_with_closures ((GObject*) self, "user-scrollback-lines", (GObject*) self, "scrollback-lines", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp14_ = self->priv->settings;
	g_object_bind_property_with_closures ((GObject*) _tmp14_, "show-scrollbars", (GObject*) self, "enable-fallback-scrolling", G_BINDING_SYNC_CREATE | G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
}

static gboolean
_terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                        guint keyval,
                                                                        guint keycode,
                                                                        GdkModifierType state,
                                                                        gpointer self)
{
	gboolean result;
	result = terminal_terminal_on_key_pressed ((TerminalTerminal*) self, keyval, keycode, state);
	return result;
}

static gpointer
_gdk_event_ref0 (gpointer self)
{
	return self ? gdk_event_ref (self) : NULL;
}

static void
__lambda11_ (TerminalTerminal* self,
             GtkGestureClick* gesture,
             gint n_clicked,
             gdouble x,
             gdouble y)
{
	GdkEvent* event = NULL;
	GdkEvent* _tmp0_;
	GdkEvent* _tmp1_;
	gchar* pattern = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GdkEvent* _tmp4_;
	const gchar* _tmp6_;
	GtkUriLauncher* _tmp7_;
	GtkUriLauncher* _tmp8_;
	TerminalWindow* _tmp9_;
	g_return_if_fail (gesture != NULL);
	_tmp0_ = gtk_event_controller_get_current_event ((GtkEventController*) gesture);
	_tmp1_ = _gdk_event_ref0 (_tmp0_);
	event = _tmp1_;
	_tmp2_ = vte_terminal_check_match_at ((VteTerminal*) self, x, y, NULL);
	pattern = _tmp2_;
	_tmp4_ = event;
	if ((gdk_event_get_modifier_state (_tmp4_) & GDK_CONTROL_MASK) == 0) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = pattern;
		_tmp3_ = _tmp5_ == NULL;
	}
	if (_tmp3_) {
		_g_free0 (pattern);
		_gdk_event_unref0 (event);
		return;
	}
	_tmp6_ = pattern;
	_tmp7_ = gtk_uri_launcher_new (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->window;
	gtk_uri_launcher_launch (_tmp8_, (GtkWindow*) _tmp9_, NULL, NULL, NULL);
	_g_object_unref0 (_tmp8_);
	_g_free0 (pattern);
	_gdk_event_unref0 (event);
}

static void
___lambda11__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
	__lambda11_ ((TerminalTerminal*) self, _sender, n_press, x, y);
}

static void
__lambda12_ (TerminalTerminal* self)
{
	g_object_notify ((GObject*) self, "user-scrollback-lines");
}

static void
___lambda12__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda12_ ((TerminalTerminal*) self);
}

static void
__lambda13_ (TerminalTerminal* self)
{
	g_object_notify ((GObject*) self, "user-scrollback-lines");
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda13_ ((TerminalTerminal*) self);
}

static void
terminal_terminal_connect_signals (TerminalTerminal* self)
{
	GtkEventControllerKey* kpcontroller = NULL;
	GtkEventControllerKey* _tmp0_;
	GtkEventController* _tmp1_;
	GtkGestureClick* left_click_controller = NULL;
	GtkGestureClick* _tmp2_ = NULL;
	GtkEventController* _tmp3_;
	TerminalSettings* _tmp4_;
	TerminalSettings* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
	kpcontroller = _tmp0_;
	g_signal_connect_object (kpcontroller, "key-pressed", (GCallback) _terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
	_tmp1_ = _g_object_ref0 ((GtkEventController*) kpcontroller);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
	_tmp2_ = (GtkGestureClick*) gtk_gesture_click_new ();
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp2_, (guint) GDK_BUTTON_PRIMARY);
	left_click_controller = _tmp2_;
	g_signal_connect_object (left_click_controller, "pressed", (GCallback) ___lambda11__gtk_gesture_click_pressed, self, 0);
	_tmp3_ = _g_object_ref0 ((GtkEventController*) left_click_controller);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp3_);
	_tmp4_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::scrollback-lines", (GCallback) ___lambda12__g_object_notify, self, 0);
	_tmp5_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::scrollback-mode", (GCallback) ___lambda13__g_object_notify, self, 0);
	_g_object_unref0 (left_click_controller);
	_g_object_unref0 (kpcontroller);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
	self = *((gchar**) data);
	_g_free0_ (self);
}

static void
__lambda14_ (TerminalTerminal* self,
             VteTerminal* _,
             GPid pid,
             GError* _error_)
{
	g_return_if_fail (_ != NULL);
	if (_error_ == NULL) {
		terminal_terminal_set_pid (self, pid);
		terminal_terminal_on_spawn_finished (self);
	} else {
		const gchar* _tmp0_;
		_tmp0_ = _error_->message;
		g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL], 0, _tmp0_);
	}
}

static void
___lambda14__vte_terminal_spawn_async_callback (VteTerminal* terminal,
                                                GPid pid,
                                                GError* _error_,
                                                gpointer self)
{
	__lambda14_ ((TerminalTerminal*) self, terminal, pid, _error_);
	g_object_unref (self);
}

static void
terminal_terminal_spawn (TerminalTerminal* self,
                         const gchar* command,
                         const gchar* cwd,
                         GError** error)
{
	GArray* argv = NULL;
	GArray* _tmp0_;
	GArray* envv = NULL;
	GArray* _tmp1_;
	VtePtyFlags flags = 0U;
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp2_;
	gchar** custom_shell_commandv = NULL;
	gint custom_shell_commandv_length1;
	gint _custom_shell_commandv_size_;
	gchar* shell = NULL;
	gboolean _tmp3_ = FALSE;
	TerminalSettings* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gchar** tmp_envv = NULL;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint tmp_envv_length1;
	gint _tmp_envv_size_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar** _tmp22_;
	gint _tmp22__length1;
	GArray* _tmp26_;
	gpointer* _tmp27_;
	gint _tmp27__length1;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	GArray* _tmp48_;
	gpointer* _tmp49_;
	gint _tmp49__length1;
	GArray* _tmp50_;
	gpointer* _tmp51_;
	gint _tmp51__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gchar_free_function_content_of);
	argv = _tmp0_;
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_gchar_free_function_content_of);
	envv = _tmp1_;
	flags = VTE_PTY_DEFAULT;
	_tmp2_ = terminal_settings_get_default ();
	settings = _tmp2_;
	custom_shell_commandv = NULL;
	custom_shell_commandv_length1 = 0;
	_custom_shell_commandv_size_ = custom_shell_commandv_length1;
	_tmp4_ = settings;
	_tmp5_ = terminal_settings_get_use_custom_command (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		TerminalSettings* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp7_ = settings;
		_tmp8_ = terminal_settings_get_custom_shell_command (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp3_ = g_strcmp0 (_tmp9_, "") != 0;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		TerminalSettings* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar** _tmp13_ = NULL;
		gint _tmp14_ = 0;
		_tmp10_ = settings;
		_tmp11_ = terminal_settings_get_custom_shell_command (_tmp10_);
		_tmp12_ = _tmp11_;
		g_shell_parse_argv (_tmp12_, &_tmp14_, &_tmp13_, &_inner_error0_);
		custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
		custom_shell_commandv = _tmp13_;
		custom_shell_commandv_length1 = _tmp14_;
		_custom_shell_commandv_size_ = custom_shell_commandv_length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (shell);
			custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
			_g_object_unref0 (settings);
			_g_array_unref0 (envv);
			_g_array_unref0 (argv);
			return;
		}
	}
	_tmp16_ = _tmp15_ = g_get_environ ();
	tmp_envv = _tmp16_;
	tmp_envv_length1 = _vala_array_length (_tmp15_);
	_tmp_envv_size_ = tmp_envv_length1;
	_tmp17_ = tmp_envv;
	_tmp17__length1 = tmp_envv_length1;
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
		env_collection = _tmp17_;
		env_collection_length1 = _tmp17__length1;
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
			gchar* _tmp18_;
			gchar* env = NULL;
			_tmp18_ = g_strdup (env_collection[env_it]);
			env = _tmp18_;
			{
				GArray* _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
				_tmp19_ = envv;
				_tmp20_ = env;
				_tmp21_ = g_strdup (_tmp20_);
				g_array_append_val (_tmp19_, _tmp21_);
				_g_free0 (env);
			}
		}
	}
	_tmp22_ = terminal_terminal_blackbox_envv;
	_tmp22__length1 = terminal_terminal_blackbox_envv_length1;
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
		env_collection = _tmp22_;
		env_collection_length1 = _tmp22__length1;
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
			const gchar* env = NULL;
			env = env_collection[env_it];
			{
				GArray* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				_tmp23_ = envv;
				_tmp24_ = env;
				_tmp25_ = g_strdup (_tmp24_);
				g_array_append_val (_tmp23_, _tmp25_);
			}
		}
	}
	_tmp26_ = envv;
	_tmp27_ = _tmp26_->data;
	_tmp27__length1 = _tmp26_->len;
	_tmp28_ = g_environ_getenv (_tmp27_, "SHELL");
	_tmp29_ = g_strdup (_tmp28_);
	_g_free0 (shell);
	shell = _tmp29_;
	_tmp30_ = custom_shell_commandv;
	_tmp30__length1 = custom_shell_commandv_length1;
	if (_tmp30_ != NULL) {
		gchar** _tmp31_;
		gint _tmp31__length1;
		_tmp31_ = custom_shell_commandv;
		_tmp31__length1 = custom_shell_commandv_length1;
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
			s_collection = _tmp31_;
			s_collection_length1 = _tmp31__length1;
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
				const gchar* s = NULL;
				s = s_collection[s_it];
				{
					GArray* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_;
					_tmp32_ = argv;
					_tmp33_ = s;
					_tmp34_ = g_strdup (_tmp33_);
					g_array_append_val (_tmp32_, _tmp34_);
				}
			}
		}
	} else {
		GArray* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gboolean _tmp38_ = FALSE;
		TerminalSettings* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
		_tmp35_ = argv;
		_tmp36_ = shell;
		_tmp37_ = g_strdup (_tmp36_);
		g_array_append_val (_tmp35_, _tmp37_);
		_tmp39_ = settings;
		_tmp40_ = terminal_settings_get_command_as_login_shell (_tmp39_);
		_tmp41_ = _tmp40_;
		if (_tmp41_) {
			_tmp38_ = command == NULL;
		} else {
			_tmp38_ = FALSE;
		}
		if (_tmp38_) {
			GArray* _tmp42_;
			gchar* _tmp43_;
			_tmp42_ = argv;
			_tmp43_ = g_strdup ("--login");
			g_array_append_val (_tmp42_, _tmp43_);
		}
	}
	if (command != NULL) {
		GArray* _tmp44_;
		gchar* _tmp45_;
		GArray* _tmp46_;
		gchar* _tmp47_;
		_tmp44_ = argv;
		_tmp45_ = g_strdup ("-c");
		g_array_append_val (_tmp44_, _tmp45_);
		_tmp46_ = argv;
		_tmp47_ = g_strdup (command);
		g_array_append_val (_tmp46_, _tmp47_);
	}
	_tmp48_ = argv;
	_tmp49_ = _tmp48_->data;
	_tmp49__length1 = _tmp48_->len;
	_tmp50_ = envv;
	_tmp51_ = _tmp50_->data;
	_tmp51__length1 = _tmp50_->len;
	vte_terminal_spawn_async ((VteTerminal*) self, flags, cwd, _tmp49_, _tmp51_, 0, NULL, NULL, NULL, -1, NULL, ___lambda14__vte_terminal_spawn_async_callback, g_object_ref (self));
	tmp_envv = (_vala_array_free (tmp_envv, tmp_envv_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (shell);
	custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (settings);
	_g_array_unref0 (envv);
	_g_array_unref0 (argv);
}

static void
__lambda15_ (TerminalTerminal* self,
             TerminalProcess* _process)
{
	gboolean desktop_notifications_enabled = FALSE;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (_process != NULL);
	_tmp0_ = terminal_settings_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = terminal_settings_get_notify_process_completion (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	desktop_notifications_enabled = _tmp4_;
	if (desktop_notifications_enabled) {
		gboolean _tmp7_;
		gboolean _tmp8_;
		g_object_get ((GtkWidget*) self, "has-focus", &_tmp7_, NULL);
		_tmp8_ = _tmp7_;
		_tmp6_ = !_tmp8_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = terminal_process_get_last_foreground_task_command (_process);
		_tmp10_ = _tmp9_;
		_tmp5_ = _tmp10_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		GNotification* n = NULL;
		GNotification* _tmp11_;
		GNotification* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		TerminalWindow* _tmp15_;
		GtkApplication* _tmp16_;
		GtkApplication* _tmp17_;
		GNotification* _tmp18_;
		GApplication* _tmp19_;
		GNotification* _tmp20_;
		_tmp11_ = g_notification_new (_ ("Command completed"));
		n = _tmp11_;
		_tmp12_ = n;
		_tmp13_ = terminal_process_get_last_foreground_task_command (_process);
		_tmp14_ = _tmp13_;
		g_notification_set_body (_tmp12_, _tmp14_);
		_tmp15_ = self->window;
		_tmp16_ = gtk_window_get_application ((GtkWindow*) _tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = n;
		g_application_send_notification ((GApplication*) _tmp17_, NULL, _tmp18_);
		_tmp19_ = g_application_get_default ();
		_tmp20_ = n;
		g_application_send_notification (_tmp19_, NULL, _tmp20_);
		_g_object_unref0 (n);
	}
}

static void
___lambda15__terminal_process_foreground_task_finished (TerminalProcess* _sender,
                                                        gpointer self)
{
	__lambda15_ ((TerminalTerminal*) self, _sender);
}

static TerminalProcessContext*
_terminal_process_context_dup (TerminalProcessContext* self)
{
	TerminalProcessContext* dup;
	dup = g_new0 (TerminalProcessContext, 1);
	memcpy (dup, self, sizeof (TerminalProcessContext));
	return dup;
}

static gpointer
__terminal_process_context_dup0 (gpointer self)
{
	return self ? _terminal_process_context_dup (self) : NULL;
}

static void
__lambda16_ (TerminalTerminal* self,
             GObject* __process,
             GParamSpec* spec)
{
	TerminalProcess* _tmp0_ = NULL;
	TerminalProcess* _tmp1_;
	TerminalProcessContext* _tmp2_ = NULL;
	TerminalProcessContext* _tmp6_ = NULL;
	TerminalProcessContext* _tmp7_;
	TerminalProcessContext* context = NULL;
	TerminalProcessContext* _tmp10_;
	g_return_if_fail (__process != NULL);
	g_return_if_fail (spec != NULL);
	_tmp1_ = self->priv->_process;
	_tmp0_ = TERMINAL_IS_PROCESS (_tmp1_) ? ((TerminalProcess*) _tmp1_) : NULL;
	_tmp2_ = NULL;
	if (_tmp0_ != NULL) {
		TerminalProcessContext _tmp3_;
		TerminalProcessContext _tmp4_;
		TerminalProcessContext* _tmp5_;
		_tmp3_ = terminal_process_get_context (_tmp0_);
		_tmp4_ = _tmp3_;
		_tmp5_ = __terminal_process_context_dup0 (&_tmp4_);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp5_;
	}
	_tmp7_ = _tmp2_;
	_tmp2_ = NULL;
	_tmp6_ = _tmp7_;
	if (_tmp6_ == NULL) {
		TerminalProcessContext _tmp8_;
		TerminalProcessContext* _tmp9_;
		_tmp8_ = TERMINAL_PROCESS_CONTEXT_DEFAULT;
		_tmp9_ = __terminal_process_context_dup0 (&_tmp8_);
		_g_free0 (_tmp6_);
		_tmp6_ = _tmp9_;
	}
	_tmp10_ = _tmp6_;
	_tmp6_ = NULL;
	context = _tmp10_;
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL], 0, *context);
	_g_free0 (context);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp2_);
}

static void
___lambda16__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda16_ ((TerminalTerminal*) self, _sender, pspec);
}

static void
terminal_terminal_on_spawn_finished (TerminalTerminal* self)
{
	VtePty* _tmp0_;
	VtePty* _tmp1_;
	GPid _tmp2_;
	TerminalProcess* _tmp3_ = NULL;
	TerminalProcess* _tmp4_;
	TerminalProcess* _tmp5_;
	TerminalProcess* _tmp6_;
	TerminalProcessWatcher* _tmp7_;
	TerminalProcessWatcher* _tmp8_;
	TerminalProcess* _tmp9_;
	TerminalProcess* _tmp10_;
	TerminalProcessContext _tmp11_;
	TerminalProcessContext _tmp12_;
	g_return_if_fail (self != NULL);
	if (self->priv->_pid < ((GPid) 0)) {
		return;
	}
	_tmp0_ = vte_terminal_get_pty ((VteTerminal*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_pid;
	_tmp3_ = terminal_process_new ();
	terminal_process_set_terminal_fd (_tmp3_, vte_pty_get_fd (_tmp1_));
	terminal_process_set_pid (_tmp3_, _tmp2_);
	terminal_process_set_foreground_pid (_tmp3_, (GPid) -1);
	_tmp4_ = _tmp3_;
	terminal_terminal_set_process (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->_process;
	g_signal_connect_object (_tmp5_, "foreground-task-finished", (GCallback) ___lambda15__terminal_process_foreground_task_finished, self, 0);
	_tmp6_ = self->priv->_process;
	g_signal_connect_object ((GObject*) _tmp6_, "notify::context", (GCallback) ___lambda16__g_object_notify, self, 0);
	_tmp7_ = terminal_process_watcher_get_instance ();
	_tmp8_ = _tmp7_;
	_tmp9_ = self->priv->_process;
	terminal_process_watcher_watch (_tmp8_, _tmp9_);
	_g_object_unref0 (_tmp8_);
	_tmp10_ = self->priv->_process;
	_tmp11_ = terminal_process_get_context (_tmp10_);
	_tmp12_ = _tmp11_;
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL], 0, _tmp12_);
}

static void
terminal_terminal_spawn_on_flatpak_data_free (gpointer _data)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
	_data_ = _data;
	_g_free0 (_data_->cwd);
	_g_array_unref0 (_data_->argv);
	_g_array_unref0 (_data_->envv);
	_g_object_unref0 (_data_->self);
	g_slice_free (TerminalTerminalSpawnOnFlatpakData, _data_);
}

static gpointer
_g_array_ref0 (gpointer self)
{
	return self ? g_array_ref (self) : NULL;
}

static void
terminal_terminal_spawn_on_flatpak (TerminalTerminal* self,
                                    VtePtyFlags flags,
                                    const gchar* cwd,
                                    GArray* argv,
                                    GArray* envv,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
	TerminalTerminal* _tmp0_;
	gchar* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (argv != NULL);
	g_return_if_fail (envv != NULL);
	_data_ = g_slice_new0 (TerminalTerminalSpawnOnFlatpakData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_spawn_on_flatpak_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->flags = flags;
	_tmp1_ = g_strdup (cwd);
	_g_free0 (_data_->cwd);
	_data_->cwd = _tmp1_;
	_tmp2_ = _g_array_ref0 (argv);
	_g_array_unref0 (_data_->argv);
	_data_->argv = _tmp2_;
	_tmp3_ = _g_array_ref0 (envv);
	_g_array_unref0 (_data_->envv);
	_data_->envv = _tmp3_;
	terminal_terminal_spawn_on_flatpak_co (_data_);
}

static gboolean
terminal_terminal_spawn_on_flatpak_finish (TerminalTerminal* self,
                                           GAsyncResult* _res_,
                                           GPid* p,
                                           GError** error)
{
	gboolean result;
	TerminalTerminalSpawnOnFlatpakData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	if (p) {
		*p = _data_->p;
	}
	result = _data_->result;
	return result;
}

static void
_vala_array_add3 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add4 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add5 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback (guint pid,
                                                                                 guint status,
                                                                                 gpointer self)
{
	terminal_terminal_on_host_command_exited ((TerminalTerminal*) self, pid, status);
}

static void
terminal_terminal_spawn_on_flatpak_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	terminal_terminal_spawn_on_flatpak_co (_data_);
}

static gboolean
terminal_terminal_spawn_on_flatpak_co (TerminalTerminalSpawnOnFlatpakData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->p = (GPid) -1;
	{
		_data_->_tmp1_ = vte_pty_new_sync (_data_->flags, NULL, &_data_->_inner_error0_);
		_data_->_tmp0_ = _data_->_tmp1_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp2_ = _data_->_tmp0_;
		_data_->_tmp0_ = NULL;
		_g_object_unref0 (_data_->_ppty);
		_data_->_ppty = _data_->_tmp2_;
		_g_object_unref0 (_data_->_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp3_ = _data_->e;
		_data_->_tmp4_ = _data_->_tmp3_->message;
		g_warning ("Terminal.vala:549: %s", _data_->_tmp4_);
		_data_->result = FALSE;
		_g_error_free0 (_data_->e);
		_g_object_unref0 (_data_->_ppty);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_object_unref0 (_data_->_ppty);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp5_ = _data_->_ppty;
	_data_->pty_master = vte_pty_get_fd (_data_->_tmp5_);
	if (grantpt (_data_->pty_master) != 0) {
		g_warning ("Terminal.vala:556: Failed granting access to slave pseudoterminal devi" \
"ce");
		_data_->result = FALSE;
		_g_object_unref0 (_data_->_ppty);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (unlockpt (_data_->pty_master) != 0) {
		g_warning ("Terminal.vala:561: Failed unlocking slave pseudoterminal device");
		_data_->result = FALSE;
		_g_object_unref0 (_data_->_ppty);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp6_ = g_new0 (gint, 0);
	_data_->pty_slaves = _data_->_tmp6_;
	_data_->pty_slaves_length1 = 0;
	_data_->_pty_slaves_size_ = _data_->pty_slaves_length1;
	_data_->_tmp7_ = ptsname (_data_->pty_master);
	_vala_array_add3 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, open (_data_->_tmp7_, O_RDWR | O_CLOEXEC, (mode_t) 0));
	_data_->_tmp8_ = _data_->pty_slaves;
	_data_->_tmp8__length1 = _data_->pty_slaves_length1;
	_data_->_tmp9_ = _data_->_tmp8_[0];
	if (_data_->_tmp9_ < 0) {
		g_warning ("Terminal.vala:570: Failed opening slave pseudoterminal device");
		_data_->result = FALSE;
		_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
		_g_object_unref0 (_data_->_ppty);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp10_ = _data_->pty_slaves;
	_data_->_tmp10__length1 = _data_->pty_slaves_length1;
	_data_->_tmp11_ = _data_->_tmp10_[0];
	_vala_array_add4 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, dup (_data_->_tmp11_));
	_data_->_tmp12_ = _data_->pty_slaves;
	_data_->_tmp12__length1 = _data_->pty_slaves_length1;
	_data_->_tmp13_ = _data_->_tmp12_[0];
	_vala_array_add5 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, dup (_data_->_tmp13_));
	_data_->_tmp14_ = g_cancellable_new ();
	_g_object_unref0 (_data_->self->priv->fp_spawn_host_command_callback_cancellable);
	_data_->self->priv->fp_spawn_host_command_callback_cancellable = _data_->_tmp14_;
	_data_->_tmp15_ = _data_->pty_slaves;
	_data_->_tmp15__length1 = _data_->pty_slaves_length1;
	_data_->_tmp16_ = _data_->self->priv->fp_spawn_host_command_callback_cancellable;
	_data_->_tmp17_ = 0;
	_data_->_state_ = 1;
	terminal_send_host_command (_data_->cwd, _data_->argv, _data_->envv, _data_->_tmp15_, (gint) _data_->_tmp15__length1, _terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback, _data_->self, _data_->_tmp16_, terminal_terminal_spawn_on_flatpak_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp18_ = terminal_send_host_command_finish (_data_->_res_, &_data_->_tmp17_, &_data_->_inner_error0_);
	_data_->p = (GPid) _data_->_tmp17_;
	_data_->res = _data_->_tmp18_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
		_g_object_unref0 (_data_->_ppty);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp19_ = _data_->_ppty;
	vte_terminal_set_pty ((VteTerminal*) _data_->self, _data_->_tmp19_);
	_data_->result = _data_->res;
	_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
	_g_object_unref0 (_data_->_ppty);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
terminal_terminal_on_host_command_exited (TerminalTerminal* self,
                                          guint _pid,
                                          guint status)
{
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name ((VteTerminal*) self, "child-exited", (gint) status);
}

static void
terminal_terminal_on_child_exited (TerminalTerminal* self,
                                   gint status)
{
	g_return_if_fail (self != NULL);
	g_debug ("Terminal.vala:601: Child exited with code %d", status);
	terminal_terminal_set_pid (self, (GPid) -1);
	terminal_terminal_set_process (self, NULL);
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_EXIT_SIGNAL], 0);
}

static gboolean
terminal_terminal_on_key_pressed (TerminalTerminal* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if ((state & GDK_CONTROL_MASK) == 0) {
		result = FALSE;
		return result;
	}
	_tmp0_ = gdk_keyval_name (keyval);
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("c")))) {
		switch (0) {
			default:
			{
				{
					gboolean _tmp4_ = FALSE;
					if (vte_terminal_get_has_selection ((VteTerminal*) self)) {
						TerminalSettings* _tmp5_;
						TerminalSettings* _tmp6_;
						gboolean _tmp7_;
						gboolean _tmp8_;
						_tmp5_ = terminal_settings_get_default ();
						_tmp6_ = _tmp5_;
						_tmp7_ = terminal_settings_get_easy_copy_paste (_tmp6_);
						_tmp8_ = _tmp7_;
						_tmp4_ = _tmp8_;
						_g_object_unref0 (_tmp6_);
					} else {
						_tmp4_ = FALSE;
					}
					if (_tmp4_) {
						terminal_terminal_do_copy_clipboard (self);
						vte_terminal_unselect_all ((VteTerminal*) self);
						result = TRUE;
						return result;
					}
					result = FALSE;
					return result;
				}
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("v")))) {
		switch (0) {
			default:
			{
				{
					TerminalSettings* _tmp9_;
					TerminalSettings* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
					_tmp9_ = terminal_settings_get_default ();
					_tmp10_ = _tmp9_;
					_tmp11_ = terminal_settings_get_easy_copy_paste (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp13_ = _tmp12_;
					_g_object_unref0 (_tmp10_);
					if (_tmp13_) {
						terminal_terminal_do_paste_clipboard (self);
						result = TRUE;
						return result;
					}
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

static void
terminal_terminal_get_can_close_data_free (gpointer _data)
{
	TerminalTerminalGetCanCloseData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (TerminalTerminalGetCanCloseData, _data_);
}

void
terminal_terminal_get_can_close (TerminalTerminal* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	TerminalTerminalGetCanCloseData* _data_;
	TerminalTerminal* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (TerminalTerminalGetCanCloseData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_get_can_close_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	terminal_terminal_get_can_close_co (_data_);
}

gboolean
terminal_terminal_get_can_close_finish (TerminalTerminal* self,
                                        GAsyncResult* _res_,
                                        gchar** command)
{
	gboolean result;
	TerminalTerminalGetCanCloseData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (command) {
		*command = _data_->command;
	} else {
		_g_free0 (_data_->command);
	}
	_data_->command = NULL;
	result = _data_->result;
	return result;
}

static void
terminal_terminal_get_can_close_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	TerminalTerminalGetCanCloseData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	terminal_terminal_get_can_close_co (_data_);
}

static gboolean
terminal_terminal_get_can_close_co (TerminalTerminalGetCanCloseData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_g_free0 (_data_->command);
	_data_->command = NULL;
	_data_->_tmp1_ = _data_->self->priv->_pid;
	if (_data_->_tmp1_ < ((GPid) 0)) {
		_data_->_tmp0_ = TRUE;
	} else {
		_data_->_tmp2_ = vte_terminal_get_pty ((VteTerminal*) _data_->self);
		_data_->_tmp3_ = _data_->_tmp2_;
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
	}
	if (_data_->_tmp0_) {
		_data_->result = TRUE;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp4_ = vte_terminal_get_pty ((VteTerminal*) _data_->self);
	_data_->_tmp5_ = _data_->_tmp4_;
	_data_->_tmp6_ = vte_pty_get_fd (_data_->_tmp5_);
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->fd = _data_->_tmp7_;
	if (_data_->fd == -1) {
		_data_->result = TRUE;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_state_ = 1;
	terminal_get_foreground_process (_data_->fd, NULL, terminal_terminal_get_can_close_ready, _data_);
	return FALSE;
	_state_1:
	_data_->fgpid = terminal_get_foreground_process_finish (_data_->_res_);
	if (_data_->fgpid == -1) {
		_data_->result = FALSE;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp8_ = _data_->self->priv->_pid;
	if (_data_->fgpid == ((gint) _data_->_tmp8_)) {
		_data_->result = TRUE;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp9_ = terminal_get_process_cmdline (_data_->fgpid);
	_g_free0 (_data_->command);
	_data_->command = _data_->_tmp9_;
	_data_->_tmp10_ = _data_->command;
	_data_->result = _data_->_tmp10_ == NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
terminal_terminal_zoom_in (TerminalTerminal* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
	_tmp1_ = _tmp0_;
	vte_terminal_set_font_scale ((VteTerminal*) self, MIN ((gdouble) 10, _tmp1_ + 0.1));
}

void
terminal_terminal_zoom_out (TerminalTerminal* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
	_tmp1_ = _tmp0_;
	vte_terminal_set_font_scale ((VteTerminal*) self, MAX (0.1, _tmp1_ - 0.1));
}

void
terminal_terminal_zoom_default (TerminalTerminal* self)
{
	g_return_if_fail (self != NULL);
	vte_terminal_set_font_scale ((VteTerminal*) self, 1.0);
}

void
terminal_terminal_do_paste_clipboard (TerminalTerminal* self)
{
	g_return_if_fail (self != NULL);
	vte_terminal_paste_clipboard ((VteTerminal*) self);
}

void
terminal_terminal_do_copy_clipboard (TerminalTerminal* self)
{
	g_return_if_fail (self != NULL);
	vte_terminal_copy_clipboard ((VteTerminal*) self);
}

static void
terminal_terminal_do_paste_from_selection_clipboard_data_free (gpointer _data)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (TerminalTerminalDoPasteFromSelectionClipboardData, _data_);
}

void
terminal_terminal_do_paste_from_selection_clipboard (TerminalTerminal* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	TerminalTerminal* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (TerminalTerminalDoPasteFromSelectionClipboardData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_do_paste_from_selection_clipboard_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	terminal_terminal_do_paste_from_selection_clipboard_co (_data_);
}

void
terminal_terminal_do_paste_from_selection_clipboard_finish (TerminalTerminal* self,
                                                            GAsyncResult* _res_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
terminal_terminal_do_paste_from_selection_clipboard_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	terminal_terminal_do_paste_from_selection_clipboard_co (_data_);
}

static gboolean
terminal_terminal_do_paste_from_selection_clipboard_co (TerminalTerminalDoPasteFromSelectionClipboardData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gdk_display_get_default ();
	_data_->_tmp1_ = gdk_display_get_primary_clipboard (_data_->_tmp0_);
	_data_->_tmp2_ = _g_object_ref0 (_data_->_tmp1_);
	_data_->clipboard = _data_->_tmp2_;
	{
		_data_->_state_ = 1;
		gdk_clipboard_read_text_async (_data_->clipboard, NULL, terminal_terminal_do_paste_from_selection_clipboard_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp3_ = gdk_clipboard_read_text_finish (_data_->clipboard, _data_->_res_, &_data_->_inner_error0_);
		_data_->text = _data_->_tmp3_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		vte_terminal_paste_text ((VteTerminal*) _data_->self, _data_->text);
		_g_free0 (_data_->text);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp4_ = _data_->e;
		_data_->_tmp5_ = _data_->_tmp4_->message;
		g_warning ("Terminal.vala:700: %s", _data_->_tmp5_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->clipboard);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_object_unref0 (_data_->clipboard);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

gchar*
terminal_terminal_get_current_working_directory (TerminalTerminal* self)
{
	gchar* cwd = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = vte_terminal_get_current_directory_uri ((VteTerminal*) self);
	_tmp1_ = g_strdup (_tmp0_);
	cwd = _tmp1_;
	_tmp2_ = cwd;
	if (_tmp2_ != NULL) {
		{
			gchar* path = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp3_ = cwd;
			_tmp4_ = g_filename_from_uri (_tmp3_, NULL, &_inner_error0_);
			path = _tmp4_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_CONVERT_ERROR) {
					goto __catch0_g_convert_error;
				}
				_g_free0 (cwd);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp5_ = path;
			_tmp6_ = g_strdup (_tmp5_);
			_g_free0 (cwd);
			cwd = _tmp6_;
			_g_free0 (path);
		}
		goto __finally0;
		__catch0_g_convert_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_warning ("Terminal.vala:713: %s", _tmp8_);
			_g_free0 (cwd);
			cwd = NULL;
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (cwd);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = cwd;
	return result;
}

gchar*
terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal)
{
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	guint mode = 0U;
	TerminalSettings* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* custom_working_directory = NULL;
	TerminalSettings* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
	_tmp0_ = terminal_settings_get_default ();
	settings = _tmp0_;
	_tmp1_ = settings;
	_tmp2_ = terminal_settings_get_working_directory_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	mode = _tmp3_;
	_tmp4_ = settings;
	_tmp5_ = terminal_settings_get_custom_working_directory (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup (_tmp6_);
	custom_working_directory = _tmp7_;
	switch (mode) {
		case TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM:
		{
			result = custom_working_directory;
			_g_object_unref0 (settings);
			return result;
		}
		case TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY:
		{
			const gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp8_ = g_get_home_dir ();
			_tmp9_ = g_strdup (_tmp8_);
			result = _tmp9_;
			_g_free0 (custom_working_directory);
			_g_object_unref0 (settings);
			return result;
		}
		case TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION:
		{
			{
				if (previous_terminal != NULL) {
					gchar* _tmp10_;
					_tmp10_ = terminal_terminal_get_current_working_directory (previous_terminal);
					result = _tmp10_;
					_g_free0 (custom_working_directory);
					_g_object_unref0 (settings);
					return result;
				}
				break;
			}
		}
		default:
		break;
	}
	result = NULL;
	_g_free0 (custom_working_directory);
	_g_object_unref0 (settings);
	return result;
}

TerminalScheme*
terminal_terminal_get_scheme (TerminalTerminal* self)
{
	TerminalScheme* result;
	TerminalScheme* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_scheme;
	result = _tmp0_;
	return result;
}

void
terminal_terminal_set_scheme (TerminalTerminal* self,
                              TerminalScheme* value)
{
	TerminalScheme* old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_terminal_get_scheme (self);
	if (old_value != value) {
		TerminalScheme* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_scheme);
		self->priv->_scheme = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_SCHEME_PROPERTY]);
	}
}

GPid
terminal_terminal_get_pid (TerminalTerminal* self)
{
	GPid result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_pid;
	return result;
}

void
terminal_terminal_set_pid (TerminalTerminal* self,
                           GPid value)
{
	GPid old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_terminal_get_pid (self);
	if (old_value != value) {
		self->priv->_pid = value;
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_PID_PROPERTY]);
	}
}

TerminalProcess*
terminal_terminal_get_process (TerminalTerminal* self)
{
	TerminalProcess* result;
	TerminalProcess* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_process;
	result = _tmp0_;
	return result;
}

void
terminal_terminal_set_process (TerminalTerminal* self,
                               TerminalProcess* value)
{
	TerminalProcess* old_value;
	g_return_if_fail (self != NULL);
	old_value = terminal_terminal_get_process (self);
	if (old_value != value) {
		TerminalProcess* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_process);
		self->priv->_process = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_PROCESS_PROPERTY]);
	}
}

guint
terminal_terminal_get_user_scrollback_lines (TerminalTerminal* self)
{
	guint result;
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = terminal_settings_get_default ();
	settings = _tmp0_;
	_tmp1_ = settings;
	_tmp2_ = terminal_settings_get_scrollback_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	switch (_tmp3_) {
		case TERMINAL_SCROLLBACK_MODE_FIXED:
		{
			TerminalSettings* _tmp4_;
			guint _tmp5_;
			guint _tmp6_;
			_tmp4_ = settings;
			_tmp5_ = terminal_settings_get_scrollback_lines (_tmp4_);
			_tmp6_ = _tmp5_;
			result = _tmp6_;
			_g_object_unref0 (settings);
			return result;
		}
		case TERMINAL_SCROLLBACK_MODE_UNLIMITED:
		{
			result = (guint) -1;
			_g_object_unref0 (settings);
			return result;
		}
		case TERMINAL_SCROLLBACK_MODE_DISABLED:
		{
			result = (guint) 0;
			_g_object_unref0 (settings);
			return result;
		}
		default:
		{
			TerminalSettings* _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
			_tmp7_ = settings;
			_tmp8_ = terminal_settings_get_scrollback_mode (_tmp7_);
			_tmp9_ = _tmp8_;
			g_error ("Terminal.vala:69: Invalid scrollback-mode %u", _tmp9_);
		}
	}
}

static void
terminal_terminal_class_init (TerminalTerminalClass * klass,
                              gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	terminal_terminal_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminalTerminal_private_offset);
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) terminal_terminal_real_dispose;
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_terminal_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_terminal_set_property;
	G_OBJECT_CLASS (klass)->finalize = terminal_terminal_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_SCHEME_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_SCHEME_PROPERTY] = g_param_spec_object ("scheme", "scheme", "scheme", TERMINAL_TYPE_SCHEME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_PID_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, (GPid) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_PROCESS_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_PROCESS_PROPERTY] = g_param_spec_object ("process", "process", "process", TERMINAL_TYPE_PROCESS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY] = g_param_spec_uint ("user-scrollback-lines", "user-scrollback-lines", "user-scrollback-lines", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	   * This signal is emitted when the terminal process exits. Something should
	   * listen for this signal and close the tab that contains this terminal.
	   */
	terminal_terminal_signals[TERMINAL_TERMINAL_EXIT_SIGNAL] = g_signal_new ("exit", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	terminal_terminal_signals[TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL] = g_signal_new ("spawn-failed", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL] = g_signal_new ("context-changed", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, TERMINAL_TYPE_PROCESS_CONTEXT);
	_tmp0_ = g_strdup ("TERM=xterm-256color");
	_tmp1_ = g_strdup ("COLORTERM=truecolor");
	_tmp2_ = g_strdup_printf ("TERM_PROGRAM=%s", TERMINAL_APP_NAME);
	_tmp3_ = terminal_constants_get_user_schemes_dir ();
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf ("BLACKBOX_THEMES_DIR=%s", _tmp4_);
	_tmp6_ = g_strdup_printf ("VTE_VERSION=%u", (guint) (((VTE_MAJOR_VERSION * 10000) + (VTE_MINOR_VERSION * 100)) + VTE_MICRO_VERSION));
	_tmp7_ = g_new0 (gchar*, 5 + 1);
	_tmp7_[0] = _tmp0_;
	_tmp7_[1] = _tmp1_;
	_tmp7_[2] = _tmp2_;
	_tmp7_[3] = _tmp5_;
	_tmp7_[4] = _tmp6_;
	terminal_terminal_blackbox_envv = _tmp7_;
	terminal_terminal_blackbox_envv_length1 = 5;
	_terminal_terminal_blackbox_envv_size_ = terminal_terminal_blackbox_envv_length1;
}

static void
terminal_terminal_instance_init (TerminalTerminal * self,
                                 gpointer klass)
{
	self->priv = terminal_terminal_get_instance_private (self);
	self->priv->_pid = (GPid) -1;
	self->priv->_process = NULL;
	self->priv->fp_spawn_host_command_callback_cancellable = NULL;
	self->priv->padding_provider = NULL;
}

static void
terminal_terminal_finalize (GObject * obj)
{
	TerminalTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
	_g_object_unref0 (self->priv->_scheme);
	_g_object_unref0 (self->priv->_process);
	_g_object_unref0 (self->window);
	_g_object_unref0 (self->priv->fp_spawn_host_command_callback_cancellable);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->padding_provider);
	G_OBJECT_CLASS (terminal_terminal_parent_class)->finalize (obj);
}

static GType
terminal_terminal_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalTerminalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_terminal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalTerminal), 0, (GInstanceInitFunc) terminal_terminal_instance_init, NULL };
	GType terminal_terminal_type_id;
	terminal_terminal_type_id = g_type_register_static (vte_terminal_get_type (), "TerminalTerminal", &g_define_type_info, 0);
	TerminalTerminal_private_offset = g_type_add_instance_private (terminal_terminal_type_id, sizeof (TerminalTerminalPrivate));
	return terminal_terminal_type_id;
}

GType
terminal_terminal_get_type (void)
{
	static volatile gsize terminal_terminal_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_type_id__once)) {
		GType terminal_terminal_type_id;
		terminal_terminal_type_id = terminal_terminal_get_type_once ();
		g_once_init_leave (&terminal_terminal_type_id__once, terminal_terminal_type_id);
	}
	return terminal_terminal_type_id__once;
}

static void
_vala_terminal_terminal_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	TerminalTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
	switch (property_id) {
		case TERMINAL_TERMINAL_SCHEME_PROPERTY:
		g_value_set_object (value, terminal_terminal_get_scheme (self));
		break;
		case TERMINAL_TERMINAL_PID_PROPERTY:
		g_value_set_int (value, terminal_terminal_get_pid (self));
		break;
		case TERMINAL_TERMINAL_PROCESS_PROPERTY:
		g_value_set_object (value, terminal_terminal_get_process (self));
		break;
		case TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY:
		g_value_set_uint (value, terminal_terminal_get_user_scrollback_lines (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_terminal_terminal_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	TerminalTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
	switch (property_id) {
		case TERMINAL_TERMINAL_SCHEME_PROPERTY:
		terminal_terminal_set_scheme (self, g_value_get_object (value));
		break;
		case TERMINAL_TERMINAL_PID_PROPERTY:
		terminal_terminal_set_pid (self, g_value_get_int (value));
		break;
		case TERMINAL_TERMINAL_PROCESS_PROPERTY:
		terminal_terminal_set_process (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

